namespace birch {
#line 1 "src/data/Buffer.birch"
#line 1 "src/data/Buffer.birch"
Buffer_::Buffer_() :
    #line 1 "src/data/Buffer.birch"
    base_type_(),
    #line 40 "src/data/Buffer.birch"
    keys(),
    #line 41 "src/data/Buffer.birch"
    values(),
    #line 42 "src/data/Buffer.birch"
    scalarString(),
    #line 43 "src/data/Buffer.birch"
    scalarReal(),
    #line 44 "src/data/Buffer.birch"
    scalarInteger(),
    #line 45 "src/data/Buffer.birch"
    scalarBoolean(),
    #line 46 "src/data/Buffer.birch"
    vectorReal(),
    #line 47 "src/data/Buffer.birch"
    vectorInteger(),
    #line 48 "src/data/Buffer.birch"
    vectorBoolean(),
    #line 49 "src/data/Buffer.birch"
    matrixReal(),
    #line 50 "src/data/Buffer.birch"
    matrixInteger(),
    #line 51 "src/data/Buffer.birch"
    matrixBoolean() {
  //
}

#line 56 "src/data/Buffer.birch"
#line 56 "src/data/Buffer.birch"
#line 56 "src/data/Buffer.birch"
Boolean Buffer_::isNil() {
  #line 57 "src/data/Buffer.birch"
  return !((keys.has_value() || values.has_value() || scalarString.has_value() || scalarReal.has_value() || scalarInteger.has_value() || scalarBoolean.has_value() || vectorReal.has_value() || vectorInteger.has_value() || vectorBoolean.has_value() || matrixReal.has_value() || matrixInteger.has_value() || matrixBoolean.has_value()));
}

#line 66 "src/data/Buffer.birch"
#line 66 "src/data/Buffer.birch"
#line 66 "src/data/Buffer.birch"
Boolean Buffer_::isNil(const String& key) {
  auto buffer = get(key);
  #line 68 "src/data/Buffer.birch"
  if (buffer.has_value()) {
    #line 69 "src/data/Buffer.birch"
    return buffer.value()->isNil();
  } else {
    #line 71 "src/data/Buffer.birch"
    return true;
  }
}

#line 78 "src/data/Buffer.birch"
#line 78 "src/data/Buffer.birch"
#line 78 "src/data/Buffer.birch"
void Buffer_::setNil() {
  #line 79 "src/data/Buffer.birch"
  keys = std::nullopt;
  #line 80 "src/data/Buffer.birch"
  values = std::nullopt;
  #line 81 "src/data/Buffer.birch"
  scalarString = std::nullopt;
  #line 82 "src/data/Buffer.birch"
  scalarReal = std::nullopt;
  #line 83 "src/data/Buffer.birch"
  scalarInteger = std::nullopt;
  #line 84 "src/data/Buffer.birch"
  scalarBoolean = std::nullopt;
  #line 85 "src/data/Buffer.birch"
  vectorReal = std::nullopt;
  #line 86 "src/data/Buffer.birch"
  vectorInteger = std::nullopt;
  #line 87 "src/data/Buffer.birch"
  vectorBoolean = std::nullopt;
  #line 88 "src/data/Buffer.birch"
  matrixReal = std::nullopt;
  #line 89 "src/data/Buffer.birch"
  matrixInteger = std::nullopt;
  #line 90 "src/data/Buffer.birch"
  matrixBoolean = std::nullopt;
}

#line 96 "src/data/Buffer.birch"
#line 96 "src/data/Buffer.birch"
#line 96 "src/data/Buffer.birch"
void Buffer_::setNil(const String& key) {
  auto value = make_buffer();
  #line 98 "src/data/Buffer.birch"
  value->setNil();
  #line 99 "src/data/Buffer.birch"
  set(key, value);
}

#line 106 "src/data/Buffer.birch"
#line 106 "src/data/Buffer.birch"
#line 106 "src/data/Buffer.birch"
Boolean Buffer_::isEmpty() {
  #line 107 "src/data/Buffer.birch"
  return isNil() || (values.has_value() && length(values.value()) == Integer(0));
}

#line 114 "src/data/Buffer.birch"
#line 114 "src/data/Buffer.birch"
#line 114 "src/data/Buffer.birch"
Boolean Buffer_::isEmpty(const String& key) {
  auto buffer = get(key);
  #line 116 "src/data/Buffer.birch"
  if (buffer.has_value()) {
    #line 117 "src/data/Buffer.birch"
    return buffer.value()->isEmpty();
  } else {
    #line 119 "src/data/Buffer.birch"
    return true;
  }
}

#line 126 "src/data/Buffer.birch"
#line 126 "src/data/Buffer.birch"
#line 126 "src/data/Buffer.birch"
void Buffer_::setEmptyObject() {
  #line 127 "src/data/Buffer.birch"
  setNil();
  libbirch::DefaultArray<String,1> keys;
  libbirch::DefaultArray<Buffer,1> values;
  #line 130 "src/data/Buffer.birch"
  this->keys = keys;
  #line 131 "src/data/Buffer.birch"
  this->values = values;
}

#line 137 "src/data/Buffer.birch"
#line 137 "src/data/Buffer.birch"
#line 137 "src/data/Buffer.birch"
void Buffer_::setEmptyObject(const String& key) {
  auto value = make_buffer();
  #line 139 "src/data/Buffer.birch"
  value->setEmptyObject();
  #line 140 "src/data/Buffer.birch"
  set(key, value);
}

#line 146 "src/data/Buffer.birch"
#line 146 "src/data/Buffer.birch"
#line 146 "src/data/Buffer.birch"
void Buffer_::setEmptyArray() {
  #line 147 "src/data/Buffer.birch"
  setNil();
  libbirch::DefaultArray<Buffer,1> values;
  #line 149 "src/data/Buffer.birch"
  this->values = values;
}

#line 155 "src/data/Buffer.birch"
#line 155 "src/data/Buffer.birch"
#line 155 "src/data/Buffer.birch"
void Buffer_::setEmptyArray(const String& key) {
  auto value = make_buffer();
  #line 157 "src/data/Buffer.birch"
  value->setEmptyArray();
  #line 158 "src/data/Buffer.birch"
  set(key, value);
}

#line 165 "src/data/Buffer.birch"
#line 165 "src/data/Buffer.birch"
#line 165 "src/data/Buffer.birch"
void Buffer_::split() {
  auto iter = walk();
  #line 167 "src/data/Buffer.birch"
  setNil();
  #line 168 "src/data/Buffer.birch"
  while (iter->hasNext()) {
    #line 169 "src/data/Buffer.birch"
    push(iter->next());
  }
  #line 171 "src/data/Buffer.birch"
  assert(isEmpty() || (!(keys.has_value()) && values.has_value()));
}

#line 181 "src/data/Buffer.birch"
#line 181 "src/data/Buffer.birch"
#line 181 "src/data/Buffer.birch"
Integer Buffer_::size() {
  #line 182 "src/data/Buffer.birch"
  if (keys.has_value() || scalarString.has_value() || scalarReal.has_value() || scalarInteger.has_value() || scalarBoolean.has_value()) {
    #line 184 "src/data/Buffer.birch"
    return Integer(1);
  } else {
    #line 185 "src/data/Buffer.birch"
    if (values.has_value()) {
      #line 186 "src/data/Buffer.birch"
      return length(values.value());
    } else {
      #line 187 "src/data/Buffer.birch"
      if (vectorReal.has_value()) {
        #line 188 "src/data/Buffer.birch"
        return length(vectorReal.value());
      } else {
        #line 189 "src/data/Buffer.birch"
        if (vectorInteger.has_value()) {
          #line 190 "src/data/Buffer.birch"
          return length(vectorInteger.value());
        } else {
          #line 191 "src/data/Buffer.birch"
          if (vectorBoolean.has_value()) {
            #line 192 "src/data/Buffer.birch"
            return length(vectorBoolean.value());
          } else {
            #line 193 "src/data/Buffer.birch"
            if (matrixReal.has_value()) {
              #line 194 "src/data/Buffer.birch"
              return rows(matrixReal.value());
            } else {
              #line 195 "src/data/Buffer.birch"
              if (matrixInteger.has_value()) {
                #line 196 "src/data/Buffer.birch"
                return rows(matrixInteger.value());
              } else {
                #line 197 "src/data/Buffer.birch"
                if (matrixBoolean.has_value()) {
                  #line 198 "src/data/Buffer.birch"
                  return rows(matrixBoolean.value());
                } else {
                  #line 200 "src/data/Buffer.birch"
                  return Integer(0);
                }
              }
            }
          }
        }
      }
    }
  }
}

#line 211 "src/data/Buffer.birch"
#line 211 "src/data/Buffer.birch"
#line 211 "src/data/Buffer.birch"
Integer Buffer_::size(const String& key) {
  auto buffer = get(key);
  #line 213 "src/data/Buffer.birch"
  if (buffer.has_value()) {
    #line 214 "src/data/Buffer.birch"
    return buffer.value()->size();
  } else {
    #line 216 "src/data/Buffer.birch"
    return Integer(0);
  }
}

#line 293 "src/data/Buffer.birch"
#line 293 "src/data/Buffer.birch"
#line 293 "src/data/Buffer.birch"
std::optional<Buffer> Buffer_::get(const String& key) {
  #line 294 "src/data/Buffer.birch"
  if (keys.has_value()) {
    #line 295 "src/data/Buffer.birch"
    for (auto i = Integer(1); i <= length(keys.value()); ++i) {
      #line 296 "src/data/Buffer.birch"
      if (keys.value()(i) == key) {
        #line 297 "src/data/Buffer.birch"
        return values.value()(i);
      }
    }
  }
  #line 301 "src/data/Buffer.birch"
  return std::nullopt;
}

#line 310 "src/data/Buffer.birch"
#line 310 "src/data/Buffer.birch"
#line 310 "src/data/Buffer.birch"
void Buffer_::set(const libbirch::DefaultArray<String,1>& keys, const libbirch::DefaultArray<Buffer,1>& values) {
  #line 311 "src/data/Buffer.birch"
  assert(length(keys) == length(values));
  #line 312 "src/data/Buffer.birch"
  setNil();
  #line 313 "src/data/Buffer.birch"
  this->keys = keys;
  #line 314 "src/data/Buffer.birch"
  this->values = values;
}

#line 346 "src/data/Buffer.birch"
#line 346 "src/data/Buffer.birch"
#line 346 "src/data/Buffer.birch"
void Buffer_::set(const String& key, const libbirch::DefaultArray<String,1>& keys, const libbirch::DefaultArray<Buffer,1>& values) {
  #line 347 "src/data/Buffer.birch"
  set(key, make_buffer(keys, values));
}

#line 386 "src/data/Buffer.birch"
#line 386 "src/data/Buffer.birch"
#line 386 "src/data/Buffer.birch"
void Buffer_::set(const String& key, const Buffer& x) {
  #line 387 "src/data/Buffer.birch"
  if (!(keys.has_value())) {
    #line 388 "src/data/Buffer.birch"
    setNil();
    #line 389 "src/data/Buffer.birch"
    keys = libbirch::make_array_from_sequence({ key });
    #line 390 "src/data/Buffer.birch"
    values = libbirch::make_array_from_sequence({ x });
  } else {
    #line 392 "src/data/Buffer.birch"
    keys = stack(keys.value(), key);
    #line 393 "src/data/Buffer.birch"
    values = stack(values.value(), x);
  }
}

#line 404 "src/data/Buffer.birch"
#line 404 "src/data/Buffer.birch"
#line 404 "src/data/Buffer.birch"
Iterator<Buffer> Buffer_::walk() {
  #line 405 "src/data/Buffer.birch"
  if (keys.has_value()) {
    #line 406 "src/data/Buffer.birch"
    return construct<ObjectBufferIterator>(keys.value(), values.value());
  } else {
    #line 407 "src/data/Buffer.birch"
    if (values.has_value()) {
      #line 408 "src/data/Buffer.birch"
      return construct<ArrayBufferIterator>(values.value());
    } else {
      #line 409 "src/data/Buffer.birch"
      if (scalarString.has_value()) {
        #line 410 "src/data/Buffer.birch"
        return construct<ScalarBufferIterator<String>>(scalarString.value());
      } else {
        #line 411 "src/data/Buffer.birch"
        if (scalarReal.has_value()) {
          #line 412 "src/data/Buffer.birch"
          return construct<ScalarBufferIterator<Real>>(scalarReal.value());
        } else {
          #line 413 "src/data/Buffer.birch"
          if (scalarInteger.has_value()) {
            #line 414 "src/data/Buffer.birch"
            return construct<ScalarBufferIterator<Integer>>(scalarInteger.value());
          } else {
            #line 415 "src/data/Buffer.birch"
            if (scalarBoolean.has_value()) {
              #line 416 "src/data/Buffer.birch"
              return construct<ScalarBufferIterator<Boolean>>(scalarBoolean.value());
            } else {
              #line 417 "src/data/Buffer.birch"
              if (vectorReal.has_value()) {
                #line 418 "src/data/Buffer.birch"
                return construct<VectorBufferIterator<Real>>(vectorReal.value());
              } else {
                #line 419 "src/data/Buffer.birch"
                if (vectorInteger.has_value()) {
                  #line 420 "src/data/Buffer.birch"
                  return construct<VectorBufferIterator<Integer>>(vectorInteger.value());
                } else {
                  #line 421 "src/data/Buffer.birch"
                  if (vectorBoolean.has_value()) {
                    #line 422 "src/data/Buffer.birch"
                    return construct<VectorBufferIterator<Boolean>>(vectorBoolean.value());
                  } else {
                    #line 423 "src/data/Buffer.birch"
                    if (matrixReal.has_value()) {
                      #line 424 "src/data/Buffer.birch"
                      return construct<MatrixBufferIterator<Real>>(matrixReal.value());
                    } else {
                      #line 425 "src/data/Buffer.birch"
                      if (matrixInteger.has_value()) {
                        #line 426 "src/data/Buffer.birch"
                        return construct<MatrixBufferIterator<Integer>>(matrixInteger.value());
                      } else {
                        #line 427 "src/data/Buffer.birch"
                        if (matrixBoolean.has_value()) {
                          #line 428 "src/data/Buffer.birch"
                          return construct<MatrixBufferIterator<Boolean>>(matrixBoolean.value());
                        } else {
                          #line 430 "src/data/Buffer.birch"
                          return EmptyIterator<Buffer>();
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}

#line 442 "src/data/Buffer.birch"
#line 442 "src/data/Buffer.birch"
#line 442 "src/data/Buffer.birch"
Iterator<Buffer> Buffer_::walk(const String& key) {
  auto buffer = get(key);
  #line 444 "src/data/Buffer.birch"
  if (buffer.has_value()) {
    #line 445 "src/data/Buffer.birch"
    return buffer.value()->walk();
  } else {
    #line 447 "src/data/Buffer.birch"
    return EmptyIterator<Buffer>();
  }
}

#line 480 "src/data/Buffer.birch"
#line 480 "src/data/Buffer.birch"
#line 480 "src/data/Buffer.birch"
void Buffer_::push(const Buffer& x) {
  #line 481 "src/data/Buffer.birch"
  if (isEmpty()) {
    #line 482 "src/data/Buffer.birch"
    keys = std::nullopt;
    #line 483 "src/data/Buffer.birch"
    values = libbirch::make_array_from_sequence({ x });
  } else {
    #line 484 "src/data/Buffer.birch"
    if (!(keys.has_value()) && values.has_value()) {
      #line 485 "src/data/Buffer.birch"
      values = stack(values.value(), x);
    } else {
      #line 487 "src/data/Buffer.birch"
      split();
      #line 488 "src/data/Buffer.birch"
      push(x);
    }
  }
}

#line 532 "src/data/Buffer.birch"
#line 532 "src/data/Buffer.birch"
#line 532 "src/data/Buffer.birch"
void Buffer_::push(const String& key, const Buffer& x) {
  auto buffer = get(key);
  #line 534 "src/data/Buffer.birch"
  if (!(buffer.has_value())) {
    #line 535 "src/data/Buffer.birch"
    buffer = make_buffer();
    #line 536 "src/data/Buffer.birch"
    set(key, buffer.value());
  }
  #line 538 "src/data/Buffer.birch"
  buffer.value()->push(x);
}

#line 544 "src/data/Buffer.birch"
#line 544 "src/data/Buffer.birch"
#line 544 "src/data/Buffer.birch"
void Buffer_::pushNil() {
  #line 545 "src/data/Buffer.birch"
  push(make_buffer());
}

#line 553 "src/data/Buffer.birch"
#line 553 "src/data/Buffer.birch"
#line 553 "src/data/Buffer.birch"
void Buffer_::pushNil(const String& key) {
  #line 554 "src/data/Buffer.birch"
  push(key, make_buffer());
}

#line 557 "src/data/Buffer.birch"
#line 557 "src/data/Buffer.birch"
#line 557 "src/data/Buffer.birch"
void Buffer_::accept(const Writer& writer) {
  #line 558 "src/data/Buffer.birch"
  if (keys.has_value()) {
    #line 559 "src/data/Buffer.birch"
    writer->visit(keys.value(), values.value());
  } else {
    #line 560 "src/data/Buffer.birch"
    if (values.has_value()) {
      #line 561 "src/data/Buffer.birch"
      writer->visit(values.value());
    } else {
      #line 562 "src/data/Buffer.birch"
      if (scalarString.has_value()) {
        #line 563 "src/data/Buffer.birch"
        writer->visit(scalarString.value());
      } else {
        #line 564 "src/data/Buffer.birch"
        if (scalarReal.has_value()) {
          #line 565 "src/data/Buffer.birch"
          writer->visit(scalarReal.value());
        } else {
          #line 566 "src/data/Buffer.birch"
          if (scalarInteger.has_value()) {
            #line 567 "src/data/Buffer.birch"
            writer->visit(scalarInteger.value());
          } else {
            #line 568 "src/data/Buffer.birch"
            if (scalarBoolean.has_value()) {
              #line 569 "src/data/Buffer.birch"
              writer->visit(scalarBoolean.value());
            } else {
              #line 570 "src/data/Buffer.birch"
              if (vectorReal.has_value()) {
                #line 571 "src/data/Buffer.birch"
                writer->visit(vectorReal.value());
              } else {
                #line 572 "src/data/Buffer.birch"
                if (vectorInteger.has_value()) {
                  #line 573 "src/data/Buffer.birch"
                  writer->visit(vectorInteger.value());
                } else {
                  #line 574 "src/data/Buffer.birch"
                  if (vectorBoolean.has_value()) {
                    #line 575 "src/data/Buffer.birch"
                    writer->visit(vectorBoolean.value());
                  } else {
                    #line 576 "src/data/Buffer.birch"
                    if (matrixReal.has_value()) {
                      #line 577 "src/data/Buffer.birch"
                      writer->visit(matrixReal.value());
                    } else {
                      #line 578 "src/data/Buffer.birch"
                      if (matrixInteger.has_value()) {
                        #line 579 "src/data/Buffer.birch"
                        writer->visit(matrixInteger.value());
                      } else {
                        #line 580 "src/data/Buffer.birch"
                        if (matrixBoolean.has_value()) {
                          #line 581 "src/data/Buffer.birch"
                          writer->visit(matrixBoolean.value());
                        } else {
                          #line 583 "src/data/Buffer.birch"
                          writer->visitNil();
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}

#line 587 "src/data/Buffer.birch"
#line 587 "src/data/Buffer.birch"
#line 587 "src/data/Buffer.birch"
std::optional<Boolean> Buffer_::doGet(const std::optional<Boolean>& x) {
  #line 588 "src/data/Buffer.birch"
  if (scalarBoolean.has_value()) {
    #line 589 "src/data/Buffer.birch"
    return scalarBoolean.value();
  } else {
    #line 590 "src/data/Buffer.birch"
    if (scalarInteger.has_value()) {
      #line 591 "src/data/Buffer.birch"
      return scalar<Boolean>(scalarInteger.value());
    } else {
      #line 592 "src/data/Buffer.birch"
      if (scalarReal.has_value()) {
        #line 593 "src/data/Buffer.birch"
        return scalar<Boolean>(scalarReal.value());
      } else {
        #line 594 "src/data/Buffer.birch"
        if (scalarString.has_value()) {
          #line 595 "src/data/Buffer.birch"
          return from_string<Boolean>(scalarString.value());
        } else {
          #line 597 "src/data/Buffer.birch"
          return std::nullopt;
        }
      }
    }
  }
}

#line 601 "src/data/Buffer.birch"
#line 601 "src/data/Buffer.birch"
#line 601 "src/data/Buffer.birch"
std::optional<Integer> Buffer_::doGet(const std::optional<Integer>& x) {
  #line 602 "src/data/Buffer.birch"
  if (scalarBoolean.has_value()) {
    #line 603 "src/data/Buffer.birch"
    return scalar<Integer>(scalarBoolean.value());
  } else {
    #line 604 "src/data/Buffer.birch"
    if (scalarInteger.has_value()) {
      #line 605 "src/data/Buffer.birch"
      return scalarInteger.value();
    } else {
      #line 606 "src/data/Buffer.birch"
      if (scalarReal.has_value()) {
        #line 607 "src/data/Buffer.birch"
        return scalar<Integer>(scalarReal.value());
      } else {
        #line 608 "src/data/Buffer.birch"
        if (scalarString.has_value()) {
          #line 609 "src/data/Buffer.birch"
          return from_string<Integer>(scalarString.value());
        } else {
          #line 611 "src/data/Buffer.birch"
          return std::nullopt;
        }
      }
    }
  }
}

#line 615 "src/data/Buffer.birch"
#line 615 "src/data/Buffer.birch"
#line 615 "src/data/Buffer.birch"
std::optional<Real> Buffer_::doGet(const std::optional<Real>& x) {
  #line 616 "src/data/Buffer.birch"
  if (scalarBoolean.has_value()) {
    #line 617 "src/data/Buffer.birch"
    return scalar<Real>(scalarBoolean.value());
  } else {
    #line 618 "src/data/Buffer.birch"
    if (scalarInteger.has_value()) {
      #line 619 "src/data/Buffer.birch"
      return scalar<Real>(scalarInteger.value());
    } else {
      #line 620 "src/data/Buffer.birch"
      if (scalarReal.has_value()) {
        #line 621 "src/data/Buffer.birch"
        return scalarReal.value();
      } else {
        #line 622 "src/data/Buffer.birch"
        if (scalarString.has_value()) {
          #line 623 "src/data/Buffer.birch"
          return from_string<Real>(scalarString.value());
        } else {
          #line 625 "src/data/Buffer.birch"
          return std::nullopt;
        }
      }
    }
  }
}

#line 629 "src/data/Buffer.birch"
#line 629 "src/data/Buffer.birch"
#line 629 "src/data/Buffer.birch"
std::optional<String> Buffer_::doGet(const std::optional<String>& x) {
  #line 630 "src/data/Buffer.birch"
  if (scalarBoolean.has_value()) {
    #line 631 "src/data/Buffer.birch"
    return to_string(scalarBoolean.value());
  } else {
    #line 632 "src/data/Buffer.birch"
    if (scalarInteger.has_value()) {
      #line 633 "src/data/Buffer.birch"
      return to_string(scalarInteger.value());
    } else {
      #line 634 "src/data/Buffer.birch"
      if (scalarReal.has_value()) {
        #line 635 "src/data/Buffer.birch"
        return to_string(scalarReal.value());
      } else {
        #line 636 "src/data/Buffer.birch"
        if (scalarString.has_value()) {
          #line 637 "src/data/Buffer.birch"
          return scalarString.value();
        } else {
          #line 639 "src/data/Buffer.birch"
          return std::nullopt;
        }
      }
    }
  }
}

#line 647 "src/data/Buffer.birch"
#line 647 "src/data/Buffer.birch"
#line 647 "src/data/Buffer.birch"
std::optional<libbirch::DefaultArray<Boolean,1>> Buffer_::doGet(const std::optional<libbirch::DefaultArray<Boolean,1>>& x) {
  #line 648 "src/data/Buffer.birch"
  if (vectorBoolean.has_value()) {
    #line 649 "src/data/Buffer.birch"
    return vectorBoolean.value();
  } else {
    #line 650 "src/data/Buffer.birch"
    if (vectorInteger.has_value()) {
      #line 651 "src/data/Buffer.birch"
      return vector<Boolean>(vectorInteger.value());
    } else {
      #line 652 "src/data/Buffer.birch"
      if (vectorReal.has_value()) {
        #line 653 "src/data/Buffer.birch"
        return vector<Boolean>(vectorReal.value());
      } else {
        #line 655 "src/data/Buffer.birch"
        return doGetVector<Boolean>();
      }
    }
  }
}

#line 659 "src/data/Buffer.birch"
#line 659 "src/data/Buffer.birch"
#line 659 "src/data/Buffer.birch"
std::optional<libbirch::DefaultArray<Integer,1>> Buffer_::doGet(const std::optional<libbirch::DefaultArray<Integer,1>>& x) {
  #line 660 "src/data/Buffer.birch"
  if (vectorBoolean.has_value()) {
    #line 661 "src/data/Buffer.birch"
    return vector<Integer>(vectorBoolean.value());
  } else {
    #line 662 "src/data/Buffer.birch"
    if (vectorInteger.has_value()) {
      #line 663 "src/data/Buffer.birch"
      return vectorInteger.value();
    } else {
      #line 664 "src/data/Buffer.birch"
      if (vectorReal.has_value()) {
        #line 665 "src/data/Buffer.birch"
        return vector<Integer>(vectorReal.value());
      } else {
        #line 667 "src/data/Buffer.birch"
        return doGetVector<Integer>();
      }
    }
  }
}

#line 671 "src/data/Buffer.birch"
#line 671 "src/data/Buffer.birch"
#line 671 "src/data/Buffer.birch"
std::optional<libbirch::DefaultArray<Real,1>> Buffer_::doGet(const std::optional<libbirch::DefaultArray<Real,1>>& x) {
  #line 672 "src/data/Buffer.birch"
  if (vectorBoolean.has_value()) {
    #line 673 "src/data/Buffer.birch"
    return vector<Real>(vectorBoolean.value());
  } else {
    #line 674 "src/data/Buffer.birch"
    if (vectorInteger.has_value()) {
      #line 675 "src/data/Buffer.birch"
      return vector<Real>(vectorInteger.value());
    } else {
      #line 676 "src/data/Buffer.birch"
      if (vectorReal.has_value()) {
        #line 677 "src/data/Buffer.birch"
        return vectorReal.value();
      } else {
        #line 679 "src/data/Buffer.birch"
        return doGetVector<Real>();
      }
    }
  }
}

#line 707 "src/data/Buffer.birch"
#line 707 "src/data/Buffer.birch"
#line 707 "src/data/Buffer.birch"
std::optional<libbirch::DefaultArray<Boolean,2>> Buffer_::doGet(const std::optional<libbirch::DefaultArray<Boolean,2>>& x) {
  #line 708 "src/data/Buffer.birch"
  if (matrixBoolean.has_value()) {
    #line 709 "src/data/Buffer.birch"
    return matrixBoolean.value();
  } else {
    #line 710 "src/data/Buffer.birch"
    if (matrixInteger.has_value()) {
      #line 711 "src/data/Buffer.birch"
      return matrix<Boolean>(matrixInteger.value());
    } else {
      #line 712 "src/data/Buffer.birch"
      if (matrixReal.has_value()) {
        #line 713 "src/data/Buffer.birch"
        return matrix<Boolean>(matrixReal.value());
      } else {
        #line 715 "src/data/Buffer.birch"
        return doGetMatrix<Boolean>();
      }
    }
  }
}

#line 719 "src/data/Buffer.birch"
#line 719 "src/data/Buffer.birch"
#line 719 "src/data/Buffer.birch"
std::optional<libbirch::DefaultArray<Integer,2>> Buffer_::doGet(const std::optional<libbirch::DefaultArray<Integer,2>>& x) {
  #line 720 "src/data/Buffer.birch"
  if (matrixBoolean.has_value()) {
    #line 721 "src/data/Buffer.birch"
    return matrix<Integer>(matrixBoolean.value());
  } else {
    #line 722 "src/data/Buffer.birch"
    if (matrixInteger.has_value()) {
      #line 723 "src/data/Buffer.birch"
      return matrixInteger.value();
    } else {
      #line 724 "src/data/Buffer.birch"
      if (matrixReal.has_value()) {
        #line 725 "src/data/Buffer.birch"
        return matrix<Integer>(matrixReal.value());
      } else {
        #line 727 "src/data/Buffer.birch"
        return doGetMatrix<Integer>();
      }
    }
  }
}

#line 731 "src/data/Buffer.birch"
#line 731 "src/data/Buffer.birch"
#line 731 "src/data/Buffer.birch"
std::optional<libbirch::DefaultArray<Real,2>> Buffer_::doGet(const std::optional<libbirch::DefaultArray<Real,2>>& x) {
  #line 732 "src/data/Buffer.birch"
  if (matrixBoolean.has_value()) {
    #line 733 "src/data/Buffer.birch"
    return matrix<Real>(matrixBoolean.value());
  } else {
    #line 734 "src/data/Buffer.birch"
    if (matrixInteger.has_value()) {
      #line 735 "src/data/Buffer.birch"
      return matrix<Real>(matrixInteger.value());
    } else {
      #line 736 "src/data/Buffer.birch"
      if (matrixReal.has_value()) {
        #line 737 "src/data/Buffer.birch"
        return matrixReal.value();
      } else {
        #line 739 "src/data/Buffer.birch"
        return doGetMatrix<Real>();
      }
    }
  }
}

#line 776 "src/data/Buffer.birch"
#line 776 "src/data/Buffer.birch"
#line 776 "src/data/Buffer.birch"
void Buffer_::doSet(const Boolean& x) {
  #line 777 "src/data/Buffer.birch"
  setNil();
  #line 778 "src/data/Buffer.birch"
  scalarBoolean = x;
}

#line 781 "src/data/Buffer.birch"
#line 781 "src/data/Buffer.birch"
#line 781 "src/data/Buffer.birch"
void Buffer_::doSet(const Integer& x) {
  #line 782 "src/data/Buffer.birch"
  setNil();
  #line 783 "src/data/Buffer.birch"
  scalarInteger = x;
}

#line 786 "src/data/Buffer.birch"
#line 786 "src/data/Buffer.birch"
#line 786 "src/data/Buffer.birch"
void Buffer_::doSet(const Real& x) {
  #line 787 "src/data/Buffer.birch"
  setNil();
  #line 788 "src/data/Buffer.birch"
  scalarReal = x;
}

#line 791 "src/data/Buffer.birch"
#line 791 "src/data/Buffer.birch"
#line 791 "src/data/Buffer.birch"
void Buffer_::doSet(const String& x) {
  #line 792 "src/data/Buffer.birch"
  setNil();
  #line 793 "src/data/Buffer.birch"
  scalarString = x;
}

#line 806 "src/data/Buffer.birch"
#line 806 "src/data/Buffer.birch"
#line 806 "src/data/Buffer.birch"
void Buffer_::doSet(const libbirch::DefaultArray<Boolean,1>& x) {
  #line 807 "src/data/Buffer.birch"
  setNil();
  #line 808 "src/data/Buffer.birch"
  vectorBoolean = x;
}

#line 811 "src/data/Buffer.birch"
#line 811 "src/data/Buffer.birch"
#line 811 "src/data/Buffer.birch"
void Buffer_::doSet(const libbirch::DefaultArray<Integer,1>& x) {
  #line 812 "src/data/Buffer.birch"
  setNil();
  #line 813 "src/data/Buffer.birch"
  vectorInteger = x;
}

#line 816 "src/data/Buffer.birch"
#line 816 "src/data/Buffer.birch"
#line 816 "src/data/Buffer.birch"
void Buffer_::doSet(const libbirch::DefaultArray<Real,1>& x) {
  #line 817 "src/data/Buffer.birch"
  setNil();
  #line 818 "src/data/Buffer.birch"
  vectorReal = x;
}

#line 835 "src/data/Buffer.birch"
#line 835 "src/data/Buffer.birch"
#line 835 "src/data/Buffer.birch"
void Buffer_::doSet(const libbirch::DefaultArray<Boolean,2>& x) {
  #line 836 "src/data/Buffer.birch"
  setNil();
  #line 837 "src/data/Buffer.birch"
  matrixBoolean = x;
}

#line 840 "src/data/Buffer.birch"
#line 840 "src/data/Buffer.birch"
#line 840 "src/data/Buffer.birch"
void Buffer_::doSet(const libbirch::DefaultArray<Integer,2>& x) {
  #line 841 "src/data/Buffer.birch"
  setNil();
  #line 842 "src/data/Buffer.birch"
  matrixInteger = x;
}

#line 845 "src/data/Buffer.birch"
#line 845 "src/data/Buffer.birch"
#line 845 "src/data/Buffer.birch"
void Buffer_::doSet(const libbirch::DefaultArray<Real,2>& x) {
  #line 846 "src/data/Buffer.birch"
  setNil();
  #line 847 "src/data/Buffer.birch"
  matrixReal = x;
}

#line 850 "src/data/Buffer.birch"
#line 850 "src/data/Buffer.birch"
#line 850 "src/data/Buffer.birch"
void Buffer_::doPush(const Boolean& x) {
  #line 851 "src/data/Buffer.birch"
  if (isEmpty()) {
    #line 852 "src/data/Buffer.birch"
    set(x);
  } else {
    #line 853 "src/data/Buffer.birch"
    if (scalarBoolean.has_value()) {
      #line 854 "src/data/Buffer.birch"
      set(libbirch::make_array_from_sequence({ scalarBoolean.value(), x }));
    } else {
      #line 855 "src/data/Buffer.birch"
      if (scalarInteger.has_value()) {
        #line 856 "src/data/Buffer.birch"
        set(libbirch::make_array_from_sequence({ scalarInteger.value(), scalar<Integer>(x) }));
      } else {
        #line 857 "src/data/Buffer.birch"
        if (scalarReal.has_value()) {
          #line 858 "src/data/Buffer.birch"
          set(libbirch::make_array_from_sequence({ scalarReal.value(), scalar<Real>(x) }));
        } else {
          #line 859 "src/data/Buffer.birch"
          if (vectorBoolean.has_value()) {
            #line 860 "src/data/Buffer.birch"

      vectorBoolean.value().push(x);
                } else {
            #line 863 "src/data/Buffer.birch"
            if (vectorInteger.has_value()) {
              #line 864 "src/data/Buffer.birch"
              push(scalar<Integer>(x));
            } else {
              #line 865 "src/data/Buffer.birch"
              if (vectorReal.has_value()) {
                #line 866 "src/data/Buffer.birch"
                push(scalar<Real>(x));
              } else {
                #line 868 "src/data/Buffer.birch"
                push(make_buffer(x));
              }
            }
          }
        }
      }
    }
  }
}

#line 872 "src/data/Buffer.birch"
#line 872 "src/data/Buffer.birch"
#line 872 "src/data/Buffer.birch"
void Buffer_::doPush(const Integer& x) {
  #line 873 "src/data/Buffer.birch"
  if (isEmpty()) {
    #line 874 "src/data/Buffer.birch"
    set(x);
  } else {
    #line 875 "src/data/Buffer.birch"
    if (scalarBoolean.has_value()) {
      #line 876 "src/data/Buffer.birch"
      set(libbirch::make_array_from_sequence({ scalar<Integer>(scalarBoolean.value()), x }));
    } else {
      #line 877 "src/data/Buffer.birch"
      if (scalarInteger.has_value()) {
        #line 878 "src/data/Buffer.birch"
        set(libbirch::make_array_from_sequence({ scalarInteger.value(), x }));
      } else {
        #line 879 "src/data/Buffer.birch"
        if (scalarReal.has_value()) {
          #line 880 "src/data/Buffer.birch"
          set(libbirch::make_array_from_sequence({ scalarReal.value(), scalar<Real>(x) }));
        } else {
          #line 881 "src/data/Buffer.birch"
          if (vectorBoolean.has_value()) {
            #line 882 "src/data/Buffer.birch"
            set(stack(vector<Integer>(vectorBoolean.value()), x));
          } else {
            #line 883 "src/data/Buffer.birch"
            if (vectorInteger.has_value()) {
              #line 884 "src/data/Buffer.birch"

      vectorInteger.value().push(x);
                  } else {
              #line 887 "src/data/Buffer.birch"
              if (vectorReal.has_value()) {
                #line 888 "src/data/Buffer.birch"
                push(scalar<Real>(x));
              } else {
                #line 890 "src/data/Buffer.birch"
                push(make_buffer(x));
              }
            }
          }
        }
      }
    }
  }
}

#line 894 "src/data/Buffer.birch"
#line 894 "src/data/Buffer.birch"
#line 894 "src/data/Buffer.birch"
void Buffer_::doPush(const Real& x) {
  #line 895 "src/data/Buffer.birch"
  if (isEmpty()) {
    #line 896 "src/data/Buffer.birch"
    set(x);
  } else {
    #line 897 "src/data/Buffer.birch"
    if (scalarBoolean.has_value()) {
      #line 898 "src/data/Buffer.birch"
      set(libbirch::make_array_from_sequence({ scalar<Real>(scalarBoolean.value()), x }));
    } else {
      #line 899 "src/data/Buffer.birch"
      if (scalarInteger.has_value()) {
        #line 900 "src/data/Buffer.birch"
        set(libbirch::make_array_from_sequence({ scalar<Real>(scalarInteger.value()), x }));
      } else {
        #line 901 "src/data/Buffer.birch"
        if (scalarReal.has_value()) {
          #line 902 "src/data/Buffer.birch"
          set(libbirch::make_array_from_sequence({ scalarReal.value(), x }));
        } else {
          #line 903 "src/data/Buffer.birch"
          if (vectorBoolean.has_value()) {
            #line 904 "src/data/Buffer.birch"
            set(stack(vector<Real>(vectorBoolean.value()), x));
          } else {
            #line 905 "src/data/Buffer.birch"
            if (vectorInteger.has_value()) {
              #line 906 "src/data/Buffer.birch"
              set(stack(vector<Real>(vectorInteger.value()), x));
            } else {
              #line 907 "src/data/Buffer.birch"
              if (vectorReal.has_value()) {
                #line 908 "src/data/Buffer.birch"

      vectorReal.value().push(x);
                    } else {
                #line 912 "src/data/Buffer.birch"
                push(make_buffer(x));
              }
            }
          }
        }
      }
    }
  }
}

#line 916 "src/data/Buffer.birch"
#line 916 "src/data/Buffer.birch"
#line 916 "src/data/Buffer.birch"
void Buffer_::doPush(const String& x) {
  #line 917 "src/data/Buffer.birch"
  push(make_buffer(x));
}

#line 928 "src/data/Buffer.birch"
#line 928 "src/data/Buffer.birch"
#line 928 "src/data/Buffer.birch"
void Buffer_::doPush(const libbirch::DefaultArray<Boolean,1>& x) {
  #line 929 "src/data/Buffer.birch"
  if (isEmpty()) {
    #line 930 "src/data/Buffer.birch"
    set(row(x));
  } else {
    #line 931 "src/data/Buffer.birch"
    if (vectorBoolean.has_value()) {
      #line 932 "src/data/Buffer.birch"
      set(stack(row(vectorBoolean.value()), row(x)));
    } else {
      #line 933 "src/data/Buffer.birch"
      if (matrixBoolean.has_value() && columns(matrixBoolean.value()) == length(x)) {
        #line 934 "src/data/Buffer.birch"
        set(stack(matrixBoolean.value(), row(x)));
      } else {
        #line 935 "src/data/Buffer.birch"
        if (vectorInteger.has_value() || matrixInteger.has_value()) {
          #line 936 "src/data/Buffer.birch"
          push(vector<Integer>(x));
        } else {
          #line 937 "src/data/Buffer.birch"
          if (vectorReal.has_value() || matrixReal.has_value()) {
            #line 938 "src/data/Buffer.birch"
            push(vector<Real>(x));
          } else {
            #line 940 "src/data/Buffer.birch"
            push(make_buffer(x));
          }
        }
      }
    }
  }
}

#line 944 "src/data/Buffer.birch"
#line 944 "src/data/Buffer.birch"
#line 944 "src/data/Buffer.birch"
void Buffer_::doPush(const libbirch::DefaultArray<Integer,1>& x) {
  #line 945 "src/data/Buffer.birch"
  if (isEmpty()) {
    #line 946 "src/data/Buffer.birch"
    set(row(x));
  } else {
    #line 947 "src/data/Buffer.birch"
    if (vectorBoolean.has_value()) {
      #line 948 "src/data/Buffer.birch"
      set(stack(matrix<Integer>(row(vectorBoolean.value())), row(x)));
    } else {
      #line 949 "src/data/Buffer.birch"
      if (matrixBoolean.has_value() && columns(matrixBoolean.value()) == length(x)) {
        #line 950 "src/data/Buffer.birch"
        set(stack(matrix<Integer>(matrixBoolean.value()), row(x)));
      } else {
        #line 951 "src/data/Buffer.birch"
        if (vectorInteger.has_value()) {
          #line 952 "src/data/Buffer.birch"
          set(stack(row(vectorInteger.value()), row(x)));
        } else {
          #line 953 "src/data/Buffer.birch"
          if (matrixInteger.has_value() && columns(matrixInteger.value()) == length(x)) {
            #line 954 "src/data/Buffer.birch"
            set(stack(matrixInteger.value(), row(x)));
          } else {
            #line 955 "src/data/Buffer.birch"
            if (vectorReal.has_value() || matrixReal.has_value()) {
              #line 956 "src/data/Buffer.birch"
              push(vector<Real>(x));
            } else {
              #line 958 "src/data/Buffer.birch"
              push(make_buffer(x));
            }
          }
        }
      }
    }
  }
}

#line 962 "src/data/Buffer.birch"
#line 962 "src/data/Buffer.birch"
#line 962 "src/data/Buffer.birch"
void Buffer_::doPush(const libbirch::DefaultArray<Real,1>& x) {
  #line 963 "src/data/Buffer.birch"
  if (isEmpty()) {
    #line 964 "src/data/Buffer.birch"
    set(row(x));
  } else {
    #line 965 "src/data/Buffer.birch"
    if (vectorBoolean.has_value()) {
      #line 966 "src/data/Buffer.birch"
      set(stack(matrix<Real>(row(vectorBoolean.value())), row(x)));
    } else {
      #line 967 "src/data/Buffer.birch"
      if (matrixBoolean.has_value() && columns(matrixBoolean.value()) == length(x)) {
        #line 968 "src/data/Buffer.birch"
        set(stack(matrix<Real>(matrixBoolean.value()), row(x)));
      } else {
        #line 969 "src/data/Buffer.birch"
        if (vectorInteger.has_value()) {
          #line 970 "src/data/Buffer.birch"
          set(stack(matrix<Real>(row(vectorInteger.value())), row(x)));
        } else {
          #line 971 "src/data/Buffer.birch"
          if (matrixInteger.has_value() && columns(matrixInteger.value()) == length(x)) {
            #line 972 "src/data/Buffer.birch"
            set(stack(matrix<Real>(matrixInteger.value()), row(x)));
          } else {
            #line 973 "src/data/Buffer.birch"
            if (vectorReal.has_value()) {
              #line 974 "src/data/Buffer.birch"
              set(stack(row(vectorReal.value()), row(x)));
            } else {
              #line 975 "src/data/Buffer.birch"
              if (matrixReal.has_value() && columns(matrixReal.value()) == length(x)) {
                #line 976 "src/data/Buffer.birch"
                set(stack(matrixReal.value(), row(x)));
              } else {
                #line 978 "src/data/Buffer.birch"
                push(make_buffer(x));
              }
            }
          }
        }
      }
    }
  }
}

#line 1 "src/data/Buffer.birch"
Buffer_* make_Buffer_() {
  #line 1 "src/data/Buffer.birch"
  return new Buffer_();
  #line 1 "src/data/Buffer.birch"
}

#line 986 "src/data/Buffer.birch"
#line 986 "src/data/Buffer.birch"
Buffer make_buffer() {
  #line 987 "src/data/Buffer.birch"
  return construct<Buffer>();
}

#line 1019 "src/data/Buffer.birch"
#line 1019 "src/data/Buffer.birch"
Buffer make_buffer(const libbirch::DefaultArray<String,1>& keys, const libbirch::DefaultArray<Buffer,1>& values) {
  Buffer o;
  #line 1021 "src/data/Buffer.birch"
  o->set(keys, values);
  #line 1022 "src/data/Buffer.birch"
  return o;
}

}
