namespace birch {
#line 91 "src/distribution/matrix_other/InverseWishartDistribution.birch"
#line 91 "src/distribution/matrix_other/InverseWishartDistribution.birch"
libbirch::DefaultArray<Real,2> simulate_inverse_wishart(const libbirch::DefaultArray<Real,2>& \u03a8, const Real& k) {
  #line 92 "src/distribution/matrix_other/InverseWishartDistribution.birch"
  return cholinv(simulate_wishart(cholinv(\u03a8), k));
}

}
namespace birch {
#line 9 "src/distribution/matrix_other/MatrixTDistribution.birch"
#line 9 "src/distribution/matrix_other/MatrixTDistribution.birch"
libbirch::DefaultArray<Real,2> simulate_matrix_t(const Real& k, const libbirch::DefaultArray<Real,2>& M, const libbirch::DefaultArray<Real,2>& U, const libbirch::DefaultArray<Real,2>& \u03a8) {
  #line 11 "src/distribution/matrix_other/MatrixTDistribution.birch"
  return simulate_matrix_gaussian(M, U, simulate_inverse_wishart(\u03a8, k));
}

}
namespace birch {
#line 55 "src/distribution/matrix_other/WishartDistribution.birch"
#line 55 "src/distribution/matrix_other/WishartDistribution.birch"
libbirch::DefaultArray<Real,2> simulate_wishart(const libbirch::DefaultArray<Real,2>& \u03a8, const Real& k) {
  #line 56 "src/distribution/matrix_other/WishartDistribution.birch"
  assert(rows(\u03a8) == columns(\u03a8));
  auto p = rows(\u03a8);
  auto A = matrix_lambda([=](const Integer& i, const Integer& j) -> Real {
    #line 59 "src/distribution/matrix_other/WishartDistribution.birch"
    if (j == i) {
      #line 61 "src/distribution/matrix_other/WishartDistribution.birch"
      return sqrt(simulate_chi_squared(k + p - i));
    } else {
      #line 62 "src/distribution/matrix_other/WishartDistribution.birch"
      if (j < i) {
        #line 64 "src/distribution/matrix_other/WishartDistribution.birch"
        return simulate_gaussian(0.0, 1.0);
      } else {
        #line 67 "src/distribution/matrix_other/WishartDistribution.birch"
        return 0.0;
      }
    }
  }, p, p);
  #line 70 "src/distribution/matrix_other/WishartDistribution.birch"
  return outer(chol(\u03a8) * A);
}

}
