namespace birch {
#line 48 "src/distribution/multivariate_other/DirichletDistribution.birch"
#line 48 "src/distribution/multivariate_other/DirichletDistribution.birch"
libbirch::DefaultArray<Real,1> simulate_dirichlet(const libbirch::DefaultArray<Real,1>& \u03b1) {
  auto x = transform(\u03b1, [=](const Real& \u03b1) -> Real {
    #line 49 "src/distribution/multivariate_other/DirichletDistribution.birch"
    return simulate_gamma(\u03b1, 1.0);
  });
  #line 50 "src/distribution/multivariate_other/DirichletDistribution.birch"
  return x / sum(x);
}

#line 59 "src/distribution/multivariate_other/DirichletDistribution.birch"
#line 59 "src/distribution/multivariate_other/DirichletDistribution.birch"
libbirch::DefaultArray<Real,1> simulate_dirichlet(const Real& \u03b1, const Integer& D) {
  auto x = vector_lambda([=](const Integer& i) -> Real {
    #line 60 "src/distribution/multivariate_other/DirichletDistribution.birch"
    return simulate_gamma(\u03b1, 1.0);
  }, D);
  #line 61 "src/distribution/multivariate_other/DirichletDistribution.birch"
  return x / sum(x);
}

#line 72 "src/distribution/multivariate_other/DirichletDistribution.birch"
#line 72 "src/distribution/multivariate_other/DirichletDistribution.birch"
Real logpdf_dirichlet(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Real,1>& \u03b1) {
  #line 73 "src/distribution/multivariate_other/DirichletDistribution.birch"
  assert(length(x) == length(\u03b1));
  auto D = length(x);
  auto w = 0.0;
  #line 76 "src/distribution/multivariate_other/DirichletDistribution.birch"
  for (auto i = Integer(1); i <= D; ++i) {
    #line 77 "src/distribution/multivariate_other/DirichletDistribution.birch"
    if (x(i) < 0.0) {
      #line 78 "src/distribution/multivariate_other/DirichletDistribution.birch"
      return -(std::numeric_limits<double>::infinity());
    }
    #line 80 "src/distribution/multivariate_other/DirichletDistribution.birch"
    w = w + (\u03b1(i) - 1.0) * log(x(i)) - lgamma(\u03b1(i));
  }
  #line 82 "src/distribution/multivariate_other/DirichletDistribution.birch"
  w = w + lgamma(sum(\u03b1));
  #line 83 "src/distribution/multivariate_other/DirichletDistribution.birch"
  return w;
}

}
namespace birch {
#line 8 "src/distribution/multivariate_other/MultivariateTDistribution.birch"
#line 8 "src/distribution/multivariate_other/MultivariateTDistribution.birch"
libbirch::DefaultArray<Real,1> simulate_multivariate_t(const Real& k, const libbirch::DefaultArray<Real,1>& \u03bc, const libbirch::DefaultArray<Real,2>& U) {
  #line 10 "src/distribution/multivariate_other/MultivariateTDistribution.birch"
  return simulate_multivariate_gaussian(\u03bc, simulate_inverse_wishart(U, k));
}

}
namespace birch {
}
