namespace birch {
#line 48 "src/distribution/scalar_boolean/BernoulliDistribution.birch"
#line 48 "src/distribution/scalar_boolean/BernoulliDistribution.birch"
Boolean simulate_bernoulli(const Real& \u03c1) {
  #line 49 "src/distribution/scalar_boolean/BernoulliDistribution.birch"
  assert(0.0 <= \u03c1 && \u03c1 <= 1.0);
  #line 50 "src/distribution/scalar_boolean/BernoulliDistribution.birch"

  return std::bernoulli_distribution(\u03c1)(rng);
  }

}
namespace birch {
#line 51 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
#line 51 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
Distribution<Boolean> Bernoulli(const Random<Real>& \u03c1) {
  #line 52 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
  \u03c1->prune();
  #line 53 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
  if (\u03c1->hasBeta()) {
    auto n4587_ = \u03c1->getBeta();
    auto \u03b1 = std::get<0>(n4587_);
    auto \u03b2 = std::get<1>(n4587_);
    auto p = BetaBernoulli(\u03b1, \u03b2);
    #line 56 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
    \u03c1->graft(p);
    #line 57 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
    return p;
  } else {
    #line 59 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
    return construct<BernoulliDistribution<Random<Real>>>(\u03c1);
  }
}

#line 69 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
#line 69 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
Boolean simulate_beta_bernoulli(const Real& \u03b1, const Real& \u03b2) {
  #line 70 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
  assert(0.0 < \u03b1);
  #line 71 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
  assert(0.0 < \u03b2);
  #line 72 "src/distribution/scalar_boolean/BetaBernoulliDistribution.birch"
  return simulate_bernoulli(simulate_beta(\u03b1, \u03b2));
}

}
