namespace birch {
#line 7 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
#line 7 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
AddDiscreteConstrainedDistribution_::AddDiscreteConstrainedDistribution_(const libbirch::DefaultArray<Real,1>& p, const Integer& l, const Integer& y) :
    #line 7 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
    base_type_(),
    #line 12 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
    p(p),
    #line 17 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
    l(l),
    #line 22 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
    y(y) {
  //
}

#line 24 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
#line 24 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
#line 24 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
Integer AddDiscreteConstrainedDistribution_::simulate() {
  #line 25 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
  return simulate_categorical(p) + l - Integer(1);
}

#line 28 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
#line 28 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
#line 28 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
Real AddDiscreteConstrainedDistribution_::logpdf(const Integer& x) {
  #line 29 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
  return logpdf_categorical(x - l + Integer(1), p);
}

#line 32 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
#line 32 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
#line 32 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
std::optional<Delay> AddDiscreteConstrainedDistribution_::update(const Integer& x) {
  #line 33 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
  return Delta(y - x);
}

#line 36 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
#line 36 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
#line 36 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
std::optional<Integer> AddDiscreteConstrainedDistribution_::lower() {
  #line 37 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
  return l;
}

#line 40 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
#line 40 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
#line 40 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
std::optional<Integer> AddDiscreteConstrainedDistribution_::upper() {
  #line 41 "src/distribution/scalar_enumerate/AddDiscreteConstrainedDistribution.birch"
  return l + length(p) - Integer(1);
}

}
namespace birch {
#line 4 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 4 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
AddDiscreteDeltaDistribution_::AddDiscreteDeltaDistribution_(const BoundedDiscreteDistribution& p, const BoundedDiscreteDistribution& q) :
    #line 4 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    base_type_(),
    #line 9 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    p(p),
    #line 14 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    q(q),
    #line 19 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    x(),
    #line 24 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    l(Integer(0)),
    #line 29 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    u(Integer(0)),
    #line 35 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    z(),
    #line 40 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    Z(0.0) {
  //
}

#line 42 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 42 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 42 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
void AddDiscreteDeltaDistribution_::enumerate(const Integer& x) {
  #line 43 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
  if (!(this->x.has_value()) || this->x.value() != x) {
    #line 44 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    l = max(p->lower().value(), x - q->upper().value());
    #line 45 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    u = min(p->upper().value(), x - q->lower().value());
    #line 46 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    if (l <= u) {
      #line 48 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
      z = vector_lambda([=](const Integer& i) {
        auto n = l + i - Integer(1);
        #line 50 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
        return p->logpdf(n) + q->logpdf(x - n);
      }, u - l + Integer(1));
      #line 52 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
      Z = log_sum_exp(z);
      #line 53 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
      z = norm_exp(z);
    } else {
      #line 55 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
      Z = -(std::numeric_limits<double>::infinity());
      #line 56 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
      z = vector(0.0, Integer(0));
    }
    #line 58 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    this->x = x;
  }
}

#line 62 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 62 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 62 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
Integer AddDiscreteDeltaDistribution_::simulate() {
  #line 63 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
  return p->simulate() + q->simulate();
}

#line 66 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 66 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 66 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
Real AddDiscreteDeltaDistribution_::logpdf(const Integer& x) {
  #line 67 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
  enumerate(x);
  #line 68 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
  return Z;
}

#line 71 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 71 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 71 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
std::optional<Delay> AddDiscreteDeltaDistribution_::update(const Integer& x) {
  #line 72 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
  enumerate(x);
  #line 73 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
  return construct<AddDiscreteConstrainedDistribution>(z, l, x);
}

#line 76 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 76 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 76 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
std::optional<Integer> AddDiscreteDeltaDistribution_::lower() {
  #line 77 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
  return p->lower().value() + q->lower().value();
}

#line 80 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 80 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 80 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
std::optional<Integer> AddDiscreteDeltaDistribution_::upper() {
  #line 81 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
  return p->upper().value() + q->upper().value();
}

#line 88 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
#line 88 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
Distribution<Integer> Delta(const Add<Random<Integer>, Random<Integer>>& \u03bc) {
  #line 90 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
  \u03bc->l->prune();
  #line 91 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
  \u03bc->r->prune();
  #line 92 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
  if (\u03bc->l->hasBoundedDiscrete() && \u03bc->r->hasBoundedDiscrete()) {
    auto p = construct<AddDiscreteDeltaDistribution>(\u03bc->l->getBoundedDiscrete(), \u03bc->r->getBoundedDiscrete());
    #line 95 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    \u03bc->l->graft(p, Integer(1));
    #line 96 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    \u03bc->r->graft(p, Integer(2));
    #line 97 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    \u03bc->l->join(\u03bc->r);
    #line 98 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    return p;
  } else {
    #line 99 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
    if (\u03bc->l->hasBoundedDiscrete()) {
      auto r = handle_assume(Delta(\u03bc->r));
      #line 101 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
      return Delta(\u03bc->l + r);
    } else {
      #line 102 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
      if (\u03bc->r->hasBoundedDiscrete()) {
        auto l = handle_assume(Delta(\u03bc->l));
        #line 104 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
        return Delta(l + \u03bc->r);
      } else {
        #line 106 "src/distribution/scalar_enumerate/AddDiscreteDeltaDistribution.birch"
        return construct<DeltaDistribution<Add<Random<Integer>, Random<Integer>>>>(\u03bc);
      }
    }
  }
}

}
namespace birch {
}
namespace birch {
#line 6 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 6 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
DiscreteDeltaDistribution_::DiscreteDeltaDistribution_(const BoundedDiscreteDistribution& p) :
    #line 6 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
    base_type_(),
    #line 11 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
    p(p) {
  //
}

#line 13 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 13 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 13 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
Integer DiscreteDeltaDistribution_::simulate() {
  #line 14 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
  return p->simulate();
}

#line 17 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 17 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 17 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
Real DiscreteDeltaDistribution_::logpdf(const Integer& x) {
  #line 18 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
  return p->logpdf(x);
}

#line 21 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 21 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 21 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
std::optional<Delay> DiscreteDeltaDistribution_::update(const Integer& x) {
  #line 22 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
  return Delta(x);
}

#line 25 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 25 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 25 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
std::optional<Integer> DiscreteDeltaDistribution_::lower() {
  #line 26 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
  return p->lower();
}

#line 29 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 29 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 29 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
std::optional<Integer> DiscreteDeltaDistribution_::upper() {
  #line 30 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
  return p->upper();
}

#line 37 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
#line 37 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
Distribution<Integer> Delta(const Random<Integer>& \u03bc) {
  #line 38 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
  \u03bc->prune();
  #line 39 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
  if (\u03bc->hasBoundedDiscrete()) {
    auto p = construct<DiscreteDeltaDistribution>(\u03bc->getBoundedDiscrete());
    #line 41 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
    \u03bc->graft(p);
    #line 42 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
    return p;
  } else {
    #line 44 "src/distribution/scalar_enumerate/DiscreteDeltaDistribution.birch"
    return construct<DeltaDistribution<Random<Integer>>>(\u03bc);
  }
}

}
namespace birch {
#line 7 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 7 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
NegateDiscreteDeltaDistribution_::NegateDiscreteDeltaDistribution_(const BoundedDiscreteDistribution& p) :
    #line 7 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
    base_type_(),
    #line 12 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
    p(p) {
  //
}

#line 14 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 14 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 14 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
Integer NegateDiscreteDeltaDistribution_::simulate() {
  #line 15 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
  return -(p->simulate());
}

#line 18 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 18 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 18 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
Real NegateDiscreteDeltaDistribution_::logpdf(const Integer& x) {
  #line 19 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
  return p->logpdf(-(x));
}

#line 22 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 22 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 22 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
std::optional<Delay> NegateDiscreteDeltaDistribution_::update(const Integer& x) {
  #line 23 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
  return Delta(-(x));
}

#line 26 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 26 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 26 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
std::optional<Integer> NegateDiscreteDeltaDistribution_::lower() {
  auto l = p->upper();
  #line 28 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
  if (l.has_value()) {
    #line 29 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
    return -(l.value());
  } else {
    #line 31 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
    return std::nullopt;
  }
}

#line 35 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 35 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 35 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
std::optional<Integer> NegateDiscreteDeltaDistribution_::upper() {
  auto l = p->lower();
  #line 37 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
  if (l.has_value()) {
    #line 38 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
    return -(l.value());
  } else {
    #line 40 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
    return std::nullopt;
  }
}

#line 48 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
#line 48 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
Distribution<Integer> Delta(const Negate<Random<Integer>>& \u03bc) {
  #line 49 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
  \u03bc->m->prune();
  #line 50 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
  if (\u03bc->m->hasBoundedDiscrete()) {
    auto p = construct<NegateDiscreteDeltaDistribution>(\u03bc->m->getBoundedDiscrete());
    #line 52 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
    \u03bc->m->graft(p);
    #line 53 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
    return p;
  } else {
    #line 55 "src/distribution/scalar_enumerate/NegateDiscreteDeltaDistribution.birch"
    return construct<DeltaDistribution<Negate<Random<Integer>>>>(\u03bc);
  }
}

}
namespace birch {
#line 8 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
#line 8 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
SubtractDiscreteConstrainedDistribution_::SubtractDiscreteConstrainedDistribution_(const libbirch::DefaultArray<Real,1>& p, const Integer& l, const Integer& y) :
    #line 8 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
    base_type_(),
    #line 13 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
    p(p),
    #line 18 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
    l(l),
    #line 23 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
    y(y) {
  //
}

#line 25 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
#line 25 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
#line 25 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
Integer SubtractDiscreteConstrainedDistribution_::simulate() {
  #line 26 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
  return simulate_categorical(p) + l - Integer(1);
}

#line 29 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
#line 29 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
#line 29 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
Real SubtractDiscreteConstrainedDistribution_::logpdf(const Integer& x) {
  #line 30 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
  return logpdf_categorical(x - l + Integer(1), p);
}

#line 33 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
#line 33 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
#line 33 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
std::optional<Delay> SubtractDiscreteConstrainedDistribution_::update(const Integer& x) {
  #line 34 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
  return Delta(x - y);
}

#line 37 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
#line 37 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
#line 37 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
std::optional<Integer> SubtractDiscreteConstrainedDistribution_::lower() {
  #line 38 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
  return l;
}

#line 41 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
#line 41 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
#line 41 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
std::optional<Integer> SubtractDiscreteConstrainedDistribution_::upper() {
  #line 42 "src/distribution/scalar_enumerate/SubtractDiscreteConstrainedDistribution.birch"
  return l + length(p) - Integer(1);
}

}
namespace birch {
#line 4 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 4 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
SubtractDiscreteDeltaDistribution_::SubtractDiscreteDeltaDistribution_(const BoundedDiscreteDistribution& p, const BoundedDiscreteDistribution& q) :
    #line 4 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    base_type_(),
    #line 9 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    p(p),
    #line 14 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    q(q),
    #line 19 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    x(),
    #line 24 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    l(Integer(0)),
    #line 29 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    u(Integer(0)),
    #line 35 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    z(),
    #line 40 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    Z(0.0) {
  //
}

#line 42 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 42 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 42 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
void SubtractDiscreteDeltaDistribution_::enumerate(const Integer& x) {
  #line 43 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
  if (!(this->x.has_value()) || this->x.value() != x) {
    #line 44 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    l = max(p->lower().value(), x + q->lower().value());
    #line 45 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    u = min(p->upper().value(), x + q->upper().value());
    #line 46 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    Z = -(std::numeric_limits<double>::infinity());
    #line 47 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    if (l <= u) {
      #line 49 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
      z = vector_lambda([=](const Integer& i) {
        auto n = l + i - Integer(1);
        #line 51 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
        return p->logpdf(n) + q->logpdf(n - x);
      }, u - l + Integer(1));
      #line 53 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
      Z = log_sum_exp(z);
      #line 54 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
      z = norm_exp(z);
    }
    #line 56 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    this->x = x;
  }
}

#line 60 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 60 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 60 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
Integer SubtractDiscreteDeltaDistribution_::simulate() {
  #line 61 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
  return p->simulate() - q->simulate();
}

#line 64 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 64 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 64 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
Real SubtractDiscreteDeltaDistribution_::logpdf(const Integer& x) {
  #line 65 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
  enumerate(x);
  #line 66 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
  return Z;
}

#line 69 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 69 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 69 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
std::optional<Delay> SubtractDiscreteDeltaDistribution_::update(const Integer& x) {
  #line 70 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
  enumerate(x);
  #line 71 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
  return construct<SubtractDiscreteConstrainedDistribution>(z, l, x);
}

#line 74 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 74 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 74 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
std::optional<Integer> SubtractDiscreteDeltaDistribution_::lower() {
  #line 75 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
  return p->lower().value() - q->upper().value();
}

#line 78 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 78 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 78 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
std::optional<Integer> SubtractDiscreteDeltaDistribution_::upper() {
  #line 79 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
  return p->upper().value() - q->lower().value();
}

#line 86 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
#line 86 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
Distribution<Integer> Delta(const Subtract<Random<Integer>, Random<Integer>>& \u03bc) {
  #line 88 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
  \u03bc->l->prune();
  #line 89 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
  \u03bc->r->prune();
  #line 90 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
  if (\u03bc->l->hasBoundedDiscrete() && \u03bc->r->hasBoundedDiscrete()) {
    auto p = construct<SubtractDiscreteDeltaDistribution>(\u03bc->l->getBoundedDiscrete(), \u03bc->r->getBoundedDiscrete());
    #line 93 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    \u03bc->l->graft(p, Integer(1));
    #line 94 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    \u03bc->r->graft(p, Integer(2));
    #line 95 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    \u03bc->l->join(\u03bc->r);
    #line 96 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    return p;
  } else {
    #line 97 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
    if (\u03bc->l->hasBoundedDiscrete()) {
      auto r = handle_assume(Delta(\u03bc->r));
      #line 99 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
      return Delta(\u03bc->l - r);
    } else {
      #line 100 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
      if (\u03bc->r->hasBoundedDiscrete()) {
        auto l = handle_assume(Delta(\u03bc->l));
        #line 102 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
        return Delta(l - \u03bc->r);
      } else {
        #line 104 "src/distribution/scalar_enumerate/SubtractDiscreteDeltaDistribution.birch"
        return construct<DeltaDistribution<Subtract<Random<Integer>, Random<Integer>>>>(\u03bc);
      }
    }
  }
}

}
