#line 1 "src/distribution/scalar_gaussian/GaussianDistribution.birch"

#include <boost/math/distributions/normal.hpp>
namespace birch {
#line 75 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
#line 75 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
Real simulate_gaussian(const Real& \u03bc, const Real& \u03c32) {
  #line 76 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
  assert(0.0 <= \u03c32);
  #line 77 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
  if (\u03c32 == 0.0) {
    #line 78 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
    return \u03bc;
  } else {
    #line 80 "src/distribution/scalar_gaussian/GaussianDistribution.birch"

    return std::normal_distribution<Real>(\u03bc, std::sqrt(\u03c32))(rng);
      }
}

#line 108 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
#line 108 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
Real cdf_gaussian(const Real& x, const Real& \u03bc, const Real& \u03c32) {
  #line 109 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
  assert(0.0 < \u03c32);
  #line 110 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
  return 0.5 * (1.0 + erf((x - \u03bc) / sqrt(\u03c32 * 2.0)));
}

#line 122 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
#line 122 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
Real quantile_gaussian(const Real& P, const Real& \u03bc, const Real& \u03c32) {
  #line 123 "src/distribution/scalar_gaussian/GaussianDistribution.birch"
  assert(0.0 < \u03c32);
  #line 124 "src/distribution/scalar_gaussian/GaussianDistribution.birch"

  return boost::math::quantile(boost::math::normal_distribution<>(\u03bc, ::sqrt(\u03c32)), P);
  }

}
namespace birch {
#line 93 "src/distribution/scalar_gaussian/GaussianGaussianDistribution.birch"
#line 93 "src/distribution/scalar_gaussian/GaussianGaussianDistribution.birch"
Real simulate_gaussian_gaussian(const Real& \u03bc, const Real& \u03c32, const Real& s2) {
  #line 94 "src/distribution/scalar_gaussian/GaussianGaussianDistribution.birch"
  return simulate_gaussian(\u03bc, \u03c32 + s2);
}

#line 122 "src/distribution/scalar_gaussian/GaussianGaussianDistribution.birch"
#line 122 "src/distribution/scalar_gaussian/GaussianGaussianDistribution.birch"
Real cdf_gaussian_gaussian(const Real& x, const Real& \u03bc, const Real& \u03c32, const Real& s2) {
  #line 123 "src/distribution/scalar_gaussian/GaussianGaussianDistribution.birch"
  return cdf_gaussian(x, \u03bc, \u03c32 + s2);
}

#line 136 "src/distribution/scalar_gaussian/GaussianGaussianDistribution.birch"
#line 136 "src/distribution/scalar_gaussian/GaussianGaussianDistribution.birch"
Real quantile_gaussian_gaussian(const Real& P, const Real& \u03bc, const Real& \u03c32, const Real& s2) {
  #line 138 "src/distribution/scalar_gaussian/GaussianGaussianDistribution.birch"
  return quantile_gaussian(P, \u03bc, \u03c32 + s2);
}

}
namespace birch {
#line 123 "src/distribution/scalar_gaussian/LinearGaussianGaussianDistribution.birch"
#line 123 "src/distribution/scalar_gaussian/LinearGaussianGaussianDistribution.birch"
Real simulate_linear_gaussian_gaussian(const Real& a, const Real& \u03bc, const Real& \u03c32, const Real& c, const Real& s2) {
  #line 125 "src/distribution/scalar_gaussian/LinearGaussianGaussianDistribution.birch"
  return simulate_gaussian(a * \u03bc + c, a * a * \u03c32 + s2);
}

#line 159 "src/distribution/scalar_gaussian/LinearGaussianGaussianDistribution.birch"
#line 159 "src/distribution/scalar_gaussian/LinearGaussianGaussianDistribution.birch"
Real cdf_linear_gaussian_gaussian(const Real& x, const Real& a, const Real& \u03bc, const Real& \u03c32, const Real& c, const Real& s2) {
  #line 161 "src/distribution/scalar_gaussian/LinearGaussianGaussianDistribution.birch"
  return cdf_gaussian(x, a * \u03bc + c, a * a * \u03c32 + s2);
}

#line 177 "src/distribution/scalar_gaussian/LinearGaussianGaussianDistribution.birch"
#line 177 "src/distribution/scalar_gaussian/LinearGaussianGaussianDistribution.birch"
Real quantile_linear_gaussian_gaussian(const Real& P, const Real& a, const Real& \u03bc, const Real& \u03c32, const Real& c, const Real& s2) {
  #line 179 "src/distribution/scalar_gaussian/LinearGaussianGaussianDistribution.birch"
  return quantile_gaussian(P, a * \u03bc + c, a * a * \u03c32 + s2);
}

}
namespace birch {
#line 124 "src/distribution/scalar_gaussian/LinearMultivariateGaussianGaussianDistribution.birch"
#line 124 "src/distribution/scalar_gaussian/LinearMultivariateGaussianGaussianDistribution.birch"
Real simulate_linear_multivariate_gaussian_gaussian(const libbirch::DefaultArray<Real,1>& a, const libbirch::DefaultArray<Real,1>& \u03bc, const libbirch::DefaultArray<Real,2>& \u03a3, const Real& c, const Real& s2) {
  #line 126 "src/distribution/scalar_gaussian/LinearMultivariateGaussianGaussianDistribution.birch"
  return simulate_gaussian(dot(a, \u03bc) + c, dot(a, \u03a3 * a) + s2);
}

#line 160 "src/distribution/scalar_gaussian/LinearMultivariateGaussianGaussianDistribution.birch"
#line 160 "src/distribution/scalar_gaussian/LinearMultivariateGaussianGaussianDistribution.birch"
Real cdf_linear_multivariate_gaussian_gaussian(const Real& x, const libbirch::DefaultArray<Real,1>& a, const libbirch::DefaultArray<Real,1>& \u03bc, const libbirch::DefaultArray<Real,2>& \u03a3, const Real& c, const Real& s2) {
  #line 162 "src/distribution/scalar_gaussian/LinearMultivariateGaussianGaussianDistribution.birch"
  return cdf_gaussian(x, dot(a, \u03bc) + c, dot(a, \u03a3 * a) + s2);
}

#line 178 "src/distribution/scalar_gaussian/LinearMultivariateGaussianGaussianDistribution.birch"
#line 178 "src/distribution/scalar_gaussian/LinearMultivariateGaussianGaussianDistribution.birch"
Real quantile_linear_multivariate_gaussian_gaussian(const Real& P, const libbirch::DefaultArray<Real,1>& a, const libbirch::DefaultArray<Real,1>& \u03bc, const libbirch::DefaultArray<Real,2>& \u03a3, const Real& c, const Real& s2) {
  #line 180 "src/distribution/scalar_gaussian/LinearMultivariateGaussianGaussianDistribution.birch"
  return quantile_gaussian(P, dot(a, \u03bc) + c, dot(a, \u03a3 * a) + s2);
}

}
