namespace birch {
#line 240 "src/distribution/scalar_normal_inverse_gamma/LinearMultivariateNormalInverseGammaGaussianDistribution.birch"
#line 240 "src/distribution/scalar_normal_inverse_gamma/LinearMultivariateNormalInverseGammaGaussianDistribution.birch"
Real simulate_linear_multivariate_normal_inverse_gamma_gaussian(const libbirch::DefaultArray<Real,1>& a, const libbirch::DefaultArray<Real,1>& \u03bd, const libbirch::DefaultArray<Real,2>& \u039b, const Real& c, const Real& \u03b1, const Real& \u03b2, const Real& s2) {
  auto S = cholinv(\u039b);
  #line 243 "src/distribution/scalar_normal_inverse_gamma/LinearMultivariateNormalInverseGammaGaussianDistribution.birch"
  return simulate_student_t(2.0 * \u03b1, dot(a, S * \u03bd) + c, (\u03b2 / \u03b1) * (s2 + dot(a, S * a)));
}

#line 314 "src/distribution/scalar_normal_inverse_gamma/LinearMultivariateNormalInverseGammaGaussianDistribution.birch"
#line 314 "src/distribution/scalar_normal_inverse_gamma/LinearMultivariateNormalInverseGammaGaussianDistribution.birch"
Real cdf_linear_multivariate_normal_inverse_gamma_gaussian(const Real& x, const libbirch::DefaultArray<Real,1>& a, const libbirch::DefaultArray<Real,1>& \u03bd, const libbirch::DefaultArray<Real,2>& \u039b, const Real& c, const Real& \u03b1, const Real& \u03b2, const Real& s2) {
  auto S = cholinv(\u039b);
  auto \u03bc = S * \u03bd;
  #line 319 "src/distribution/scalar_normal_inverse_gamma/LinearMultivariateNormalInverseGammaGaussianDistribution.birch"
  return cdf_student_t(x, 2.0 * \u03b1, dot(a, \u03bc) + c, (\u03b2 / \u03b1) * (s2 + dot(a, S * a)));
}

#line 337 "src/distribution/scalar_normal_inverse_gamma/LinearMultivariateNormalInverseGammaGaussianDistribution.birch"
#line 337 "src/distribution/scalar_normal_inverse_gamma/LinearMultivariateNormalInverseGammaGaussianDistribution.birch"
Real quantile_linear_multivariate_normal_inverse_gamma_gaussian(const Real& P, const libbirch::DefaultArray<Real,1>& a, const libbirch::DefaultArray<Real,1>& \u03bd, const libbirch::DefaultArray<Real,2>& \u039b, const Real& c, const Real& \u03b1, const Real& \u03b2, const Real& s2) {
  auto S = cholinv(\u039b);
  auto \u03bc = S * \u03bd;
  #line 342 "src/distribution/scalar_normal_inverse_gamma/LinearMultivariateNormalInverseGammaGaussianDistribution.birch"
  return quantile_student_t(P, 2.0 * \u03b1, dot(a, \u03bc) + c, (\u03b2 / \u03b1) * (s2 + dot(a, S * a)));
}

}
namespace birch {
#line 229 "src/distribution/scalar_normal_inverse_gamma/LinearNormalInverseGammaGaussianDistribution.birch"
#line 229 "src/distribution/scalar_normal_inverse_gamma/LinearNormalInverseGammaGaussianDistribution.birch"
Real simulate_linear_normal_inverse_gamma_gaussian(const Real& a, const Real& \u03bd, const Real& \u03bb, const Real& \u03b1, const Real& \u03b2, const Real& c, const Real& s2) {
  #line 231 "src/distribution/scalar_normal_inverse_gamma/LinearNormalInverseGammaGaussianDistribution.birch"
  return simulate_student_t(2.0 * \u03b1, a * \u03bd / \u03bb + c, (\u03b2 / \u03b1) * (s2 + a * a / \u03bb));
}

#line 298 "src/distribution/scalar_normal_inverse_gamma/LinearNormalInverseGammaGaussianDistribution.birch"
#line 298 "src/distribution/scalar_normal_inverse_gamma/LinearNormalInverseGammaGaussianDistribution.birch"
Real cdf_linear_normal_inverse_gamma_gaussian(const Real& x, const Real& a, const Real& \u03bd, const Real& \u03bb, const Real& \u03b1, const Real& \u03b2, const Real& c, const Real& s2) {
  #line 300 "src/distribution/scalar_normal_inverse_gamma/LinearNormalInverseGammaGaussianDistribution.birch"
  return cdf_student_t(x, 2.0 * \u03b1, a * \u03bd / \u03bb + c, (\u03b2 / \u03b1) * (s2 + a * a / \u03bb));
}

#line 318 "src/distribution/scalar_normal_inverse_gamma/LinearNormalInverseGammaGaussianDistribution.birch"
#line 318 "src/distribution/scalar_normal_inverse_gamma/LinearNormalInverseGammaGaussianDistribution.birch"
Real quantile_linear_normal_inverse_gamma_gaussian(const Real& P, const Real& a, const Real& \u03bd, const Real& \u03bb, const Real& \u03b1, const Real& \u03b2, const Real& c, const Real& s2) {
  #line 320 "src/distribution/scalar_normal_inverse_gamma/LinearNormalInverseGammaGaussianDistribution.birch"
  return quantile_student_t(P, 2.0 * \u03b1, a * \u03bd / \u03bb + c, (\u03b2 / \u03b1) * (s2 + a * a / \u03bb));
}

}
namespace birch {
#line 195 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaDistribution.birch"
#line 195 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaDistribution.birch"
Real simulate_normal_inverse_gamma(const Real& \u03bd, const Real& \u03bb, const Real& \u03b1, const Real& \u03b2) {
  #line 197 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaDistribution.birch"
  return simulate_student_t(2.0 * \u03b1, \u03bd / \u03bb, \u03b2 / (\u03b1 * \u03bb));
}

#line 244 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaDistribution.birch"
#line 244 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaDistribution.birch"
Real cdf_normal_inverse_gamma(const Real& x, const Real& \u03bd, const Real& \u03bb, const Real& \u03b1, const Real& \u03b2) {
  #line 246 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaDistribution.birch"
  return cdf_student_t(x, 2.0 * \u03b1, \u03bd / \u03bb, \u03b2 / (\u03b1 * \u03bb));
}

#line 260 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaDistribution.birch"
#line 260 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaDistribution.birch"
Real quantile_normal_inverse_gamma(const Real& P, const Real& \u03bd, const Real& \u03bb, const Real& \u03b1, const Real& \u03b2) {
  #line 262 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaDistribution.birch"
  return quantile_student_t(P, 2.0 * \u03b1, \u03bd / \u03bb, \u03b2 / (\u03b1 * \u03bb));
}

}
namespace birch {
#line 83 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
#line 83 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
Distribution<Real> Gaussian(const Random<Real>& \u03bc, const Random<Real>& \u03c32) {
  #line 84 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
  return Gaussian(\u03bc, 1.0 * \u03c32);
}

#line 130 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
#line 130 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
Distribution<Real> Gaussian(const Random<Real>& \u03bc, const Multiply<Random<Real>, Random<Real>>& \u03c32) {
  #line 132 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
  \u03bc->prune();
  #line 133 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
  if (\u03bc->hasNormalInverseGamma() && \u03bc->isGrandChildOf(\u03c32->l)) {
    auto n4592_ = \u03bc->getNormalInverseGamma();
    auto \u03bd = std::get<0>(n4592_);
    auto \u03bb = std::get<1>(n4592_);
    auto \u03b1 = std::get<2>(n4592_);
    auto \u03b2 = std::get<3>(n4592_);
    auto p = NormalInverseGammaGaussian(\u03bd, \u03bb, \u03b1, \u03b2, \u03c32->r);
    #line 136 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
    \u03bc->graft(p, Integer(1));
    #line 137 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
    \u03c32->l->graftReplace(p, Integer(2));
    #line 138 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
    \u03bc->join(\u03c32->l);
    #line 139 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
    return p;
  } else {
    #line 140 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
    if (\u03bc->hasNormalInverseGamma() && \u03bc->isGrandChildOf(\u03c32->r)) {
      auto n4593_ = \u03bc->getNormalInverseGamma();
      auto \u03bd = std::get<0>(n4593_);
      auto \u03bb = std::get<1>(n4593_);
      auto \u03b1 = std::get<2>(n4593_);
      auto \u03b2 = std::get<3>(n4593_);
      auto p = NormalInverseGammaGaussian(\u03bd, \u03bb, \u03b1, \u03b2, \u03c32->l);
      #line 143 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
      \u03bc->graft(p, Integer(1));
      #line 144 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
      \u03c32->r->graftReplace(p, Integer(2));
      #line 145 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
      \u03bc->join(\u03c32->r);
      #line 146 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
      return p;
    } else {
      #line 148 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
      \u03c32->l->prune();
      #line 149 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
      \u03c32->r->prune();
      #line 150 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
      if (\u03c32->l->hasInverseGamma()) {
        auto n4594_ = \u03c32->l->getInverseGamma();
        auto \u03b1 = std::get<0>(n4594_);
        auto \u03b2 = std::get<1>(n4594_);
        auto p = NormalInverseGamma(\u03bc / \u03c32->r, 1.0 / \u03c32->r, \u03b1, \u03b2);
        #line 153 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
        \u03c32->l->graft(p);
        #line 154 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
        return p;
      } else {
        #line 155 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
        if (\u03c32->r->hasInverseGamma()) {
          auto n4595_ = \u03c32->r->getInverseGamma();
          auto \u03b1 = std::get<0>(n4595_);
          auto \u03b2 = std::get<1>(n4595_);
          auto p = NormalInverseGamma(\u03bc / \u03c32->l, 1.0 / \u03c32->l, \u03b1, \u03b2);
          #line 158 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
          \u03c32->r->graft(p);
          #line 159 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
          return p;
        } else {
          #line 160 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
          if (\u03bc->hasGaussian()) {
            auto n4596_ = \u03bc->getGaussian();
            auto m = std::get<0>(n4596_);
            auto s2 = std::get<1>(n4596_);
            auto p = GaussianGaussian(m, s2, \u03c32);
            #line 163 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
            \u03bc->graft(p);
            #line 164 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
            return p;
          } else {
            #line 166 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
            return construct<GaussianDistribution<Random<Real>, Multiply<Random<Real>, Random<Real>>>>(\u03bc, \u03c32);
          }
        }
      }
    }
  }
}

#line 181 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
#line 181 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
Real simulate_normal_inverse_gamma_gaussian(const Real& \u03bd, const Real& \u03bb, const Real& \u03b1, const Real& \u03b2, const Real& s2) {
  #line 183 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
  return simulate_student_t(2.0 * \u03b1, \u03bd / \u03bb, (\u03b2 / \u03b1) * (s2 + 1.0 / \u03bb));
}

#line 239 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
#line 239 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
Real cdf_normal_inverse_gamma_gaussian(const Real& x, const Real& \u03bd, const Real& \u03bb, const Real& \u03b1, const Real& \u03b2, const Real& s2) {
  #line 241 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
  return cdf_student_t(x, 2.0 * \u03b1, \u03bd / \u03bb, (\u03b2 / \u03b1) * (s2 + 1.0 / \u03bb));
}

#line 256 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
#line 256 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
Real quantile_normal_inverse_gamma_gaussian(const Real& P, const Real& \u03bd, const Real& \u03bb, const Real& \u03b1, const Real& \u03b2, const Real& s2) {
  #line 258 "src/distribution/scalar_normal_inverse_gamma/NormalInverseGammaGaussianDistribution.birch"
  return quantile_student_t(P, 2.0 * \u03b1, \u03bd / \u03bb, (\u03b2 / \u03b1) * (s2 + 1.0 / \u03bb));
}

}
