#line 1 "src/distribution/scalar_other/BetaDistribution.birch"

#include <boost/math/distributions/beta.hpp>
namespace birch {
#line 83 "src/distribution/scalar_other/BetaDistribution.birch"
#line 83 "src/distribution/scalar_other/BetaDistribution.birch"
Real simulate_beta(const Real& \u03b1, const Real& \u03b2) {
  #line 84 "src/distribution/scalar_other/BetaDistribution.birch"
  assert(0.0 < \u03b1);
  #line 85 "src/distribution/scalar_other/BetaDistribution.birch"
  assert(0.0 < \u03b2);
  auto u = simulate_gamma(\u03b1, 1.0);
  auto v = simulate_gamma(\u03b2, 1.0);
  #line 88 "src/distribution/scalar_other/BetaDistribution.birch"
  return u / (u + v);
}

#line 113 "src/distribution/scalar_other/BetaDistribution.birch"
#line 113 "src/distribution/scalar_other/BetaDistribution.birch"
Real cdf_beta(const Real& x, const Real& \u03b1, const Real& \u03b2) {
  #line 114 "src/distribution/scalar_other/BetaDistribution.birch"
  assert(0.0 < \u03b1);
  #line 115 "src/distribution/scalar_other/BetaDistribution.birch"
  assert(0.0 < \u03b2);
  #line 117 "src/distribution/scalar_other/BetaDistribution.birch"
  if (x < 0.0) {
    #line 118 "src/distribution/scalar_other/BetaDistribution.birch"
    return 0.0;
  } else {
    #line 119 "src/distribution/scalar_other/BetaDistribution.birch"
    if (x > 1.0) {
      #line 120 "src/distribution/scalar_other/BetaDistribution.birch"
      return 1.0;
    } else {
      #line 122 "src/distribution/scalar_other/BetaDistribution.birch"
      return ibeta(\u03b1, \u03b2, x);
    }
  }
}

#line 135 "src/distribution/scalar_other/BetaDistribution.birch"
#line 135 "src/distribution/scalar_other/BetaDistribution.birch"
Real quantile_beta(const Real& P, const Real& \u03b1, const Real& \u03b2) {
  #line 136 "src/distribution/scalar_other/BetaDistribution.birch"
  assert(0.0 < \u03b1);
  #line 137 "src/distribution/scalar_other/BetaDistribution.birch"
  assert(0.0 < \u03b2);
  #line 138 "src/distribution/scalar_other/BetaDistribution.birch"

  return boost::math::quantile(boost::math::beta_distribution<>(\u03b1, \u03b2), P);
  }

}
#line 1 "src/distribution/scalar_other/ChiSquaredDistribution.birch"

#include <boost/math/distributions/chi_squared.hpp>
namespace birch {
#line 10 "src/distribution/scalar_other/ChiSquaredDistribution.birch"
#line 10 "src/distribution/scalar_other/ChiSquaredDistribution.birch"
Real simulate_chi_squared(const Real& \u03bd) {
  #line 11 "src/distribution/scalar_other/ChiSquaredDistribution.birch"
  assert(0.0 < \u03bd);
  #line 12 "src/distribution/scalar_other/ChiSquaredDistribution.birch"

  return std::chi_squared_distribution<Real>(\u03bd)(rng);
  }

#line 38 "src/distribution/scalar_other/ChiSquaredDistribution.birch"
#line 38 "src/distribution/scalar_other/ChiSquaredDistribution.birch"
Real cdf_chi_squared(const Real& x, const Real& \u03bd) {
  #line 39 "src/distribution/scalar_other/ChiSquaredDistribution.birch"
  assert(0.0 < \u03bd);
  #line 40 "src/distribution/scalar_other/ChiSquaredDistribution.birch"
  return lower_inc_gamma(0.5 * \u03bd, 0.5 * x) / tgamma(0.5 * \u03bd);
}

#line 51 "src/distribution/scalar_other/ChiSquaredDistribution.birch"
#line 51 "src/distribution/scalar_other/ChiSquaredDistribution.birch"
Real quantile_chi_squared(const Real& P, const Real& \u03bd) {
  #line 52 "src/distribution/scalar_other/ChiSquaredDistribution.birch"
  assert(0.0 < \u03bd);
  #line 53 "src/distribution/scalar_other/ChiSquaredDistribution.birch"

  return boost::math::quantile(boost::math::chi_squared_distribution<>(\u03bd), P);
  }

}
#line 1 "src/distribution/scalar_other/ExponentialDistribution.birch"

#include <boost/math/distributions/exponential.hpp>
namespace birch {
#line 64 "src/distribution/scalar_other/ExponentialDistribution.birch"
#line 64 "src/distribution/scalar_other/ExponentialDistribution.birch"
Real simulate_exponential(const Real& \u03bb) {
  #line 65 "src/distribution/scalar_other/ExponentialDistribution.birch"
  assert(0.0 < \u03bb);
  #line 66 "src/distribution/scalar_other/ExponentialDistribution.birch"

  return std::exponential_distribution<Real>(\u03bb)(rng);
  }

#line 91 "src/distribution/scalar_other/ExponentialDistribution.birch"
#line 91 "src/distribution/scalar_other/ExponentialDistribution.birch"
Real cdf_exponential(const Real& x, const Real& \u03bb) {
  #line 92 "src/distribution/scalar_other/ExponentialDistribution.birch"
  assert(0.0 < \u03bb);
  #line 93 "src/distribution/scalar_other/ExponentialDistribution.birch"
  if (x <= 0.0) {
    #line 94 "src/distribution/scalar_other/ExponentialDistribution.birch"
    return 0.0;
  } else {
    #line 96 "src/distribution/scalar_other/ExponentialDistribution.birch"
    return -(expm1(-(\u03bb) * x));
  }
}

#line 108 "src/distribution/scalar_other/ExponentialDistribution.birch"
#line 108 "src/distribution/scalar_other/ExponentialDistribution.birch"
Real quantile_exponential(const Real& P, const Real& \u03bb) {
  #line 109 "src/distribution/scalar_other/ExponentialDistribution.birch"
  assert(0.0 < \u03bb);
  #line 110 "src/distribution/scalar_other/ExponentialDistribution.birch"

  return boost::math::quantile(boost::math::exponential_distribution<>(\u03bb), P);
  }

}
#line 1 "src/distribution/scalar_other/GammaDistribution.birch"

#include <boost/math/distributions/gamma.hpp>
namespace birch {
#line 79 "src/distribution/scalar_other/GammaDistribution.birch"
#line 79 "src/distribution/scalar_other/GammaDistribution.birch"
Real simulate_gamma(const Real& k, const Real& \u03b8) {
  #line 80 "src/distribution/scalar_other/GammaDistribution.birch"
  assert(0.0 < k);
  #line 81 "src/distribution/scalar_other/GammaDistribution.birch"
  assert(0.0 < \u03b8);
  #line 82 "src/distribution/scalar_other/GammaDistribution.birch"

  return std::gamma_distribution<Real>(k, \u03b8)(rng);
  }

#line 110 "src/distribution/scalar_other/GammaDistribution.birch"
#line 110 "src/distribution/scalar_other/GammaDistribution.birch"
Real cdf_gamma(const Real& x, const Real& k, const Real& \u03b8) {
  #line 111 "src/distribution/scalar_other/GammaDistribution.birch"
  assert(0.0 < k);
  #line 112 "src/distribution/scalar_other/GammaDistribution.birch"
  assert(0.0 < \u03b8);
  #line 114 "src/distribution/scalar_other/GammaDistribution.birch"
  if (x <= 0.0) {
    #line 115 "src/distribution/scalar_other/GammaDistribution.birch"
    return 0.0;
  } else {
    #line 117 "src/distribution/scalar_other/GammaDistribution.birch"
    return lower_inc_gamma(k, x / \u03b8);
  }
}

#line 130 "src/distribution/scalar_other/GammaDistribution.birch"
#line 130 "src/distribution/scalar_other/GammaDistribution.birch"
Real quantile_gamma(const Real& P, const Real& k, const Real& \u03b8) {
  #line 131 "src/distribution/scalar_other/GammaDistribution.birch"
  assert(0.0 < k);
  #line 132 "src/distribution/scalar_other/GammaDistribution.birch"
  assert(0.0 < \u03b8);
  #line 133 "src/distribution/scalar_other/GammaDistribution.birch"

  return boost::math::quantile(boost::math::gamma_distribution<>(k, \u03b8), P);
  }

}
#line 1 "src/distribution/scalar_other/GammaExponentialDistribution.birch"

#include <boost/math/distributions/pareto.hpp>
namespace birch {
#line 67 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
#line 67 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
Distribution<Real> Exponential(const Random<Real>& \u03bb) {
  #line 68 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
  \u03bb->prune();
  #line 69 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
  if (\u03bb->hasGamma()) {
    auto n4597_ = \u03bb->getGamma();
    auto k = std::get<0>(n4597_);
    auto \u03b8 = std::get<1>(n4597_);
    auto p = GammaExponential(k, \u03b8);
    #line 72 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
    \u03bb->graft(p);
    #line 73 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
    return p;
  } else {
    #line 75 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
    return construct<ExponentialDistribution<Random<Real>>>(\u03bb);
  }
}

#line 85 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
#line 85 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
Real simulate_lomax(const Real& \u03bb, const Real& \u03b1) {
  #line 86 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
  assert(0.0 < \u03bb);
  #line 87 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
  assert(0.0 < \u03b1);
  auto u = simulate_uniform(0.0, 1.0);
  #line 89 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
  return \u03bb * (pow(u, -(1.0) / \u03b1) - 1.0);
}

#line 129 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
#line 129 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
Real cdf_lomax(const Real& x, const Real& \u03bb, const Real& \u03b1) {
  #line 130 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
  assert(0.0 < \u03bb);
  #line 131 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
  assert(0.0 < \u03b1);
  #line 132 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
  if (x <= 0.0) {
    #line 133 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
    return 0.0;
  } else {
    #line 135 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
    return 1.0 - pow((1.0 + x / \u03bb), -(\u03b1));
  }
}

#line 148 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
#line 148 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
Real quantile_lomax(const Real& P, const Real& \u03bb, const Real& \u03b1) {
  #line 149 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
  assert(0.0 < \u03bb);
  #line 150 "src/distribution/scalar_other/GammaExponentialDistribution.birch"
  assert(0.0 < \u03b1);
  #line 151 "src/distribution/scalar_other/GammaExponentialDistribution.birch"

  return boost::math::quantile(boost::math::pareto_distribution<>(\u03bb, \u03b1), P) - \u03bb;
  }

}
#line 1 "src/distribution/scalar_other/InverseGammaDistribution.birch"

#include <boost/math/distributions/inverse_gamma.hpp>
namespace birch {
#line 79 "src/distribution/scalar_other/InverseGammaDistribution.birch"
#line 79 "src/distribution/scalar_other/InverseGammaDistribution.birch"
Real simulate_inverse_gamma(const Real& \u03b1, const Real& \u03b2) {
  #line 80 "src/distribution/scalar_other/InverseGammaDistribution.birch"
  return 1.0 / simulate_gamma(\u03b1, 1.0 / \u03b2);
}

#line 106 "src/distribution/scalar_other/InverseGammaDistribution.birch"
#line 106 "src/distribution/scalar_other/InverseGammaDistribution.birch"
Real cdf_inverse_gamma(const Real& x, const Real& \u03b1, const Real& \u03b2) {
  #line 107 "src/distribution/scalar_other/InverseGammaDistribution.birch"
  assert(0.0 < \u03b1);
  #line 108 "src/distribution/scalar_other/InverseGammaDistribution.birch"
  assert(0.0 < \u03b2);
  #line 110 "src/distribution/scalar_other/InverseGammaDistribution.birch"
  if (x <= 0.0) {
    #line 111 "src/distribution/scalar_other/InverseGammaDistribution.birch"
    return 0.0;
  } else {
    #line 113 "src/distribution/scalar_other/InverseGammaDistribution.birch"
    return upper_inc_gamma(\u03b1, \u03b2 / x);
  }
}

#line 126 "src/distribution/scalar_other/InverseGammaDistribution.birch"
#line 126 "src/distribution/scalar_other/InverseGammaDistribution.birch"
Real quantile_inverse_gamma(const Real& P, const Real& \u03b1, const Real& \u03b2) {
  #line 127 "src/distribution/scalar_other/InverseGammaDistribution.birch"
  assert(0.0 < \u03b1);
  #line 128 "src/distribution/scalar_other/InverseGammaDistribution.birch"
  assert(0.0 < \u03b2);
  #line 129 "src/distribution/scalar_other/InverseGammaDistribution.birch"
  if (P == 0.0) {
    #line 130 "src/distribution/scalar_other/InverseGammaDistribution.birch"
    return 0.0;
  } else {
    #line 132 "src/distribution/scalar_other/InverseGammaDistribution.birch"

    return boost::math::quantile(boost::math::inverse_gamma_distribution<>(\u03b1, \u03b2), P);
      }
}

}
namespace birch {
#line 84 "src/distribution/scalar_other/InverseGammaGammaDistribution.birch"
#line 84 "src/distribution/scalar_other/InverseGammaGammaDistribution.birch"
Real simulate_inverse_gamma_gamma(const Real& k, const Real& \u03b1, const Real& \u03b2) {
  #line 85 "src/distribution/scalar_other/InverseGammaGammaDistribution.birch"
  return simulate_gamma(k, simulate_inverse_gamma(\u03b1, \u03b2));
}

#line 129 "src/distribution/scalar_other/InverseGammaGammaDistribution.birch"
#line 129 "src/distribution/scalar_other/InverseGammaGammaDistribution.birch"
Real cdf_inverse_gamma_gamma(const Real& x, const Real& k, const Real& \u03b1, const Real& \u03b2) {
  #line 130 "src/distribution/scalar_other/InverseGammaGammaDistribution.birch"
  if (x <= 0.0) {
    #line 131 "src/distribution/scalar_other/InverseGammaGammaDistribution.birch"
    return 0.0;
  } else {
    #line 133 "src/distribution/scalar_other/InverseGammaGammaDistribution.birch"
    return ibeta(k, \u03b1, x / (\u03b2 + x));
  }
}

}
namespace birch {
#line 101 "src/distribution/scalar_other/ScaledGammaExponentialDistribution.birch"
#line 101 "src/distribution/scalar_other/ScaledGammaExponentialDistribution.birch"
Distribution<Real> Exponential(const Multiply<Random<Real>, Random<Real>>& \u03bb) {
  #line 103 "src/distribution/scalar_other/ScaledGammaExponentialDistribution.birch"
  \u03bb->l->prune();
  #line 104 "src/distribution/scalar_other/ScaledGammaExponentialDistribution.birch"
  if (\u03bb->l->hasGamma()) {
    auto n4598_ = \u03bb->l->getGamma();
    auto k = std::get<0>(n4598_);
    auto \u03b8 = std::get<1>(n4598_);
    auto p = ScaledGammaExponential(\u03bb->r, k, \u03b8);
    #line 107 "src/distribution/scalar_other/ScaledGammaExponentialDistribution.birch"
    \u03bb->l->graft(p);
    #line 108 "src/distribution/scalar_other/ScaledGammaExponentialDistribution.birch"
    return p;
  } else {
    #line 110 "src/distribution/scalar_other/ScaledGammaExponentialDistribution.birch"
    \u03bb->r->prune();
    #line 111 "src/distribution/scalar_other/ScaledGammaExponentialDistribution.birch"
    if (\u03bb->r->hasGamma()) {
      auto n4599_ = \u03bb->r->getGamma();
      auto k = std::get<0>(n4599_);
      auto \u03b8 = std::get<1>(n4599_);
      auto p = ScaledGammaExponential(\u03bb->l, k, \u03b8);
      #line 114 "src/distribution/scalar_other/ScaledGammaExponentialDistribution.birch"
      \u03bb->r->graft(p);
      #line 115 "src/distribution/scalar_other/ScaledGammaExponentialDistribution.birch"
      return p;
    } else {
      #line 117 "src/distribution/scalar_other/ScaledGammaExponentialDistribution.birch"
      return construct<ExponentialDistribution<Multiply<Random<Real>, Random<Real>>>>(\u03bb);
    }
  }
}

}
#line 1 "src/distribution/scalar_other/StudentDistribution.birch"

#include <boost/math/distributions/students_t.hpp>
namespace birch {
#line 80 "src/distribution/scalar_other/StudentDistribution.birch"
#line 80 "src/distribution/scalar_other/StudentDistribution.birch"
Real simulate_student_t(const Real& k) {
  #line 81 "src/distribution/scalar_other/StudentDistribution.birch"
  assert(0.0 < k);
  #line 82 "src/distribution/scalar_other/StudentDistribution.birch"

  return std::student_t_distribution<Real>(k)(rng);
  }

#line 94 "src/distribution/scalar_other/StudentDistribution.birch"
#line 94 "src/distribution/scalar_other/StudentDistribution.birch"
Real simulate_student_t(const Real& k, const Real& \u03bc, const Real& v) {
  #line 95 "src/distribution/scalar_other/StudentDistribution.birch"
  return \u03bc + sqrt(v) * simulate_student_t(k);
}

#line 138 "src/distribution/scalar_other/StudentDistribution.birch"
#line 138 "src/distribution/scalar_other/StudentDistribution.birch"
Real cdf_student_t(const Real& x, const Real& \u03bd) {
  #line 139 "src/distribution/scalar_other/StudentDistribution.birch"
  assert(0.0 < \u03bd);
  auto t = 0.5 * x / sqrt(x * x + \u03bd) + 0.5;
  auto prob = ibeta(0.5 * \u03bd, 0.5 * \u03bd, t);
  #line 142 "src/distribution/scalar_other/StudentDistribution.birch"
  return prob;
}

#line 155 "src/distribution/scalar_other/StudentDistribution.birch"
#line 155 "src/distribution/scalar_other/StudentDistribution.birch"
Real cdf_student_t(const Real& x, const Real& k, const Real& \u03bc, const Real& \u03c32) {
  #line 156 "src/distribution/scalar_other/StudentDistribution.birch"
  assert(0.0 < \u03c32);
  #line 157 "src/distribution/scalar_other/StudentDistribution.birch"
  return cdf_student_t((x - \u03bc) / sqrt(\u03c32), k);
}

#line 168 "src/distribution/scalar_other/StudentDistribution.birch"
#line 168 "src/distribution/scalar_other/StudentDistribution.birch"
Real quantile_student_t(const Real& P, const Real& \u03bd) {
  #line 169 "src/distribution/scalar_other/StudentDistribution.birch"
  assert(0.0 < \u03bd);
  #line 170 "src/distribution/scalar_other/StudentDistribution.birch"

  return boost::math::quantile(boost::math::students_t_distribution<>(\u03bd), P);
  }

#line 185 "src/distribution/scalar_other/StudentDistribution.birch"
#line 185 "src/distribution/scalar_other/StudentDistribution.birch"
Real quantile_student_t(const Real& P, const Real& \u03bd, const Real& \u03bc, const Real& \u03c32) {
  #line 186 "src/distribution/scalar_other/StudentDistribution.birch"
  assert(0.0 < \u03c32);
  #line 187 "src/distribution/scalar_other/StudentDistribution.birch"
  return quantile_student_t(P, \u03bd) * sqrt(\u03c32) + \u03bc;
}

}
#line 1 "src/distribution/scalar_other/UniformDistribution.birch"

#include <boost/math/distributions/uniform.hpp>
namespace birch {
#line 67 "src/distribution/scalar_other/UniformDistribution.birch"
#line 67 "src/distribution/scalar_other/UniformDistribution.birch"
Real simulate_uniform(const Real& l, const Real& u) {
  #line 68 "src/distribution/scalar_other/UniformDistribution.birch"
  assert(l <= u);
  #line 69 "src/distribution/scalar_other/UniformDistribution.birch"

  return std::uniform_real_distribution<Real>(l, u)(rng);
  }

#line 83 "src/distribution/scalar_other/UniformDistribution.birch"
#line 83 "src/distribution/scalar_other/UniformDistribution.birch"
Real logpdf_uniform(const Real& x, const Real& l, const Real& u) {
  #line 84 "src/distribution/scalar_other/UniformDistribution.birch"
  assert(l <= u);
  #line 85 "src/distribution/scalar_other/UniformDistribution.birch"
  if (x >= l && x <= u) {
    #line 86 "src/distribution/scalar_other/UniformDistribution.birch"
    return -(log(u - l));
  } else {
    #line 88 "src/distribution/scalar_other/UniformDistribution.birch"
    return -(std::numeric_limits<double>::infinity());
  }
}

#line 101 "src/distribution/scalar_other/UniformDistribution.birch"
#line 101 "src/distribution/scalar_other/UniformDistribution.birch"
Real cdf_uniform(const Real& x, const Real& l, const Real& u) {
  #line 102 "src/distribution/scalar_other/UniformDistribution.birch"
  assert(l <= u);
  #line 103 "src/distribution/scalar_other/UniformDistribution.birch"
  if (x <= l) {
    #line 104 "src/distribution/scalar_other/UniformDistribution.birch"
    return 0.0;
  } else {
    #line 105 "src/distribution/scalar_other/UniformDistribution.birch"
    if (x > u) {
      #line 106 "src/distribution/scalar_other/UniformDistribution.birch"
      return 1.0;
    } else {
      #line 108 "src/distribution/scalar_other/UniformDistribution.birch"
      return (x - l) / (u - l);
    }
  }
}

#line 121 "src/distribution/scalar_other/UniformDistribution.birch"
#line 121 "src/distribution/scalar_other/UniformDistribution.birch"
Real quantile_uniform(const Real& P, const Real& l, const Real& u) {
  #line 122 "src/distribution/scalar_other/UniformDistribution.birch"
  assert(l <= u);
  #line 123 "src/distribution/scalar_other/UniformDistribution.birch"
  return l + P * (u - l);
}

}
#line 1 "src/distribution/scalar_other/WeibullDistribution.birch"

#include <boost/math/distributions/weibull.hpp>
namespace birch {
#line 71 "src/distribution/scalar_other/WeibullDistribution.birch"
#line 71 "src/distribution/scalar_other/WeibullDistribution.birch"
Real simulate_weibull(const Real& k, const Real& \u03bb) {
  #line 72 "src/distribution/scalar_other/WeibullDistribution.birch"
  assert(0.0 < k);
  #line 73 "src/distribution/scalar_other/WeibullDistribution.birch"
  assert(0.0 < \u03bb);
  #line 74 "src/distribution/scalar_other/WeibullDistribution.birch"

  return std::weibull_distribution<Real>(k, \u03bb)(rng);
  }

#line 102 "src/distribution/scalar_other/WeibullDistribution.birch"
#line 102 "src/distribution/scalar_other/WeibullDistribution.birch"
Real cdf_weibull(const Real& x, const Real& k, const Real& \u03bb) {
  #line 103 "src/distribution/scalar_other/WeibullDistribution.birch"
  assert(0.0 < k);
  #line 104 "src/distribution/scalar_other/WeibullDistribution.birch"
  assert(0.0 < \u03bb);
  #line 105 "src/distribution/scalar_other/WeibullDistribution.birch"
  if (x >= Integer(0)) {
    #line 106 "src/distribution/scalar_other/WeibullDistribution.birch"
    return -(expm1(-(pow(x / \u03bb, k))));
  } else {
    #line 108 "src/distribution/scalar_other/WeibullDistribution.birch"
    return Integer(0);
  }
}

#line 121 "src/distribution/scalar_other/WeibullDistribution.birch"
#line 121 "src/distribution/scalar_other/WeibullDistribution.birch"
Real quantile_weibull(const Real& P, const Real& k, const Real& \u03bb) {
  #line 122 "src/distribution/scalar_other/WeibullDistribution.birch"
  assert(0.0 < k);
  #line 123 "src/distribution/scalar_other/WeibullDistribution.birch"
  assert(0.0 < \u03bb);
  #line 124 "src/distribution/scalar_other/WeibullDistribution.birch"

  return boost::math::quantile(boost::math::weibull_distribution<>(k, \u03bb), P);
  }

}
