namespace birch {
#line 1 "src/filter/AliveParticleFilter.birch"
#line 1 "src/filter/AliveParticleFilter.birch"
AliveParticleFilter_::AliveParticleFilter_() :
    #line 1 "src/filter/AliveParticleFilter.birch"
    base_type_(),
    #line 19 "src/filter/AliveParticleFilter.birch"
    p() {
  //
}

#line 21 "src/filter/AliveParticleFilter.birch"
#line 21 "src/filter/AliveParticleFilter.birch"
#line 21 "src/filter/AliveParticleFilter.birch"
void AliveParticleFilter_::simulate(const Integer& t, const Buffer& input) {
  #line 22 "src/filter/AliveParticleFilter.birch"
  a = resample_systematic(w);
  #line 23 "src/filter/AliveParticleFilter.birch"
  p = vector(Integer(0), nparticles);
  auto x0 = x;
  auto w0 = w;
  #line 30 "src/filter/AliveParticleFilter.birch"
  #pragma omp parallel
  {
    #pragma omp for schedule(static)
    for (auto n = Integer(1); n <= nparticles; ++n) {
      #line 31 "src/filter/AliveParticleFilter.birch"
      bridge(x0(n));
    }
  }
  #line 35 "src/filter/AliveParticleFilter.birch"
  #pragma omp parallel
  {
    #pragma omp for schedule(static)
    for (auto n = Integer(1); n <= nparticles; ++n) {
      #line 36 "src/filter/AliveParticleFilter.birch"
      do {
        #line 37 "src/filter/AliveParticleFilter.birch"
        x(n) = birch::copy(x0(a(n)));
        #line 38 "src/filter/AliveParticleFilter.birch"
        p(n) = p(n) + Integer(1);
        auto m = x(n)->m;
        auto h = x(n)->h;
        #line 42 "src/filter/AliveParticleFilter.birch"
        {
          auto handler_ = swap_handler(h);
          #line 43 "src/filter/AliveParticleFilter.birch"
          h->w = 0.0;
          #line 44 "src/filter/AliveParticleFilter.birch"
          x(n)->m->read(t, input);
          #line 45 "src/filter/AliveParticleFilter.birch"
          x(n)->m->simulate(t);
          #line 46 "src/filter/AliveParticleFilter.birch"
          w(n) = h->w;
          set_handler(handler_);
        }
        #line 48 "src/filter/AliveParticleFilter.birch"
        if (!(isfinite(w(n)))) {
          #line 49 "src/filter/AliveParticleFilter.birch"
          a(n) = birch::ancestor(w0);
        }
      } while (!(isfinite(w(n))));
    }
  }
  #line 53 "src/filter/AliveParticleFilter.birch"
  collect();
  #line 57 "src/filter/AliveParticleFilter.birch"
  w(simulate_uniform_int(Integer(1), nparticles)) = -(std::numeric_limits<double>::infinity());
}

#line 60 "src/filter/AliveParticleFilter.birch"
#line 60 "src/filter/AliveParticleFilter.birch"
#line 60 "src/filter/AliveParticleFilter.birch"
void AliveParticleFilter_::resample(const Integer& t) {
  #line 63 "src/filter/AliveParticleFilter.birch"
  a = iota(Integer(1), nparticles);
  #line 64 "src/filter/AliveParticleFilter.birch"
  w = w - vector(lsum - log(nparticles), nparticles);
}

#line 67 "src/filter/AliveParticleFilter.birch"
#line 67 "src/filter/AliveParticleFilter.birch"
#line 67 "src/filter/AliveParticleFilter.birch"
void AliveParticleFilter_::reduce() {
  #line 68 "src/filter/AliveParticleFilter.birch"
  this->base_type_::reduce();
  #line 69 "src/filter/AliveParticleFilter.birch"
  npropagations = sum(p);
}

#line 1 "src/filter/AliveParticleFilter.birch"
AliveParticleFilter_* make_AliveParticleFilter_() {
  #line 1 "src/filter/AliveParticleFilter.birch"
  return new AliveParticleFilter_();
  #line 1 "src/filter/AliveParticleFilter.birch"
}

}
namespace birch {
#line 1 "src/filter/Particle.birch"
#line 1 "src/filter/Particle.birch"
Particle_::Particle_(const Model& m, const Boolean& delaySampling, const Boolean& delayExpressions) :
    #line 1 "src/filter/Particle.birch"
    base_type_(),
    #line 12 "src/filter/Particle.birch"
    m(m),
    #line 17 "src/filter/Particle.birch"
    h(std::in_place, delaySampling, delayExpressions) {
  //
}

#line 22 "src/filter/Particle.birch"
#line 22 "src/filter/Particle.birch"
#line 22 "src/filter/Particle.birch"
Real Particle_::peek() {
  #line 23 "src/filter/Particle.birch"
  return h->peek();
}

#line 29 "src/filter/Particle.birch"
#line 29 "src/filter/Particle.birch"
#line 29 "src/filter/Particle.birch"
libbirch::DefaultArray<Real,1> Particle_::args() {
  #line 30 "src/filter/Particle.birch"
  return h->args();
}

#line 36 "src/filter/Particle.birch"
#line 36 "src/filter/Particle.birch"
#line 36 "src/filter/Particle.birch"
libbirch::DefaultArray<Real,1> Particle_::grad() {
  #line 37 "src/filter/Particle.birch"
  return h->grad();
}

#line 43 "src/filter/Particle.birch"
#line 43 "src/filter/Particle.birch"
#line 43 "src/filter/Particle.birch"
Real Particle_::move(const libbirch::DefaultArray<Real,1>& x) {
  #line 44 "src/filter/Particle.birch"
  return h->move(x);
}

#line 52 "src/filter/Particle.birch"
#line 52 "src/filter/Particle.birch"
#line 52 "src/filter/Particle.birch"
void Particle_::label(const Integer& gen) {
  #line 53 "src/filter/Particle.birch"
  h->label(gen);
}

#line 61 "src/filter/Particle.birch"
#line 61 "src/filter/Particle.birch"
#line 61 "src/filter/Particle.birch"
void Particle_::constant(const Integer& gen) {
  #line 62 "src/filter/Particle.birch"
  h->constant(gen);
}

#line 65 "src/filter/Particle.birch"
#line 65 "src/filter/Particle.birch"
#line 65 "src/filter/Particle.birch"
void Particle_::read(const Buffer& buffer) {
  #line 66 "src/filter/Particle.birch"
  {
    auto handler_ = swap_handler(h);
    #line 67 "src/filter/Particle.birch"
    m->read(buffer);
    set_handler(handler_);
  }
}

#line 71 "src/filter/Particle.birch"
#line 71 "src/filter/Particle.birch"
#line 71 "src/filter/Particle.birch"
void Particle_::write(const Buffer& buffer) {
  #line 72 "src/filter/Particle.birch"
  {
    auto handler_ = swap_handler(h);
    #line 73 "src/filter/Particle.birch"
    m->write(buffer);
    set_handler(handler_);
  }
}

#line 77 "src/filter/Particle.birch"
#line 77 "src/filter/Particle.birch"
#line 77 "src/filter/Particle.birch"
void Particle_::read(const Integer& t, const Buffer& buffer) {
  #line 78 "src/filter/Particle.birch"
  {
    auto handler_ = swap_handler(h);
    #line 79 "src/filter/Particle.birch"
    m->read(t, buffer);
    set_handler(handler_);
  }
}

#line 83 "src/filter/Particle.birch"
#line 83 "src/filter/Particle.birch"
#line 83 "src/filter/Particle.birch"
void Particle_::write(const Integer& t, const Buffer& buffer) {
  #line 84 "src/filter/Particle.birch"
  {
    auto handler_ = swap_handler(h);
    #line 85 "src/filter/Particle.birch"
    m->write(t, buffer);
    set_handler(handler_);
  }
}

}
namespace birch {
#line 1 "src/filter/ParticleFilter.birch"
#line 1 "src/filter/ParticleFilter.birch"
ParticleFilter_::ParticleFilter_() :
    #line 1 "src/filter/ParticleFilter.birch"
    base_type_(),
    #line 15 "src/filter/ParticleFilter.birch"
    x(),
    #line 20 "src/filter/ParticleFilter.birch"
    w(),
    #line 25 "src/filter/ParticleFilter.birch"
    a(),
    #line 31 "src/filter/ParticleFilter.birch"
    b(Integer(0)),
    #line 36 "src/filter/ParticleFilter.birch"
    lsum(0.0),
    #line 41 "src/filter/ParticleFilter.birch"
    ess(0.0),
    #line 46 "src/filter/ParticleFilter.birch"
    lnormalize(0.0),
    #line 54 "src/filter/ParticleFilter.birch"
    npropagations(Integer(0)),
    #line 59 "src/filter/ParticleFilter.birch"
    raccepts(0.0),
    #line 64 "src/filter/ParticleFilter.birch"
    nparticles(Integer(1)),
    #line 71 "src/filter/ParticleFilter.birch"
    trigger(0.7),
    #line 76 "src/filter/ParticleFilter.birch"
    delayed(true),
    #line 81 "src/filter/ParticleFilter.birch"
    autodiff(false) {
  //
}

#line 86 "src/filter/ParticleFilter.birch"
#line 86 "src/filter/ParticleFilter.birch"
#line 86 "src/filter/ParticleFilter.birch"
Particle ParticleFilter_::particle(const Model& model) {
  #line 87 "src/filter/ParticleFilter.birch"
  return construct<Particle>(model, delayed, autodiff);
}

#line 96 "src/filter/ParticleFilter.birch"
#line 96 "src/filter/ParticleFilter.birch"
#line 96 "src/filter/ParticleFilter.birch"
void ParticleFilter_::filter(const Model& model, const Buffer& input) {
  #line 97 "src/filter/ParticleFilter.birch"
  x = birch::copy(particle(model), nparticles);
  #line 98 "src/filter/ParticleFilter.birch"
  w = vector(0.0, nparticles);
  #line 99 "src/filter/ParticleFilter.birch"
  a = iota(Integer(1), nparticles);
  #line 100 "src/filter/ParticleFilter.birch"
  b = Integer(1);
  #line 101 "src/filter/ParticleFilter.birch"
  ess = nparticles;
  #line 102 "src/filter/ParticleFilter.birch"
  lsum = 0.0;
  #line 103 "src/filter/ParticleFilter.birch"
  lnormalize = 0.0;
  #line 104 "src/filter/ParticleFilter.birch"
  npropagations = nparticles;
  #line 105 "src/filter/ParticleFilter.birch"
  simulate(input);
  #line 106 "src/filter/ParticleFilter.birch"
  reduce();
}

#line 115 "src/filter/ParticleFilter.birch"
#line 115 "src/filter/ParticleFilter.birch"
#line 115 "src/filter/ParticleFilter.birch"
void ParticleFilter_::filter(const Integer& t, const Buffer& input) {
  #line 116 "src/filter/ParticleFilter.birch"
  resample(t);
  #line 117 "src/filter/ParticleFilter.birch"
  simulate(t, input);
  #line 118 "src/filter/ParticleFilter.birch"
  reduce();
}

#line 128 "src/filter/ParticleFilter.birch"
#line 128 "src/filter/ParticleFilter.birch"
#line 128 "src/filter/ParticleFilter.birch"
void ParticleFilter_::filter(const Integer& t, const Buffer& input, const Kernel& \u03ba) {
  #line 129 "src/filter/ParticleFilter.birch"
  resample(t);
  #line 130 "src/filter/ParticleFilter.birch"
  move(t, \u03ba);
  #line 131 "src/filter/ParticleFilter.birch"
  simulate(t, input);
  #line 132 "src/filter/ParticleFilter.birch"
  reduce();
}

#line 138 "src/filter/ParticleFilter.birch"
#line 138 "src/filter/ParticleFilter.birch"
#line 138 "src/filter/ParticleFilter.birch"
void ParticleFilter_::simulate(const Buffer& input) {
  #line 139 "src/filter/ParticleFilter.birch"
  #pragma omp parallel
  {
    #pragma omp for schedule(static)
    for (auto n = Integer(1); n <= nparticles; ++n) {
      auto m = x(n)->m;
      auto h = x(n)->h;
      #line 142 "src/filter/ParticleFilter.birch"
      {
        auto handler_ = swap_handler(h);
        #line 143 "src/filter/ParticleFilter.birch"
        h->w = 0.0;
        #line 144 "src/filter/ParticleFilter.birch"
        m->read(input);
        #line 145 "src/filter/ParticleFilter.birch"
        m->simulate();
        #line 146 "src/filter/ParticleFilter.birch"
        w(n) = w(n) + h->w;
        set_handler(handler_);
      }
    }
  }
}

#line 154 "src/filter/ParticleFilter.birch"
#line 154 "src/filter/ParticleFilter.birch"
#line 154 "src/filter/ParticleFilter.birch"
void ParticleFilter_::simulate(const Integer& t, const Buffer& input) {
  #line 155 "src/filter/ParticleFilter.birch"
  #pragma omp parallel
  {
    #pragma omp for schedule(static)
    for (auto n = Integer(1); n <= nparticles; ++n) {
      auto m = x(n)->m;
      auto h = x(n)->h;
      #line 158 "src/filter/ParticleFilter.birch"
      {
        auto handler_ = swap_handler(h);
        #line 159 "src/filter/ParticleFilter.birch"
        h->w = 0.0;
        #line 160 "src/filter/ParticleFilter.birch"
        m->read(t, input);
        #line 161 "src/filter/ParticleFilter.birch"
        m->simulate(t);
        #line 162 "src/filter/ParticleFilter.birch"
        w(n) = w(n) + h->w;
        set_handler(handler_);
      }
    }
  }
}

#line 171 "src/filter/ParticleFilter.birch"
#line 171 "src/filter/ParticleFilter.birch"
#line 171 "src/filter/ParticleFilter.birch"
void ParticleFilter_::reduce() {
  #line 172 "src/filter/ParticleFilter.birch"
  std::tie(ess, lsum) = resample_reduce(w);
  #line 173 "src/filter/ParticleFilter.birch"
  lnormalize = lnormalize + lsum - log(nparticles);
  #line 174 "src/filter/ParticleFilter.birch"
  b = ancestor(w);
  #line 175 "src/filter/ParticleFilter.birch"
  if (b == Integer(0)) {
    #line 176 "src/filter/ParticleFilter.birch"
    error(String("particle filter degenerated"));
  }
}

#line 185 "src/filter/ParticleFilter.birch"
#line 185 "src/filter/ParticleFilter.birch"
#line 185 "src/filter/ParticleFilter.birch"
void ParticleFilter_::resample(const Integer& t) {
  #line 186 "src/filter/ParticleFilter.birch"
  if (ess <= trigger * nparticles) {
    #line 187 "src/filter/ParticleFilter.birch"
    a = resample_systematic(w);
    #line 188 "src/filter/ParticleFilter.birch"
    w = vector(0.0, nparticles);
    #line 189 "src/filter/ParticleFilter.birch"
    copy();
    #line 190 "src/filter/ParticleFilter.birch"
    collect();
  } else {
    #line 193 "src/filter/ParticleFilter.birch"
    a = iota(Integer(1), nparticles);
    #line 194 "src/filter/ParticleFilter.birch"
    w = w - vector(lsum - log(nparticles), nparticles);
  }
}

#line 201 "src/filter/ParticleFilter.birch"
#line 201 "src/filter/ParticleFilter.birch"
#line 201 "src/filter/ParticleFilter.birch"
void ParticleFilter_::copy() {
  #line 204 "src/filter/ParticleFilter.birch"
  #pragma omp parallel
  {
    #pragma omp for schedule(guided)
    for (auto n = Integer(2); n <= nparticles; ++n) {
      #line 205 "src/filter/ParticleFilter.birch"
      if (a(n) == a(n - Integer(1)) && (n <= Integer(2) || a(n) != a(n - Integer(2)))) {
        #line 206 "src/filter/ParticleFilter.birch"
        bridge(x(a(n)));
      }
    }
  }
  #line 212 "src/filter/ParticleFilter.birch"
  a = permute_ancestors(a);
  #line 215 "src/filter/ParticleFilter.birch"
  #pragma omp parallel
  {
    #pragma omp for schedule(guided)
    for (auto n = Integer(1); n <= nparticles; ++n) {
      #line 216 "src/filter/ParticleFilter.birch"
      if (a(n) != n) {
        #line 217 "src/filter/ParticleFilter.birch"
        x(n) = birch::copy(x(a(n)));
      }
    }
  }
}

#line 228 "src/filter/ParticleFilter.birch"
#line 228 "src/filter/ParticleFilter.birch"
#line 228 "src/filter/ParticleFilter.birch"
void ParticleFilter_::move(const Integer& t, const Kernel& \u03ba) {
  auto \u03b1 = vector(0.0, nparticles);
  #line 230 "src/filter/ParticleFilter.birch"
  #pragma omp parallel
  {
    #pragma omp for schedule(static)
    for (auto n = Integer(1); n <= nparticles; ++n) {
      #line 231 "src/filter/ParticleFilter.birch"
      \u03b1(n) = \u03ba->apply(t, x(n));
    }
  }
  #line 233 "src/filter/ParticleFilter.birch"
  raccepts = sum(\u03b1) / nparticles;
}

#line 236 "src/filter/ParticleFilter.birch"
#line 236 "src/filter/ParticleFilter.birch"
#line 236 "src/filter/ParticleFilter.birch"
void ParticleFilter_::read(const Buffer& buffer) {
  #line 237 "src/filter/ParticleFilter.birch"
    libbirch::optional_assign(nparticles, buffer->get<Integer>(String("nparticles")));
;
  #line 238 "src/filter/ParticleFilter.birch"
    libbirch::optional_assign(trigger, buffer->get<Real>(String("trigger")));
;
  #line 239 "src/filter/ParticleFilter.birch"
    libbirch::optional_assign(delayed, buffer->get<Boolean>(String("delayed")));
;
  #line 240 "src/filter/ParticleFilter.birch"
    libbirch::optional_assign(autodiff, buffer->get<Boolean>(String("autodiff")));
;
}

#line 1 "src/filter/ParticleFilter.birch"
ParticleFilter_* make_ParticleFilter_() {
  #line 1 "src/filter/ParticleFilter.birch"
  return new ParticleFilter_();
  #line 1 "src/filter/ParticleFilter.birch"
}

}
