namespace birch {
#line 1 "src/form/binary_matrix/CholSolve.birch"
#line 1 "src/form/binary_matrix/CholSolve.birch"
CholSolveFunction_::CholSolveFunction_() {
  //
}

#line 27 "src/form/binary_matrix/CholSolve.birch"
#line 27 "src/form/binary_matrix/CholSolve.birch"
libbirch::DefaultArray<Real,1> cholsolve(const libbirch::DefaultArray<Real,2>& l, const libbirch::DefaultArray<Real,1>& r) {
  #line 28 "src/form/binary_matrix/CholSolve.birch"

  return l.toEigen().llt().solve(r.toEigen());
  }

#line 37 "src/form/binary_matrix/CholSolve.birch"
#line 37 "src/form/binary_matrix/CholSolve.birch"
libbirch::DefaultArray<Real,2> cholsolve(const libbirch::DefaultArray<Real,2>& l, const libbirch::DefaultArray<Real,2>& r) {
  #line 38 "src/form/binary_matrix/CholSolve.birch"

  return l.toEigen().llt().solve(r.toEigen());
  }

}
namespace birch {
#line 1 "src/form/binary_matrix/Diagonal.birch"
#line 1 "src/form/binary_matrix/Diagonal.birch"
DiagonalFunction_::DiagonalFunction_() {
  //
}

#line 29 "src/form/binary_matrix/Diagonal.birch"
#line 29 "src/form/binary_matrix/Diagonal.birch"
libbirch::DefaultArray<Boolean,2> diagonal(const Boolean& x, const Integer& length) {
  #line 30 "src/form/binary_matrix/Diagonal.birch"
  return matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 31 "src/form/binary_matrix/Diagonal.birch"
    return if_then_else(i == j, x, false);
  }, length, length);
}

#line 41 "src/form/binary_matrix/Diagonal.birch"
#line 41 "src/form/binary_matrix/Diagonal.birch"
libbirch::DefaultArray<Integer,2> diagonal(const Integer& x, const Integer& length) {
  #line 42 "src/form/binary_matrix/Diagonal.birch"
  return matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 43 "src/form/binary_matrix/Diagonal.birch"
    return if_then_else(i == j, x, Integer(0));
  }, length, length);
}

#line 53 "src/form/binary_matrix/Diagonal.birch"
#line 53 "src/form/binary_matrix/Diagonal.birch"
libbirch::DefaultArray<Real,2> diagonal(const Real& x, const Integer& length) {
  #line 54 "src/form/binary_matrix/Diagonal.birch"
  return matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 55 "src/form/binary_matrix/Diagonal.birch"
    return if_then_else(i == j, x, 0.0);
  }, length, length);
}

}
namespace birch {
#line 1 "src/form/binary_matrix/Dot.birch"
#line 1 "src/form/binary_matrix/Dot.birch"
DotFunction_::DotFunction_() {
  //
}

#line 30 "src/form/binary_matrix/Dot.birch"
#line 30 "src/form/binary_matrix/Dot.birch"
Integer dot(const libbirch::DefaultArray<Integer,1>& x) {
  #line 31 "src/form/binary_matrix/Dot.birch"

  return x.toEigen().squaredNorm();
  }

#line 39 "src/form/binary_matrix/Dot.birch"
#line 39 "src/form/binary_matrix/Dot.birch"
Real dot(const libbirch::DefaultArray<Real,1>& x) {
  #line 40 "src/form/binary_matrix/Dot.birch"

  return x.toEigen().squaredNorm();
  }

#line 48 "src/form/binary_matrix/Dot.birch"
#line 48 "src/form/binary_matrix/Dot.birch"
Integer dot(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 49 "src/form/binary_matrix/Dot.birch"

  return x.toEigen().dot(y.toEigen());
  }

#line 57 "src/form/binary_matrix/Dot.birch"
#line 57 "src/form/binary_matrix/Dot.birch"
Real dot(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 58 "src/form/binary_matrix/Dot.birch"

  return x.toEigen().cast<Real>().dot(y.toEigen());
  }

#line 66 "src/form/binary_matrix/Dot.birch"
#line 66 "src/form/binary_matrix/Dot.birch"
Real dot(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 67 "src/form/binary_matrix/Dot.birch"

  return x.toEigen().dot(y.toEigen().cast<Real>());
  }

#line 75 "src/form/binary_matrix/Dot.birch"
#line 75 "src/form/binary_matrix/Dot.birch"
Real dot(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 76 "src/form/binary_matrix/Dot.birch"

  return x.toEigen().dot(y.toEigen());
  }

#line 85 "src/form/binary_matrix/Dot.birch"
#line 85 "src/form/binary_matrix/Dot.birch"
libbirch::DefaultArray<Integer,1> dot(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Integer,2>& Y) {
  #line 86 "src/form/binary_matrix/Dot.birch"

  return Y.toEigen().transpose().operator*(x.toEigen());
  }

#line 95 "src/form/binary_matrix/Dot.birch"
#line 95 "src/form/binary_matrix/Dot.birch"
libbirch::DefaultArray<Real,1> dot(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Real,2>& Y) {
  #line 96 "src/form/binary_matrix/Dot.birch"

  return Y.toEigen().transpose().operator*(x.toEigen().cast<Real>());
  }

#line 105 "src/form/binary_matrix/Dot.birch"
#line 105 "src/form/binary_matrix/Dot.birch"
libbirch::DefaultArray<Real,1> dot(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Integer,2>& Y) {
  #line 106 "src/form/binary_matrix/Dot.birch"

  return Y.toEigen().cast<Real>().transpose().operator*(x.toEigen());
  }

#line 115 "src/form/binary_matrix/Dot.birch"
#line 115 "src/form/binary_matrix/Dot.birch"
libbirch::DefaultArray<Real,1> dot(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Real,2>& Y) {
  #line 116 "src/form/binary_matrix/Dot.birch"

  return Y.toEigen().transpose().operator*(x.toEigen());
  }

}
namespace birch {
#line 1 "src/form/binary_matrix/Inner.birch"
#line 1 "src/form/binary_matrix/Inner.birch"
InnerFunction_::InnerFunction_() {
  //
}

#line 30 "src/form/binary_matrix/Inner.birch"
#line 30 "src/form/binary_matrix/Inner.birch"
Integer inner(const Integer& x) {
  #line 31 "src/form/binary_matrix/Inner.birch"
  return inner(x, x);
}

#line 37 "src/form/binary_matrix/Inner.birch"
#line 37 "src/form/binary_matrix/Inner.birch"
Real inner(const Real& x) {
  #line 38 "src/form/binary_matrix/Inner.birch"
  return inner(x, x);
}

#line 44 "src/form/binary_matrix/Inner.birch"
#line 44 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Integer,1> inner(const libbirch::DefaultArray<Integer,1>& x) {
  #line 45 "src/form/binary_matrix/Inner.birch"
  return inner(x, x);
}

#line 51 "src/form/binary_matrix/Inner.birch"
#line 51 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,1> inner(const libbirch::DefaultArray<Real,1>& x) {
  #line 52 "src/form/binary_matrix/Inner.birch"
  return inner(x, x);
}

#line 58 "src/form/binary_matrix/Inner.birch"
#line 58 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Integer,2> inner(const libbirch::DefaultArray<Integer,2>& X) {
  #line 59 "src/form/binary_matrix/Inner.birch"
  return inner(X, X);
}

#line 65 "src/form/binary_matrix/Inner.birch"
#line 65 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Real,2>& X) {
  #line 66 "src/form/binary_matrix/Inner.birch"
  return inner(X, X);
}

#line 72 "src/form/binary_matrix/Inner.birch"
#line 72 "src/form/binary_matrix/Inner.birch"
Integer inner(const Integer& x, const Integer& y) {
  #line 73 "src/form/binary_matrix/Inner.birch"
  return x * y;
}

#line 79 "src/form/binary_matrix/Inner.birch"
#line 79 "src/form/binary_matrix/Inner.birch"
Real inner(const Integer& x, const Real& y) {
  #line 80 "src/form/binary_matrix/Inner.birch"
  return x * y;
}

#line 86 "src/form/binary_matrix/Inner.birch"
#line 86 "src/form/binary_matrix/Inner.birch"
Real inner(const Real& x, const Integer& y) {
  #line 87 "src/form/binary_matrix/Inner.birch"
  return x * y;
}

#line 93 "src/form/binary_matrix/Inner.birch"
#line 93 "src/form/binary_matrix/Inner.birch"
Real inner(const Real& x, const Real& y) {
  #line 94 "src/form/binary_matrix/Inner.birch"
  return x * y;
}

#line 100 "src/form/binary_matrix/Inner.birch"
#line 100 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Integer,1> inner(const Integer& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 101 "src/form/binary_matrix/Inner.birch"

  return y.toEigen().operator*(x);
  }

#line 109 "src/form/binary_matrix/Inner.birch"
#line 109 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,1> inner(const Integer& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 110 "src/form/binary_matrix/Inner.birch"

  return y.toEigen().operator*(x);
  }

#line 118 "src/form/binary_matrix/Inner.birch"
#line 118 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,1> inner(const Real& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 119 "src/form/binary_matrix/Inner.birch"

  return y.toEigen().cast<Real>().operator*(x);
  }

#line 127 "src/form/binary_matrix/Inner.birch"
#line 127 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,1> inner(const Real& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 128 "src/form/binary_matrix/Inner.birch"

  return y.toEigen().operator*(x);
  }

#line 136 "src/form/binary_matrix/Inner.birch"
#line 136 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Integer,2> inner(const libbirch::DefaultArray<Integer,1>& x, const Integer& y) {
  #line 137 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().transpose().operator*(y);
  }

#line 145 "src/form/binary_matrix/Inner.birch"
#line 145 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Integer,1>& x, const Real& y) {
  #line 146 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().cast<Real>().transpose().operator*(y);
  }

#line 154 "src/form/binary_matrix/Inner.birch"
#line 154 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Real,1>& x, const Integer& y) {
  #line 155 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().cast<Real>().transpose().operator*(y);
  }

#line 163 "src/form/binary_matrix/Inner.birch"
#line 163 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Real,1>& x, const Real& y) {
  #line 164 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().transpose().operator*(y);
  }

#line 172 "src/form/binary_matrix/Inner.birch"
#line 172 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Integer,1> inner(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 173 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().transpose().operator*(y.toEigen());
  }

#line 181 "src/form/binary_matrix/Inner.birch"
#line 181 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,1> inner(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 182 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().cast<Real>().transpose().operator*(y.toEigen());
  }

#line 190 "src/form/binary_matrix/Inner.birch"
#line 190 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,1> inner(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 191 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().transpose().operator*(y.toEigen().cast<Real>());
  }

#line 199 "src/form/binary_matrix/Inner.birch"
#line 199 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,1> inner(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 200 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().transpose().operator*(y.toEigen());
  }

#line 208 "src/form/binary_matrix/Inner.birch"
#line 208 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Integer,2> inner(const Integer& x, const libbirch::DefaultArray<Integer,2>& y) {
  #line 209 "src/form/binary_matrix/Inner.birch"

  return y.toEigen().operator*(x);
  }

#line 217 "src/form/binary_matrix/Inner.birch"
#line 217 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const Integer& x, const libbirch::DefaultArray<Real,2>& y) {
  #line 218 "src/form/binary_matrix/Inner.birch"

  return y.toEigen().operator*(x);
  }

#line 226 "src/form/binary_matrix/Inner.birch"
#line 226 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const Real& x, const libbirch::DefaultArray<Integer,2>& y) {
  #line 227 "src/form/binary_matrix/Inner.birch"

  return y.toEigen().cast<Real>().operator*(x);
  }

#line 235 "src/form/binary_matrix/Inner.birch"
#line 235 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const Real& x, const libbirch::DefaultArray<Real,2>& y) {
  #line 236 "src/form/binary_matrix/Inner.birch"

  return y.toEigen().operator*(x);
  }

#line 244 "src/form/binary_matrix/Inner.birch"
#line 244 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Integer,2> inner(const libbirch::DefaultArray<Integer,2>& x, const Integer& y) {
  #line 245 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().transpose().operator*(y);
  }

#line 253 "src/form/binary_matrix/Inner.birch"
#line 253 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Integer,2>& x, const Real& y) {
  #line 254 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().cast<Real>().transpose().operator*(y);
  }

#line 262 "src/form/binary_matrix/Inner.birch"
#line 262 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Real,2>& x, const Integer& y) {
  #line 263 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().transpose().operator*(y);
  }

#line 271 "src/form/binary_matrix/Inner.birch"
#line 271 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Real,2>& x, const Real& y) {
  #line 272 "src/form/binary_matrix/Inner.birch"

  return x.toEigen().transpose().operator*(y);
  }

#line 280 "src/form/binary_matrix/Inner.birch"
#line 280 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Integer,1> inner(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Integer,1>& y) {
  #line 281 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().transpose().operator*(y.toEigen());
  }

#line 289 "src/form/binary_matrix/Inner.birch"
#line 289 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,1> inner(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Real,1>& y) {
  #line 290 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().cast<Real>().transpose().operator*(y.toEigen());
  }

#line 298 "src/form/binary_matrix/Inner.birch"
#line 298 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,1> inner(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Integer,1>& y) {
  #line 299 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().transpose().operator*(y.toEigen().cast<Real>());
  }

#line 307 "src/form/binary_matrix/Inner.birch"
#line 307 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,1> inner(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Real,1>& y) {
  #line 308 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().transpose().operator*(y.toEigen());
  }

#line 316 "src/form/binary_matrix/Inner.birch"
#line 316 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Integer,2> inner(const libbirch::DefaultArray<Integer,1>& X, const libbirch::DefaultArray<Integer,2>& y) {
  #line 317 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().transpose().operator*(y.toEigen());
  }

#line 325 "src/form/binary_matrix/Inner.birch"
#line 325 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Integer,1>& X, const libbirch::DefaultArray<Real,2>& y) {
  #line 326 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().transpose().cast<Real>().operator*(y.toEigen());
  }

#line 334 "src/form/binary_matrix/Inner.birch"
#line 334 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Real,1>& X, const libbirch::DefaultArray<Integer,2>& y) {
  #line 335 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().transpose().operator*(y.toEigen().cast<Real>());
  }

#line 343 "src/form/binary_matrix/Inner.birch"
#line 343 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Real,1>& X, const libbirch::DefaultArray<Real,2>& y) {
  #line 344 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().transpose().operator*(y.toEigen());
  }

#line 352 "src/form/binary_matrix/Inner.birch"
#line 352 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Integer,2> inner(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Integer,2>& Y) {
  #line 353 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().transpose().operator*(Y.toEigen());
  }

#line 361 "src/form/binary_matrix/Inner.birch"
#line 361 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Real,2>& Y) {
  #line 362 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().cast<Real>().transpose().operator*(Y.toEigen());
  }

#line 370 "src/form/binary_matrix/Inner.birch"
#line 370 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Integer,2>& Y) {
  #line 371 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().transpose().operator*(Y.toEigen().cast<Real>());
  }

#line 379 "src/form/binary_matrix/Inner.birch"
#line 379 "src/form/binary_matrix/Inner.birch"
libbirch::DefaultArray<Real,2> inner(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Real,2>& Y) {
  #line 380 "src/form/binary_matrix/Inner.birch"

  return X.toEigen().transpose().operator*(Y.toEigen());
  }

}
namespace birch {
#line 1 "src/form/binary_matrix/MatrixPack.birch"
#line 1 "src/form/binary_matrix/MatrixPack.birch"
MatrixPackFunction_::MatrixPackFunction_() {
  //
}

#line 37 "src/form/binary_matrix/MatrixPack.birch"
#line 37 "src/form/binary_matrix/MatrixPack.birch"
libbirch::DefaultArray<Real,2> pack(const Real& x, const Real& y) {
  #line 38 "src/form/binary_matrix/MatrixPack.birch"
  return libbirch::make_array_from_sequence({ { x, y } });
}

#line 44 "src/form/binary_matrix/MatrixPack.birch"
#line 44 "src/form/binary_matrix/MatrixPack.birch"
libbirch::DefaultArray<Integer,2> pack(const Integer& x, const Integer& y) {
  #line 45 "src/form/binary_matrix/MatrixPack.birch"
  return libbirch::make_array_from_sequence({ { x, y } });
}

#line 51 "src/form/binary_matrix/MatrixPack.birch"
#line 51 "src/form/binary_matrix/MatrixPack.birch"
libbirch::DefaultArray<Boolean,2> pack(const Boolean& x, const Boolean& y) {
  #line 52 "src/form/binary_matrix/MatrixPack.birch"
  return libbirch::make_array_from_sequence({ { x, y } });
}

}
namespace birch {
#line 1 "src/form/binary_matrix/MatrixStack.birch"
#line 1 "src/form/binary_matrix/MatrixStack.birch"
MatrixStackFunction_::MatrixStackFunction_() {
  //
}

#line 48 "src/form/binary_matrix/MatrixStack.birch"
#line 48 "src/form/binary_matrix/MatrixStack.birch"
libbirch::DefaultArray<Real,1> stack(const Real& x, const Real& y) {
  #line 49 "src/form/binary_matrix/MatrixStack.birch"
  return libbirch::make_array_from_sequence({ x, y });
}

#line 56 "src/form/binary_matrix/MatrixStack.birch"
#line 56 "src/form/binary_matrix/MatrixStack.birch"
libbirch::DefaultArray<Integer,1> stack(const Integer& x, const Integer& y) {
  #line 57 "src/form/binary_matrix/MatrixStack.birch"
  return libbirch::make_array_from_sequence({ x, y });
}

#line 64 "src/form/binary_matrix/MatrixStack.birch"
#line 64 "src/form/binary_matrix/MatrixStack.birch"
libbirch::DefaultArray<Boolean,1> stack(const Boolean& x, const Boolean& y) {
  #line 65 "src/form/binary_matrix/MatrixStack.birch"
  return libbirch::make_array_from_sequence({ x, y });
}

}
namespace birch {
#line 1 "src/form/binary_matrix/Outer.birch"
#line 1 "src/form/binary_matrix/Outer.birch"
OuterFunction_::OuterFunction_() {
  //
}

#line 30 "src/form/binary_matrix/Outer.birch"
#line 30 "src/form/binary_matrix/Outer.birch"
Integer outer(const Integer& x) {
  #line 31 "src/form/binary_matrix/Outer.birch"
  return outer(x, x);
}

#line 37 "src/form/binary_matrix/Outer.birch"
#line 37 "src/form/binary_matrix/Outer.birch"
Real outer(const Real& x) {
  #line 38 "src/form/binary_matrix/Outer.birch"
  return outer(x, x);
}

#line 44 "src/form/binary_matrix/Outer.birch"
#line 44 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Integer,2> outer(const libbirch::DefaultArray<Integer,1>& x) {
  #line 45 "src/form/binary_matrix/Outer.birch"
  return outer(x, x);
}

#line 51 "src/form/binary_matrix/Outer.birch"
#line 51 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,1>& x) {
  #line 52 "src/form/binary_matrix/Outer.birch"
  return outer(x, x);
}

#line 58 "src/form/binary_matrix/Outer.birch"
#line 58 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Integer,2> outer(const libbirch::DefaultArray<Integer,2>& X) {
  #line 59 "src/form/binary_matrix/Outer.birch"
  return outer(X, X);
}

#line 65 "src/form/binary_matrix/Outer.birch"
#line 65 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,2>& X) {
  #line 66 "src/form/binary_matrix/Outer.birch"
  return outer(X, X);
}

#line 72 "src/form/binary_matrix/Outer.birch"
#line 72 "src/form/binary_matrix/Outer.birch"
Integer outer(const Integer& x, const Integer& y) {
  #line 73 "src/form/binary_matrix/Outer.birch"
  return x * y;
}

#line 79 "src/form/binary_matrix/Outer.birch"
#line 79 "src/form/binary_matrix/Outer.birch"
Real outer(const Integer& x, const Real& y) {
  #line 80 "src/form/binary_matrix/Outer.birch"
  return x * y;
}

#line 86 "src/form/binary_matrix/Outer.birch"
#line 86 "src/form/binary_matrix/Outer.birch"
Real outer(const Real& x, const Integer& y) {
  #line 87 "src/form/binary_matrix/Outer.birch"
  return x * y;
}

#line 93 "src/form/binary_matrix/Outer.birch"
#line 93 "src/form/binary_matrix/Outer.birch"
Real outer(const Real& x, const Real& y) {
  #line 94 "src/form/binary_matrix/Outer.birch"
  return x * y;
}

#line 100 "src/form/binary_matrix/Outer.birch"
#line 100 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Integer,2> outer(const Integer& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 101 "src/form/binary_matrix/Outer.birch"

  return y.toEigen().transpose().operator*(x);
  }

#line 109 "src/form/binary_matrix/Outer.birch"
#line 109 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const Integer& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 110 "src/form/binary_matrix/Outer.birch"

  return y.toEigen().transpose().operator*(x);
  }

#line 118 "src/form/binary_matrix/Outer.birch"
#line 118 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const Real& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 119 "src/form/binary_matrix/Outer.birch"

  return y.toEigen().cast<Real>().transpose().operator*(x);
  }

#line 127 "src/form/binary_matrix/Outer.birch"
#line 127 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const Real& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 128 "src/form/binary_matrix/Outer.birch"

  return y.toEigen().transpose().operator*(x);
  }

#line 136 "src/form/binary_matrix/Outer.birch"
#line 136 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Integer,1> outer(const libbirch::DefaultArray<Integer,1>& x, const Integer& y) {
  #line 137 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().operator*(y);
  }

#line 145 "src/form/binary_matrix/Outer.birch"
#line 145 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,1> outer(const libbirch::DefaultArray<Integer,1>& x, const Real& y) {
  #line 146 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().cast<Real>().operator*(y);
  }

#line 154 "src/form/binary_matrix/Outer.birch"
#line 154 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,1> outer(const libbirch::DefaultArray<Real,1>& x, const Integer& y) {
  #line 155 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().cast<Real>().operator*(y);
  }

#line 163 "src/form/binary_matrix/Outer.birch"
#line 163 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,1> outer(const libbirch::DefaultArray<Real,1>& x, const Real& y) {
  #line 164 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().operator*(y);
  }

#line 172 "src/form/binary_matrix/Outer.birch"
#line 172 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Integer,2> outer(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 173 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().operator*(y.toEigen().transpose());
  }

#line 181 "src/form/binary_matrix/Outer.birch"
#line 181 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Integer,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 182 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().cast<Real>().operator*(y.toEigen().transpose());
  }

#line 190 "src/form/binary_matrix/Outer.birch"
#line 190 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Integer,1>& y) {
  #line 191 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().operator*(y.toEigen().cast<Real>().transpose());
  }

#line 199 "src/form/binary_matrix/Outer.birch"
#line 199 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,1>& x, const libbirch::DefaultArray<Real,1>& y) {
  #line 200 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().operator*(y.toEigen().transpose());
  }

#line 208 "src/form/binary_matrix/Outer.birch"
#line 208 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Integer,2> outer(const Integer& x, const libbirch::DefaultArray<Integer,2>& y) {
  #line 209 "src/form/binary_matrix/Outer.birch"

  return y.toEigen().transpose().operator*(x);
  }

#line 217 "src/form/binary_matrix/Outer.birch"
#line 217 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const Integer& x, const libbirch::DefaultArray<Real,2>& y) {
  #line 218 "src/form/binary_matrix/Outer.birch"

  return y.toEigen().transpose().operator*(x);
  }

#line 226 "src/form/binary_matrix/Outer.birch"
#line 226 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const Real& x, const libbirch::DefaultArray<Integer,2>& y) {
  #line 227 "src/form/binary_matrix/Outer.birch"

  return y.toEigen().cast<Real>().transpose().operator*(x);
  }

#line 235 "src/form/binary_matrix/Outer.birch"
#line 235 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const Real& x, const libbirch::DefaultArray<Real,2>& y) {
  #line 236 "src/form/binary_matrix/Outer.birch"

  return y.toEigen().transpose().operator*(x);
  }

#line 244 "src/form/binary_matrix/Outer.birch"
#line 244 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Integer,2> outer(const libbirch::DefaultArray<Integer,2>& x, const Integer& y) {
  #line 245 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().operator*(y);
  }

#line 253 "src/form/binary_matrix/Outer.birch"
#line 253 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Integer,2>& x, const Real& y) {
  #line 254 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().cast<Real>().operator*(y);
  }

#line 262 "src/form/binary_matrix/Outer.birch"
#line 262 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,2>& x, const Integer& y) {
  #line 263 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().operator*(y);
  }

#line 271 "src/form/binary_matrix/Outer.birch"
#line 271 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,2>& x, const Real& y) {
  #line 272 "src/form/binary_matrix/Outer.birch"

  return x.toEigen().operator*(y);
  }

#line 280 "src/form/binary_matrix/Outer.birch"
#line 280 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Integer,2> outer(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Integer,1>& y) {
  #line 281 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().operator*(y.toEigen().transpose());
  }

#line 289 "src/form/binary_matrix/Outer.birch"
#line 289 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Real,1>& y) {
  #line 290 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().cast<Real>().operator*(y.toEigen().transpose());
  }

#line 298 "src/form/binary_matrix/Outer.birch"
#line 298 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Integer,1>& y) {
  #line 299 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().operator*(y.toEigen().cast<Real>().transpose());
  }

#line 307 "src/form/binary_matrix/Outer.birch"
#line 307 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Real,1>& y) {
  #line 308 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().operator*(y.toEigen().transpose());
  }

#line 316 "src/form/binary_matrix/Outer.birch"
#line 316 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Integer,2> outer(const libbirch::DefaultArray<Integer,1>& X, const libbirch::DefaultArray<Integer,2>& y) {
  #line 317 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().operator*(y.toEigen().transpose());
  }

#line 325 "src/form/binary_matrix/Outer.birch"
#line 325 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Integer,1>& X, const libbirch::DefaultArray<Real,2>& y) {
  #line 326 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().cast<Real>().operator*(y.toEigen().transpose());
  }

#line 334 "src/form/binary_matrix/Outer.birch"
#line 334 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,1>& X, const libbirch::DefaultArray<Integer,2>& y) {
  #line 335 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().operator*(y.toEigen().cast<Real>().transpose());
  }

#line 343 "src/form/binary_matrix/Outer.birch"
#line 343 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,1>& X, const libbirch::DefaultArray<Real,2>& y) {
  #line 344 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().operator*(y.toEigen().transpose());
  }

#line 352 "src/form/binary_matrix/Outer.birch"
#line 352 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Integer,2> outer(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Integer,2>& Y) {
  #line 353 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().operator*(Y.toEigen().transpose());
  }

#line 361 "src/form/binary_matrix/Outer.birch"
#line 361 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Integer,2>& X, const libbirch::DefaultArray<Real,2>& Y) {
  #line 362 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().cast<Real>().operator*(Y.toEigen().transpose());
  }

#line 370 "src/form/binary_matrix/Outer.birch"
#line 370 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Integer,2>& Y) {
  #line 371 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().operator*(Y.toEigen().cast<Real>().transpose());
  }

#line 379 "src/form/binary_matrix/Outer.birch"
#line 379 "src/form/binary_matrix/Outer.birch"
libbirch::DefaultArray<Real,2> outer(const libbirch::DefaultArray<Real,2>& X, const libbirch::DefaultArray<Real,2>& Y) {
  #line 380 "src/form/binary_matrix/Outer.birch"

  return X.toEigen().operator*(Y.toEigen().transpose());
  }

}
namespace birch {
#line 1 "src/form/binary_matrix/Solve.birch"
#line 1 "src/form/binary_matrix/Solve.birch"
SolveFunction_::SolveFunction_() {
  //
}

#line 25 "src/form/binary_matrix/Solve.birch"
#line 25 "src/form/binary_matrix/Solve.birch"
libbirch::DefaultArray<Real,1> solve(const libbirch::DefaultArray<Real,2>& l, const libbirch::DefaultArray<Real,1>& r) {
  #line 26 "src/form/binary_matrix/Solve.birch"

  return l.toEigen().householderQr().solve(r.toEigen());
  }

#line 34 "src/form/binary_matrix/Solve.birch"
#line 34 "src/form/binary_matrix/Solve.birch"
libbirch::DefaultArray<Real,2> solve(const libbirch::DefaultArray<Real,2>& l, const libbirch::DefaultArray<Real,2>& r) {
  #line 35 "src/form/binary_matrix/Solve.birch"

  return l.toEigen().householderQr().solve(r.toEigen());
  }

}
