namespace birch {
#line 1 "src/form/unary_matrix/CholInv.birch"
#line 1 "src/form/unary_matrix/CholInv.birch"
CholInvFunction_::CholInvFunction_() {
  //
}

#line 25 "src/form/unary_matrix/CholInv.birch"
#line 25 "src/form/unary_matrix/CholInv.birch"
libbirch::DefaultArray<Real,2> cholinv(const libbirch::DefaultArray<Real,2>& S) {
  #line 26 "src/form/unary_matrix/CholInv.birch"

  return S.toEigen().llt().solve(libbirch::EigenMatrix<Real>::Identity(
      rows(S), columns(S)));
  }

}
namespace birch {
#line 1 "src/form/unary_matrix/Inv.birch"
#line 1 "src/form/unary_matrix/Inv.birch"
InvFunction_::InvFunction_() {
  //
}

#line 23 "src/form/unary_matrix/Inv.birch"
#line 23 "src/form/unary_matrix/Inv.birch"
libbirch::DefaultArray<Real,2> inv(const libbirch::DefaultArray<Real,2>& X) {
  #line 24 "src/form/unary_matrix/Inv.birch"

  return X.toEigen().inverse();
  }

}
namespace birch {
#line 1 "src/form/unary_matrix/LCholDet.birch"
#line 1 "src/form/unary_matrix/LCholDet.birch"
LCholDetFunction_::LCholDetFunction_() {
  //
}

#line 23 "src/form/unary_matrix/LCholDet.birch"
#line 23 "src/form/unary_matrix/LCholDet.birch"
Real lcholdet(const libbirch::DefaultArray<Real,2>& S) {
  auto L = chol(S);
  #line 25 "src/form/unary_matrix/LCholDet.birch"

  return 2.0*L.toEigen().diagonal().array().log().sum();
  }

}
namespace birch {
#line 1 "src/form/unary_matrix/LDet.birch"
#line 1 "src/form/unary_matrix/LDet.birch"
LDetFunction_::LDetFunction_() {
  //
}

#line 22 "src/form/unary_matrix/LDet.birch"
#line 22 "src/form/unary_matrix/LDet.birch"
Real ldet(const libbirch::DefaultArray<Real,2>& X) {
  #line 23 "src/form/unary_matrix/LDet.birch"

  return X.toEigen().householderQr().logAbsDeterminant();
  }

}
namespace birch {
}
namespace birch {
#line 1 "src/form/unary_matrix/Trace.birch"
#line 1 "src/form/unary_matrix/Trace.birch"
TraceFunction_::TraceFunction_() {
  //
}

#line 30 "src/form/unary_matrix/Trace.birch"
#line 30 "src/form/unary_matrix/Trace.birch"
Integer trace(const Integer& m) {
  #line 31 "src/form/unary_matrix/Trace.birch"
  return m;
}

#line 37 "src/form/unary_matrix/Trace.birch"
#line 37 "src/form/unary_matrix/Trace.birch"
Real trace(const Real& m) {
  #line 38 "src/form/unary_matrix/Trace.birch"
  return m;
}

#line 44 "src/form/unary_matrix/Trace.birch"
#line 44 "src/form/unary_matrix/Trace.birch"
Integer trace(const libbirch::DefaultArray<Integer,1>& m) {
  #line 45 "src/form/unary_matrix/Trace.birch"

  return m.toEigen().sum();
  }

#line 53 "src/form/unary_matrix/Trace.birch"
#line 53 "src/form/unary_matrix/Trace.birch"
Real trace(const libbirch::DefaultArray<Real,1>& m) {
  #line 54 "src/form/unary_matrix/Trace.birch"

  return m.toEigen().sum();
  }

#line 62 "src/form/unary_matrix/Trace.birch"
#line 62 "src/form/unary_matrix/Trace.birch"
Integer trace(const libbirch::DefaultArray<Integer,2>& m) {
  #line 63 "src/form/unary_matrix/Trace.birch"

  return m.toEigen().trace();
  }

#line 71 "src/form/unary_matrix/Trace.birch"
#line 71 "src/form/unary_matrix/Trace.birch"
Real trace(const libbirch::DefaultArray<Real,2>& m) {
  #line 72 "src/form/unary_matrix/Trace.birch"

  return m.toEigen().trace();
  }

}
namespace birch {
#line 1 "src/form/unary_matrix/Transpose.birch"
#line 1 "src/form/unary_matrix/Transpose.birch"
TransposeFunction_::TransposeFunction_() {
  //
}

#line 22 "src/form/unary_matrix/Transpose.birch"
#line 22 "src/form/unary_matrix/Transpose.birch"
Boolean transpose(const Boolean& m) {
  #line 23 "src/form/unary_matrix/Transpose.birch"
  return m;
}

#line 29 "src/form/unary_matrix/Transpose.birch"
#line 29 "src/form/unary_matrix/Transpose.birch"
Integer transpose(const Integer& m) {
  #line 30 "src/form/unary_matrix/Transpose.birch"
  return m;
}

#line 36 "src/form/unary_matrix/Transpose.birch"
#line 36 "src/form/unary_matrix/Transpose.birch"
Real transpose(const Real& m) {
  #line 37 "src/form/unary_matrix/Transpose.birch"
  return m;
}

#line 43 "src/form/unary_matrix/Transpose.birch"
#line 43 "src/form/unary_matrix/Transpose.birch"
libbirch::DefaultArray<Boolean,2> transpose(const libbirch::DefaultArray<Boolean,1>& x) {
  #line 44 "src/form/unary_matrix/Transpose.birch"

  return x.toEigen().transpose();
  }

#line 52 "src/form/unary_matrix/Transpose.birch"
#line 52 "src/form/unary_matrix/Transpose.birch"
libbirch::DefaultArray<Integer,2> transpose(const libbirch::DefaultArray<Integer,1>& x) {
  #line 53 "src/form/unary_matrix/Transpose.birch"

  return x.toEigen().transpose();
  }

#line 61 "src/form/unary_matrix/Transpose.birch"
#line 61 "src/form/unary_matrix/Transpose.birch"
libbirch::DefaultArray<Real,2> transpose(const libbirch::DefaultArray<Real,1>& x) {
  #line 62 "src/form/unary_matrix/Transpose.birch"

  return x.toEigen().transpose();
  }

#line 70 "src/form/unary_matrix/Transpose.birch"
#line 70 "src/form/unary_matrix/Transpose.birch"
libbirch::DefaultArray<Boolean,2> transpose(const libbirch::DefaultArray<Boolean,2>& X) {
  #line 71 "src/form/unary_matrix/Transpose.birch"

  return X.toEigen().transpose();
  }

#line 79 "src/form/unary_matrix/Transpose.birch"
#line 79 "src/form/unary_matrix/Transpose.birch"
libbirch::DefaultArray<Integer,2> transpose(const libbirch::DefaultArray<Integer,2>& X) {
  #line 80 "src/form/unary_matrix/Transpose.birch"

  return X.toEigen().transpose();
  }

#line 88 "src/form/unary_matrix/Transpose.birch"
#line 88 "src/form/unary_matrix/Transpose.birch"
libbirch::DefaultArray<Real,2> transpose(const libbirch::DefaultArray<Real,2>& X) {
  #line 89 "src/form/unary_matrix/Transpose.birch"

  return X.toEigen().transpose();
  }

}
namespace birch {
}
