namespace birch {
#line 4 "src/io/InputStream.birch"
#line 4 "src/io/InputStream.birch"
InputStream_::InputStream_() :
    #line 8 "src/io/InputStream.birch"
    file() {
  //
}

#line 16 "src/io/InputStream.birch"
#line 16 "src/io/InputStream.birch"
#line 16 "src/io/InputStream.birch"
void InputStream_::open(const String& path, const Integer& mode) {
  #line 17 "src/io/InputStream.birch"
  assert(!((file.has_value())));
  #line 18 "src/io/InputStream.birch"
  file = fopen(path, mode);
}

#line 26 "src/io/InputStream.birch"
#line 26 "src/io/InputStream.birch"
#line 26 "src/io/InputStream.birch"
void InputStream_::open(const String& path) {
  #line 27 "src/io/InputStream.birch"
  open(path, READ);
}

#line 33 "src/io/InputStream.birch"
#line 33 "src/io/InputStream.birch"
#line 33 "src/io/InputStream.birch"
void InputStream_::close() {
  #line 34 "src/io/InputStream.birch"
  assert(file.has_value());
  #line 35 "src/io/InputStream.birch"

    fclose(file.value());
      #line 38 "src/io/InputStream.birch"
  file = std::nullopt;
}

#line 44 "src/io/InputStream.birch"
#line 44 "src/io/InputStream.birch"
#line 44 "src/io/InputStream.birch"
Boolean InputStream_::eof() {
  #line 45 "src/io/InputStream.birch"
  assert(file.has_value());
  #line 46 "src/io/InputStream.birch"

    return feof(file.value());
    }

#line 54 "src/io/InputStream.birch"
#line 54 "src/io/InputStream.birch"
#line 54 "src/io/InputStream.birch"
std::optional<Integer> InputStream_::scanInteger() {
  #line 55 "src/io/InputStream.birch"
  assert(file.has_value());
  std::optional<Integer> x;
  #line 57 "src/io/InputStream.birch"

    long long int y;  // ensure fscanf gets exactly the type it expects
    auto res = ::fscanf(this->file.value(), "%lld", &y);
    if (res == 1) {
      x = (Integer)y;
    } 
      #line 64 "src/io/InputStream.birch"
  return x;
}

#line 70 "src/io/InputStream.birch"
#line 70 "src/io/InputStream.birch"
#line 70 "src/io/InputStream.birch"
std::optional<Real> InputStream_::scanReal() {
  #line 71 "src/io/InputStream.birch"
  assert(file.has_value());
  std::optional<Real> x;
  #line 73 "src/io/InputStream.birch"

    double y;  // ensure fscanf gets exactly the type it expects
    auto res = ::fscanf(this->file.value(), "%lf", &y);
    if (res == 1) {
      x = y;
    } 
      #line 80 "src/io/InputStream.birch"
  return x;
}

#line 87 "src/io/InputStream.birch"
#line 87 "src/io/InputStream.birch"
InputStream make_input_stream(const File& file) {
  InputStream o;
  #line 89 "src/io/InputStream.birch"
  o->file = file;
  #line 90 "src/io/InputStream.birch"
  return o;
}

}
namespace birch {
}
namespace birch {
#line 1 "src/io/JSONWriter.birch"
#line 1 "src/io/JSONWriter.birch"
JSONWriter_::JSONWriter_() :
    #line 1 "src/io/JSONWriter.birch"
    base_type_() {
  //
}

#line 14 "src/io/JSONWriter.birch"
#line 14 "src/io/JSONWriter.birch"
#line 14 "src/io/JSONWriter.birch"
void JSONWriter_::visit(const String& value) {
  #line 15 "src/io/JSONWriter.birch"

    yaml_scalar_event_initialize(&this->event, NULL, NULL,
        (yaml_char_t*)value.c_str(), value.length(), 1, 1,
        YAML_DOUBLE_QUOTED_SCALAR_STYLE);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 23 "src/io/JSONWriter.birch"
#line 23 "src/io/JSONWriter.birch"
#line 23 "src/io/JSONWriter.birch"
void JSONWriter_::startMapping() {
  #line 24 "src/io/JSONWriter.birch"

    yaml_mapping_start_event_initialize(&this->event, NULL, NULL, 1,
        YAML_FLOW_MAPPING_STYLE);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 31 "src/io/JSONWriter.birch"
#line 31 "src/io/JSONWriter.birch"
#line 31 "src/io/JSONWriter.birch"
void JSONWriter_::startSequence() {
  #line 32 "src/io/JSONWriter.birch"

    yaml_sequence_start_event_initialize(&this->event, NULL, NULL, 1,
        YAML_FLOW_SEQUENCE_STYLE);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 1 "src/io/JSONWriter.birch"
JSONWriter_* make_JSONWriter_() {
  #line 1 "src/io/JSONWriter.birch"
  return new JSONWriter_();
  #line 1 "src/io/JSONWriter.birch"
}

}
namespace birch {
#line 4 "src/io/OutputStream.birch"
#line 4 "src/io/OutputStream.birch"
OutputStream_::OutputStream_() :
    #line 8 "src/io/OutputStream.birch"
    file() {
  //
}

#line 16 "src/io/OutputStream.birch"
#line 16 "src/io/OutputStream.birch"
#line 16 "src/io/OutputStream.birch"
void OutputStream_::open(const String& path, const Integer& mode) {
  #line 17 "src/io/OutputStream.birch"
  file = fopen(path, mode);
}

#line 25 "src/io/OutputStream.birch"
#line 25 "src/io/OutputStream.birch"
#line 25 "src/io/OutputStream.birch"
void OutputStream_::open(const String& path) {
  #line 26 "src/io/OutputStream.birch"
  open(path, WRITE);
}

#line 32 "src/io/OutputStream.birch"
#line 32 "src/io/OutputStream.birch"
#line 32 "src/io/OutputStream.birch"
void OutputStream_::close() {
  #line 33 "src/io/OutputStream.birch"
  assert(file.has_value());
  #line 34 "src/io/OutputStream.birch"

    fclose(file.value());
      #line 37 "src/io/OutputStream.birch"
  file = std::nullopt;
}

#line 43 "src/io/OutputStream.birch"
#line 43 "src/io/OutputStream.birch"
#line 43 "src/io/OutputStream.birch"
void OutputStream_::flush() {
  #line 44 "src/io/OutputStream.birch"
  assert(file.has_value());
  #line 45 "src/io/OutputStream.birch"

    fflush(file.value());
    }

#line 53 "src/io/OutputStream.birch"
#line 53 "src/io/OutputStream.birch"
#line 53 "src/io/OutputStream.birch"
void OutputStream_::print(const String& value) {
  #line 54 "src/io/OutputStream.birch"
  assert(file.has_value());
  #line 55 "src/io/OutputStream.birch"

    ::fprintf(this->file.value(), "%s", value.c_str());
    }

#line 63 "src/io/OutputStream.birch"
#line 63 "src/io/OutputStream.birch"
#line 63 "src/io/OutputStream.birch"
void OutputStream_::print(const Boolean& value) {
  #line 64 "src/io/OutputStream.birch"
  print(to_string(value));
}

#line 70 "src/io/OutputStream.birch"
#line 70 "src/io/OutputStream.birch"
#line 70 "src/io/OutputStream.birch"
void OutputStream_::print(const Integer& value) {
  #line 71 "src/io/OutputStream.birch"
  print(to_string(value));
}

#line 77 "src/io/OutputStream.birch"
#line 77 "src/io/OutputStream.birch"
#line 77 "src/io/OutputStream.birch"
void OutputStream_::print(const Real& value) {
  #line 78 "src/io/OutputStream.birch"
  print(to_string(value));
}

#line 84 "src/io/OutputStream.birch"
#line 84 "src/io/OutputStream.birch"
#line 84 "src/io/OutputStream.birch"
void OutputStream_::print(const libbirch::DefaultArray<Boolean,1>& value) {
  #line 85 "src/io/OutputStream.birch"
  print(to_string(value));
}

#line 91 "src/io/OutputStream.birch"
#line 91 "src/io/OutputStream.birch"
#line 91 "src/io/OutputStream.birch"
void OutputStream_::print(const libbirch::DefaultArray<Integer,1>& value) {
  #line 92 "src/io/OutputStream.birch"
  print(to_string(value));
}

#line 98 "src/io/OutputStream.birch"
#line 98 "src/io/OutputStream.birch"
#line 98 "src/io/OutputStream.birch"
void OutputStream_::print(const libbirch::DefaultArray<Real,1>& value) {
  #line 99 "src/io/OutputStream.birch"
  print(to_string(value));
}

#line 105 "src/io/OutputStream.birch"
#line 105 "src/io/OutputStream.birch"
#line 105 "src/io/OutputStream.birch"
void OutputStream_::print(const libbirch::DefaultArray<Boolean,2>& value) {
  #line 106 "src/io/OutputStream.birch"
  print(to_string(value));
}

#line 112 "src/io/OutputStream.birch"
#line 112 "src/io/OutputStream.birch"
#line 112 "src/io/OutputStream.birch"
void OutputStream_::print(const libbirch::DefaultArray<Integer,2>& value) {
  #line 113 "src/io/OutputStream.birch"
  print(to_string(value));
}

#line 119 "src/io/OutputStream.birch"
#line 119 "src/io/OutputStream.birch"
#line 119 "src/io/OutputStream.birch"
void OutputStream_::print(const libbirch::DefaultArray<Real,2>& value) {
  #line 120 "src/io/OutputStream.birch"
  print(to_string(value));
}

#line 127 "src/io/OutputStream.birch"
#line 127 "src/io/OutputStream.birch"
OutputStream make_output_stream(const File& file) {
  OutputStream o;
  #line 129 "src/io/OutputStream.birch"
  o->file = file;
  #line 130 "src/io/OutputStream.birch"
  return o;
}

}
namespace birch {
#line 38 "src/io/Reader.birch"
#line 38 "src/io/Reader.birch"
Reader_::Reader_() :
    #line 38 "src/io/Reader.birch"
    base_type_() {
  //
}

#line 69 "src/io/Reader.birch"
#line 69 "src/io/Reader.birch"
Reader make_reader(const String& path) {
  auto ext = extension(path);
  std::optional<Reader> result;
  #line 72 "src/io/Reader.birch"
  if (ext == String(".json")) {
    JSONReader reader;
    #line 74 "src/io/Reader.birch"
    reader->open(path);
    #line 75 "src/io/Reader.birch"
    result = reader;
  } else {
    #line 76 "src/io/Reader.birch"
    if (ext == String(".yml") || ext == String(".yaml")) {
      YAMLReader reader;
      #line 78 "src/io/Reader.birch"
      reader->open(path);
      #line 79 "src/io/Reader.birch"
      result = reader;
    }
  }
  #line 81 "src/io/Reader.birch"
  if (!(result.has_value())) {
    #line 82 "src/io/Reader.birch"
    error(String("unrecognized file extension '") + ext + String("' in path '") + path + String("'; supported extensions are '.json', '.yml' and '.yaml'."));
  }
  #line 85 "src/io/Reader.birch"
  return result.value();
}

#line 95 "src/io/Reader.birch"
#line 95 "src/io/Reader.birch"
Buffer slurp(const String& path) {
  auto reader = make_reader(path);
  auto buffer = reader->slurp();
  #line 98 "src/io/Reader.birch"
  reader->close();
  #line 99 "src/io/Reader.birch"
  return buffer;
}

}
namespace birch {
#line 37 "src/io/Writer.birch"
#line 37 "src/io/Writer.birch"
Writer_::Writer_() :
    #line 37 "src/io/Writer.birch"
    base_type_() {
  //
}

#line 98 "src/io/Writer.birch"
#line 98 "src/io/Writer.birch"
Writer make_writer(const String& path) {
  auto ext = extension(path);
  std::optional<Writer> result;
  #line 101 "src/io/Writer.birch"
  if (ext == String(".json")) {
    JSONWriter writer;
    #line 103 "src/io/Writer.birch"
    writer->open(path);
    #line 104 "src/io/Writer.birch"
    result = writer;
  } else {
    #line 105 "src/io/Writer.birch"
    if (ext == String(".yml")) {
      YAMLWriter writer;
      #line 107 "src/io/Writer.birch"
      writer->open(path);
      #line 108 "src/io/Writer.birch"
      result = writer;
    }
  }
  #line 110 "src/io/Writer.birch"
  if (!(result.has_value())) {
    #line 111 "src/io/Writer.birch"
    error(String("unrecognized file extension '") + ext + String("' in path '") + path + String("'; supported extensions are '.json' and '.yml'."));
  }
  #line 114 "src/io/Writer.birch"
  return result.value();
}

#line 123 "src/io/Writer.birch"
#line 123 "src/io/Writer.birch"
void dump(const String& path, const Buffer& buffer) {
  auto writer = make_writer(path);
  #line 125 "src/io/Writer.birch"
  writer->dump(buffer);
  #line 126 "src/io/Writer.birch"
  writer->close();
}

}
namespace birch {
#line 1 "src/io/YAMLReader.birch"
#line 1 "src/io/YAMLReader.birch"
YAMLReader_::YAMLReader_() :
    #line 1 "src/io/YAMLReader.birch"
    base_type_(),
    #line 24 "src/io/YAMLReader.birch"
    file(),
    #line 29 "src/io/YAMLReader.birch"
    sequential(false) {
  //
}

#line 36 "src/io/YAMLReader.birch"
#line 36 "src/io/YAMLReader.birch"
#line 36 "src/io/YAMLReader.birch"
void YAMLReader_::open(const String& path) {
  #line 37 "src/io/YAMLReader.birch"
  file = fopen(path, READ);
  #line 38 "src/io/YAMLReader.birch"

    yaml_parser_initialize(&parser);
    yaml_parser_set_input_file(&parser, file);
    if (!yaml_parser_parse(&parser, &event)) {
      error("parse error");
    }
    }

#line 47 "src/io/YAMLReader.birch"
#line 47 "src/io/YAMLReader.birch"
#line 47 "src/io/YAMLReader.birch"
void YAMLReader_::close() {
  #line 48 "src/io/YAMLReader.birch"

    yaml_event_delete(&event);
    yaml_parser_delete(&parser);
    fclose(file);
    }

#line 55 "src/io/YAMLReader.birch"
#line 55 "src/io/YAMLReader.birch"
#line 55 "src/io/YAMLReader.birch"
Buffer YAMLReader_::slurp() {
  #line 56 "src/io/YAMLReader.birch"
  assert(!(sequential));
  Buffer buffer;
  #line 58 "src/io/YAMLReader.birch"

    while (event.type != YAML_STREAM_END_EVENT) {
      if (event.type == YAML_SEQUENCE_START_EVENT) {
        parseSequence(buffer);
      } else if (event.type == YAML_MAPPING_START_EVENT) {
        parseMapping(buffer);
      } else if (event.type == YAML_SCALAR_EVENT) {
        parseValue(buffer);
      }
      nextEvent();
    }
      #line 70 "src/io/YAMLReader.birch"
  return buffer;
}

#line 73 "src/io/YAMLReader.birch"
#line 73 "src/io/YAMLReader.birch"
#line 73 "src/io/YAMLReader.birch"
Boolean YAMLReader_::hasNext() {
  #line 74 "src/io/YAMLReader.birch"

    while (event.type != YAML_MAPPING_START_EVENT &&
        event.type != YAML_SEQUENCE_START_EVENT &&
        event.type != YAML_SCALAR_EVENT &&
        event.type != YAML_STREAM_END_EVENT) {
      nextEvent();
    }
    if (!sequential && event.type == YAML_SEQUENCE_START_EVENT) {
      /* root is a sequence to iterate through, go one level deeper to find
       * its first element, if any */
      nextEvent();
      while (event.type != YAML_MAPPING_START_EVENT &&
          event.type != YAML_SEQUENCE_START_EVENT &&
          event.type != YAML_SCALAR_EVENT &&
          event.type != YAML_STREAM_END_EVENT) {
        nextEvent();
      }
    }
    sequential = true;
    return event.type != YAML_STREAM_END_EVENT;
      #line 95 "src/io/YAMLReader.birch"
  return false;
}

#line 98 "src/io/YAMLReader.birch"
#line 98 "src/io/YAMLReader.birch"
#line 98 "src/io/YAMLReader.birch"
Buffer YAMLReader_::next() {
  #line 99 "src/io/YAMLReader.birch"
  if (!(sequential)) {
    #line 100 "src/io/YAMLReader.birch"
    hasNext();
  }
  Buffer buffer;
  #line 103 "src/io/YAMLReader.birch"

    if (event.type == YAML_SCALAR_EVENT) {
      parseValue(buffer);
    } else if (event.type == YAML_SEQUENCE_START_EVENT) {
      parseSequence(buffer);
    } else if (event.type == YAML_MAPPING_START_EVENT) {
      parseMapping(buffer);
    } else {
      /* shouldn't get here if hasNext() was called before next() */
      assert(false);
    }
    nextEvent();
      #line 116 "src/io/YAMLReader.birch"
  return buffer;
}

#line 122 "src/io/YAMLReader.birch"
#line 122 "src/io/YAMLReader.birch"
#line 122 "src/io/YAMLReader.birch"
void YAMLReader_::parseMapping(const Buffer& buffer) {
  #line 123 "src/io/YAMLReader.birch"
  buffer->setEmptyObject();
  #line 124 "src/io/YAMLReader.birch"

    nextEvent();
    while (event.type != YAML_MAPPING_END_EVENT) {
      if (event.type == YAML_SCALAR_EVENT) {
        /* key */
        char* data = (char*)event.data.scalar.value;
        size_t length = event.data.scalar.length;
        std::string key(data, length);
      
        /* value */
        nextEvent();
        auto value = make_buffer();
        if (event.type == YAML_SCALAR_EVENT) {
          parseValue(value);
        } else if (event.type == YAML_SEQUENCE_START_EVENT) {
          parseSequence(value);
        } else if (event.type == YAML_MAPPING_START_EVENT) {
          parseMapping(value);
        }

        /* set key/value entry */
        buffer->set(key, value);
      }
      nextEvent();
    }
    }

#line 155 "src/io/YAMLReader.birch"
#line 155 "src/io/YAMLReader.birch"
#line 155 "src/io/YAMLReader.birch"
void YAMLReader_::parseSequence(const Buffer& buffer) {
  #line 156 "src/io/YAMLReader.birch"
  buffer->setEmptyArray();
  #line 157 "src/io/YAMLReader.birch"

    nextEvent();
    while (event.type != YAML_SEQUENCE_END_EVENT) {
      if (event.type == YAML_SCALAR_EVENT) {
        parseElement(buffer);
      } else if (event.type == YAML_SEQUENCE_START_EVENT) {
        auto element = make_buffer();
        parseSequence(element);

        /* attempt to merge sequences into numerical matrices */
        if (element->vectorReal.has_value()) {
          buffer->push(element->vectorReal.value());
        } else if (element->vectorInteger.has_value()) {
          buffer->push(element->vectorInteger.value());
        } else if (element->vectorBoolean.has_value()) {
          buffer->push(element->vectorBoolean.value());
        } else {
          buffer->push(element);
        }
      } else if (event.type == YAML_MAPPING_START_EVENT) {
        auto element = make_buffer();
        parseMapping(element);
        buffer->push(element);
      }
      nextEvent();
    }
    }

#line 189 "src/io/YAMLReader.birch"
#line 189 "src/io/YAMLReader.birch"
#line 189 "src/io/YAMLReader.birch"
void YAMLReader_::parseValue(const Buffer& buffer) {
  #line 190 "src/io/YAMLReader.birch"

    auto data = (char*)event.data.scalar.value;
    auto length = event.data.scalar.length;
    auto endptr = data;
    auto intValue = int64_t(std::strtoll(data, &endptr, 10));
    if (endptr == data + length) {
      buffer->set(intValue);
    } else {
      auto realValue = std::strtod(data, &endptr);
      if (endptr == data + length) {
        buffer->set(realValue);
      } else if (std::strcmp(data, "true") == 0) {
        buffer->set(true);
      } else if (std::strcmp(data, "false") == 0) {
        buffer->set(false);
      } else if (std::strcmp(data, "null") == 0) {
        buffer->setNil();
      } else if (std::strcmp(data, "Infinity") == 0) {
        buffer->set(std::numeric_limits<Real>::infinity());
      } else if (std::strcmp(data, "-Infinity") == 0) {
        buffer->set(-std::numeric_limits<Real>::infinity());
      } else if (std::strcmp(data, "NaN") == 0) {
        buffer->set(std::numeric_limits<Real>::quiet_NaN());
      } else {
        buffer->set(std::string(data, length));
      }
    }
    }

#line 223 "src/io/YAMLReader.birch"
#line 223 "src/io/YAMLReader.birch"
#line 223 "src/io/YAMLReader.birch"
void YAMLReader_::parseElement(const Buffer& buffer) {
  #line 224 "src/io/YAMLReader.birch"

    auto data = (char*)event.data.scalar.value;
    auto length = event.data.scalar.length;
    auto endptr = data;
    auto intValue = int64_t(std::strtoll(data, &endptr, 10));
    if (endptr == data + length) {
      buffer->push(intValue);
    } else {
      auto realValue = std::strtod(data, &endptr);
      if (endptr == data + length) {
        buffer->push(realValue);
      } else if (std::strcmp(data, "true") == 0) {
        buffer->push(true);
      } else if (std::strcmp(data, "false") == 0) {
        buffer->push(false);
      } else if (std::strcmp(data, "null") == 0) {
        buffer->pushNil();
      } else if (std::strcmp(data, "Infinity") == 0) {
        buffer->push(std::numeric_limits<Real>::infinity());
      } else if (std::strcmp(data, "-Infinity") == 0) {
        buffer->push(-std::numeric_limits<Real>::infinity());
      } else if (std::strcmp(data, "NaN") == 0) {
        buffer->push(std::numeric_limits<Real>::quiet_NaN());
      } else {
        buffer->push(std::string(data, length));
      }
    }
    }

#line 257 "src/io/YAMLReader.birch"
#line 257 "src/io/YAMLReader.birch"
#line 257 "src/io/YAMLReader.birch"
void YAMLReader_::nextEvent() {
  #line 258 "src/io/YAMLReader.birch"

    yaml_event_delete(&event);
    if (!yaml_parser_parse(&parser, &event)) {
      error("parse error");
    }
    }

#line 1 "src/io/YAMLReader.birch"
YAMLReader_* make_YAMLReader_() {
  #line 1 "src/io/YAMLReader.birch"
  return new YAMLReader_();
  #line 1 "src/io/YAMLReader.birch"
}

}
namespace birch {
#line 1 "src/io/YAMLWriter.birch"
#line 1 "src/io/YAMLWriter.birch"
YAMLWriter_::YAMLWriter_() :
    #line 1 "src/io/YAMLWriter.birch"
    base_type_(),
    #line 17 "src/io/YAMLWriter.birch"
    file(),
    #line 22 "src/io/YAMLWriter.birch"
    sequential(false) {
  //
}

#line 29 "src/io/YAMLWriter.birch"
#line 29 "src/io/YAMLWriter.birch"
#line 29 "src/io/YAMLWriter.birch"
void YAMLWriter_::open(const String& path) {
  #line 30 "src/io/YAMLWriter.birch"
  file = fopen(path, WRITE);
  #line 31 "src/io/YAMLWriter.birch"

    yaml_emitter_initialize(&this->emitter);
    yaml_emitter_set_unicode(&this->emitter, 1);
    yaml_emitter_set_output_file(&this->emitter, this->file);
    yaml_stream_start_event_initialize(&this->event, YAML_UTF8_ENCODING);
    yaml_emitter_emit(&this->emitter, &this->event);
    yaml_document_start_event_initialize(&this->event, NULL, NULL, NULL, 1);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 42 "src/io/YAMLWriter.birch"
#line 42 "src/io/YAMLWriter.birch"
#line 42 "src/io/YAMLWriter.birch"
void YAMLWriter_::dump(const Buffer& buffer) {
  #line 43 "src/io/YAMLWriter.birch"
  buffer->accept(this->shared_from_this_());
}

#line 46 "src/io/YAMLWriter.birch"
#line 46 "src/io/YAMLWriter.birch"
#line 46 "src/io/YAMLWriter.birch"
void YAMLWriter_::push(const Buffer& buffer) {
  #line 47 "src/io/YAMLWriter.birch"
  if (!(sequential)) {
    #line 48 "src/io/YAMLWriter.birch"
    startSequence();
    #line 49 "src/io/YAMLWriter.birch"
    sequential = true;
  }
  #line 51 "src/io/YAMLWriter.birch"
  buffer->accept(this->shared_from_this_());
}

#line 54 "src/io/YAMLWriter.birch"
#line 54 "src/io/YAMLWriter.birch"
#line 54 "src/io/YAMLWriter.birch"
void YAMLWriter_::flush() {
  #line 55 "src/io/YAMLWriter.birch"

    yaml_emitter_flush(&this->emitter);
    fflush(file);
    }

#line 61 "src/io/YAMLWriter.birch"
#line 61 "src/io/YAMLWriter.birch"
#line 61 "src/io/YAMLWriter.birch"
void YAMLWriter_::close() {
  #line 62 "src/io/YAMLWriter.birch"
  if (sequential) {
    #line 63 "src/io/YAMLWriter.birch"
    endSequence();
  }
  #line 65 "src/io/YAMLWriter.birch"

    yaml_document_end_event_initialize(&this->event, 1);
    yaml_emitter_emit(&this->emitter, &this->event);
    yaml_stream_end_event_initialize(&this->event);
    yaml_emitter_emit(&this->emitter, &this->event);
    yaml_emitter_delete(&this->emitter);
    fclose(file);
    }

#line 75 "src/io/YAMLWriter.birch"
#line 75 "src/io/YAMLWriter.birch"
#line 75 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const libbirch::DefaultArray<String,1>& keys, const libbirch::DefaultArray<Buffer,1>& values) {
  #line 76 "src/io/YAMLWriter.birch"
  assert(length(keys) == length(values));
  #line 77 "src/io/YAMLWriter.birch"
  startMapping();
  #line 78 "src/io/YAMLWriter.birch"
  for (auto i = Integer(1); i <= length(keys); ++i) {
    #line 79 "src/io/YAMLWriter.birch"
    visit(keys(i));
    #line 80 "src/io/YAMLWriter.birch"
    values(i)->accept(this->shared_from_this_());
  }
  #line 82 "src/io/YAMLWriter.birch"
  endMapping();
}

#line 85 "src/io/YAMLWriter.birch"
#line 85 "src/io/YAMLWriter.birch"
#line 85 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const libbirch::DefaultArray<Buffer,1>& values) {
  #line 86 "src/io/YAMLWriter.birch"
  startSequence();
  #line 87 "src/io/YAMLWriter.birch"
  for (auto i = Integer(1); i <= length(values); ++i) {
    #line 88 "src/io/YAMLWriter.birch"
    values(i)->accept(this->shared_from_this_());
  }
  #line 90 "src/io/YAMLWriter.birch"
  endSequence();
}

#line 93 "src/io/YAMLWriter.birch"
#line 93 "src/io/YAMLWriter.birch"
#line 93 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const Boolean& value) {
  auto str = to_string(value);
  #line 95 "src/io/YAMLWriter.birch"

    yaml_scalar_event_initialize(&this->event, NULL, NULL,
        (yaml_char_t*)str.c_str(), str.length(), 1, 1,
        YAML_ANY_SCALAR_STYLE);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 103 "src/io/YAMLWriter.birch"
#line 103 "src/io/YAMLWriter.birch"
#line 103 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const Integer& value) {
  auto str = to_string(value);
  #line 105 "src/io/YAMLWriter.birch"

    yaml_scalar_event_initialize(&this->event, NULL, NULL,
        (yaml_char_t*)str.c_str(), str.length(), 1, 1,
        YAML_ANY_SCALAR_STYLE);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 113 "src/io/YAMLWriter.birch"
#line 113 "src/io/YAMLWriter.birch"
#line 113 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const Real& value) {
  String str;
  #line 118 "src/io/YAMLWriter.birch"
  if (value == std::numeric_limits<double>::infinity()) {
    #line 119 "src/io/YAMLWriter.birch"
    str = String("Infinity");
  } else {
    #line 120 "src/io/YAMLWriter.birch"
    if (value == -(std::numeric_limits<double>::infinity())) {
      #line 121 "src/io/YAMLWriter.birch"
      str = String("-Infinity");
    } else {
      #line 122 "src/io/YAMLWriter.birch"
      if (isnan(value)) {
        #line 123 "src/io/YAMLWriter.birch"
        str = String("NaN");
      } else {
        #line 125 "src/io/YAMLWriter.birch"
        str = to_string(value);
      }
    }
  }
  #line 127 "src/io/YAMLWriter.birch"

    yaml_scalar_event_initialize(&this->event, NULL, NULL,
        (yaml_char_t*)str.c_str(), str.length(), 1, 1,
        YAML_PLAIN_SCALAR_STYLE);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 135 "src/io/YAMLWriter.birch"
#line 135 "src/io/YAMLWriter.birch"
#line 135 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const String& value) {
  #line 136 "src/io/YAMLWriter.birch"

    yaml_scalar_event_initialize(&this->event, NULL, NULL,
        (yaml_char_t*)value.c_str(), value.length(), 1, 1,
        YAML_ANY_SCALAR_STYLE);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 144 "src/io/YAMLWriter.birch"
#line 144 "src/io/YAMLWriter.birch"
#line 144 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const libbirch::DefaultArray<Boolean,1>& value) {
  #line 145 "src/io/YAMLWriter.birch"
  startSequence();
  #line 146 "src/io/YAMLWriter.birch"
  for (auto i = Integer(1); i <= length(value); ++i) {
    #line 147 "src/io/YAMLWriter.birch"
    visit(value(i));
  }
  #line 149 "src/io/YAMLWriter.birch"
  endSequence();
}

#line 152 "src/io/YAMLWriter.birch"
#line 152 "src/io/YAMLWriter.birch"
#line 152 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const libbirch::DefaultArray<Integer,1>& value) {
  #line 153 "src/io/YAMLWriter.birch"
  startSequence();
  #line 154 "src/io/YAMLWriter.birch"
  for (auto i = Integer(1); i <= length(value); ++i) {
    #line 155 "src/io/YAMLWriter.birch"
    visit(value(i));
  }
  #line 157 "src/io/YAMLWriter.birch"
  endSequence();
}

#line 160 "src/io/YAMLWriter.birch"
#line 160 "src/io/YAMLWriter.birch"
#line 160 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const libbirch::DefaultArray<Real,1>& value) {
  #line 161 "src/io/YAMLWriter.birch"
  startSequence();
  #line 162 "src/io/YAMLWriter.birch"
  for (auto i = Integer(1); i <= length(value); ++i) {
    #line 163 "src/io/YAMLWriter.birch"
    visit(value(i));
  }
  #line 165 "src/io/YAMLWriter.birch"
  endSequence();
}

#line 168 "src/io/YAMLWriter.birch"
#line 168 "src/io/YAMLWriter.birch"
#line 168 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const libbirch::DefaultArray<String,1>& value) {
  #line 169 "src/io/YAMLWriter.birch"
  startSequence();
  #line 170 "src/io/YAMLWriter.birch"
  for (auto i = Integer(1); i <= length(value); ++i) {
    #line 171 "src/io/YAMLWriter.birch"
    visit(value(i));
  }
  #line 173 "src/io/YAMLWriter.birch"
  endSequence();
}

#line 176 "src/io/YAMLWriter.birch"
#line 176 "src/io/YAMLWriter.birch"
#line 176 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const libbirch::DefaultArray<Boolean,2>& value) {
  #line 177 "src/io/YAMLWriter.birch"
  startSequence();
  #line 178 "src/io/YAMLWriter.birch"
  for (auto i = Integer(1); i <= rows(value); ++i) {
    #line 179 "src/io/YAMLWriter.birch"
    visit(row(value, i));
  }
  #line 181 "src/io/YAMLWriter.birch"
  endSequence();
}

#line 184 "src/io/YAMLWriter.birch"
#line 184 "src/io/YAMLWriter.birch"
#line 184 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const libbirch::DefaultArray<Integer,2>& value) {
  #line 185 "src/io/YAMLWriter.birch"
  startSequence();
  #line 186 "src/io/YAMLWriter.birch"
  for (auto i = Integer(1); i <= rows(value); ++i) {
    #line 187 "src/io/YAMLWriter.birch"
    visit(row(value, i));
  }
  #line 189 "src/io/YAMLWriter.birch"
  endSequence();
}

#line 192 "src/io/YAMLWriter.birch"
#line 192 "src/io/YAMLWriter.birch"
#line 192 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const libbirch::DefaultArray<Real,2>& value) {
  #line 193 "src/io/YAMLWriter.birch"
  startSequence();
  #line 194 "src/io/YAMLWriter.birch"
  for (auto i = Integer(1); i <= rows(value); ++i) {
    #line 195 "src/io/YAMLWriter.birch"
    visit(row(value, i));
  }
  #line 197 "src/io/YAMLWriter.birch"
  endSequence();
}

#line 200 "src/io/YAMLWriter.birch"
#line 200 "src/io/YAMLWriter.birch"
#line 200 "src/io/YAMLWriter.birch"
void YAMLWriter_::visit(const libbirch::DefaultArray<String,2>& value) {
  #line 201 "src/io/YAMLWriter.birch"
  startSequence();
  #line 202 "src/io/YAMLWriter.birch"
  for (auto i = Integer(1); i <= rows(value); ++i) {
    #line 203 "src/io/YAMLWriter.birch"
    visit(row(value, i));
  }
  #line 205 "src/io/YAMLWriter.birch"
  endSequence();
}

#line 208 "src/io/YAMLWriter.birch"
#line 208 "src/io/YAMLWriter.birch"
#line 208 "src/io/YAMLWriter.birch"
void YAMLWriter_::visitNil() {
  #line 209 "src/io/YAMLWriter.birch"

    yaml_scalar_event_initialize(&this->event, NULL, NULL,
        (yaml_char_t*)"null", 4, 1, 1,
        YAML_ANY_SCALAR_STYLE);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 217 "src/io/YAMLWriter.birch"
#line 217 "src/io/YAMLWriter.birch"
#line 217 "src/io/YAMLWriter.birch"
void YAMLWriter_::startMapping() {
  #line 218 "src/io/YAMLWriter.birch"

    yaml_mapping_start_event_initialize(&this->event, NULL, NULL, 1,
        YAML_ANY_MAPPING_STYLE);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 225 "src/io/YAMLWriter.birch"
#line 225 "src/io/YAMLWriter.birch"
#line 225 "src/io/YAMLWriter.birch"
void YAMLWriter_::endMapping() {
  #line 226 "src/io/YAMLWriter.birch"

    yaml_mapping_end_event_initialize(&this->event);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 232 "src/io/YAMLWriter.birch"
#line 232 "src/io/YAMLWriter.birch"
#line 232 "src/io/YAMLWriter.birch"
void YAMLWriter_::startSequence() {
  #line 233 "src/io/YAMLWriter.birch"

    yaml_sequence_start_event_initialize(&this->event, NULL, NULL, 1,
        YAML_ANY_SEQUENCE_STYLE);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 240 "src/io/YAMLWriter.birch"
#line 240 "src/io/YAMLWriter.birch"
#line 240 "src/io/YAMLWriter.birch"
void YAMLWriter_::endSequence() {
  #line 241 "src/io/YAMLWriter.birch"

    yaml_sequence_end_event_initialize(&this->event);
    yaml_emitter_emit(&this->emitter, &this->event);
    }

#line 1 "src/io/YAMLWriter.birch"
YAMLWriter_* make_YAMLWriter_() {
  #line 1 "src/io/YAMLWriter.birch"
  return new YAMLWriter_();
  #line 1 "src/io/YAMLWriter.birch"
}

}
