namespace birch {
}
namespace birch {
}
namespace birch {
#line 10 "src/primitive/resample.birch"
#line 10 "src/primitive/resample.birch"
libbirch::DefaultArray<Integer,1> resample_systematic(const libbirch::DefaultArray<Real,1>& w) {
  #line 11 "src/primitive/resample.birch"
  return cumulative_offspring_to_ancestors(systematic_cumulative_offspring(cumulative_weights(w)));
}

#line 22 "src/primitive/resample.birch"
#line 22 "src/primitive/resample.birch"
libbirch::DefaultArray<Integer,1> resample_multinomial(const libbirch::DefaultArray<Real,1>& w) {
  #line 23 "src/primitive/resample.birch"
  return offspring_to_ancestors(simulate_multinomial(length(w), norm_exp(w)));
}

#line 30 "src/primitive/resample.birch"
#line 30 "src/primitive/resample.birch"
Real log_sum_exp(const libbirch::DefaultArray<Real,1>& x) {
  #line 31 "src/primitive/resample.birch"
  assert(length(x) > Integer(0));
  auto mx = max(x);
  auto r = transform_reduce(x, 0.0, [=](const Real& x, const Real& y) {
    #line 33 "src/primitive/resample.birch"
    return x + y;
  }, [=](const Real& x) {
    #line 34 "src/primitive/resample.birch"
    return nan_exp(x - mx);
  });
  #line 35 "src/primitive/resample.birch"
  return mx + log(r);
}

#line 41 "src/primitive/resample.birch"
#line 41 "src/primitive/resample.birch"
Real log_sum(const libbirch::DefaultArray<Real,1>& x) {
  #line 42 "src/primitive/resample.birch"
  return transform_reduce(x, 0.0, [=](const Real& x, const Real& y) {
    #line 42 "src/primitive/resample.birch"
    return x + y;
  }, [=](const Real& x) {
    #line 43 "src/primitive/resample.birch"
    return log(x);
  });
}

#line 49 "src/primitive/resample.birch"
#line 49 "src/primitive/resample.birch"
Real nan_exp(const Real& x) {
  #line 50 "src/primitive/resample.birch"
  if (isnan(x)) {
    #line 51 "src/primitive/resample.birch"
    return 0.0;
  } else {
    #line 53 "src/primitive/resample.birch"
    return exp(x);
  }
}

#line 62 "src/primitive/resample.birch"
#line 62 "src/primitive/resample.birch"
libbirch::DefaultArray<Real,1> norm_exp(const libbirch::DefaultArray<Real,1>& x) {
  #line 63 "src/primitive/resample.birch"
  assert(length(x) > Integer(0));
  auto mx = max(x);
  auto r = transform_reduce(x, 0.0, [=](const Real& x, const Real& y) {
    #line 65 "src/primitive/resample.birch"
    return x + y;
  }, [=](const Real& x) {
    #line 66 "src/primitive/resample.birch"
    return nan_exp(x - mx);
  });
  auto W = mx + log(r);
  #line 68 "src/primitive/resample.birch"
  return transform(x, [=](const Real& x) {
    #line 68 "src/primitive/resample.birch"
    return nan_exp(x - W);
  });
}

#line 74 "src/primitive/resample.birch"
#line 74 "src/primitive/resample.birch"
Integer cumulative_ancestor(const libbirch::DefaultArray<Real,1>& W) {
  auto N = length(W);
  #line 76 "src/primitive/resample.birch"
  assert(W(N) > 0.0);
  auto u = simulate_uniform(0.0, W(N));
  auto n = Integer(1);
  #line 79 "src/primitive/resample.birch"
  while (W(n) < u) {
    #line 80 "src/primitive/resample.birch"
    n = n + Integer(1);
  }
  #line 82 "src/primitive/resample.birch"
  return n;
}

#line 89 "src/primitive/resample.birch"
#line 89 "src/primitive/resample.birch"
Integer ancestor(const libbirch::DefaultArray<Real,1>& w) {
  auto N = length(w);
  auto W = cumulative_weights(w);
  #line 92 "src/primitive/resample.birch"
  if (W(N) > 0.0) {
    #line 93 "src/primitive/resample.birch"
    return cumulative_ancestor(W);
  } else {
    #line 95 "src/primitive/resample.birch"
    return Integer(0);
  }
}

#line 102 "src/primitive/resample.birch"
#line 102 "src/primitive/resample.birch"
libbirch::DefaultArray<Integer,1> systematic_cumulative_offspring(const libbirch::DefaultArray<Real,1>& W) {
  auto N = length(W);
  libbirch::DefaultArray<Integer,1> O(libbirch::make_shape(N));
  auto u = simulate_uniform(0.0, 1.0);
  #line 106 "src/primitive/resample.birch"
  for (auto n = Integer(1); n <= N; ++n) {
    auto r = N * W(n) / W(N);
    #line 108 "src/primitive/resample.birch"
    O(n) = min(N, scalar<Integer>(floor(r + u)));
  }
  #line 110 "src/primitive/resample.birch"
  return O;
}

#line 116 "src/primitive/resample.birch"
#line 116 "src/primitive/resample.birch"
libbirch::DefaultArray<Integer,1> offspring_to_ancestors(const libbirch::DefaultArray<Integer,1>& o) {
  auto N = length(o);
  auto i = Integer(1);
  libbirch::DefaultArray<Integer,1> a(libbirch::make_shape(N));
  #line 120 "src/primitive/resample.birch"
  for (auto n = Integer(1); n <= N; ++n) {
    #line 121 "src/primitive/resample.birch"
    for (auto j = Integer(1); j <= o(n); ++j) {
      #line 122 "src/primitive/resample.birch"
      a(i) = n;
      #line 123 "src/primitive/resample.birch"
      i = i + Integer(1);
    }
  }
  #line 126 "src/primitive/resample.birch"
  assert(i == N + Integer(1));
  #line 127 "src/primitive/resample.birch"
  assert(is_sorted(a));
  #line 128 "src/primitive/resample.birch"
  return a;
}

#line 134 "src/primitive/resample.birch"
#line 134 "src/primitive/resample.birch"
libbirch::DefaultArray<Integer,1> cumulative_offspring_to_ancestors(const libbirch::DefaultArray<Integer,1>& O) {
  auto N = length(O);
  libbirch::DefaultArray<Integer,1> a(libbirch::make_shape(N));
  #line 137 "src/primitive/resample.birch"
  for (auto n = Integer(1); n <= N; ++n) {
    auto start = Integer(0);
    #line 139 "src/primitive/resample.birch"
    if (n > Integer(1)) {
      #line 140 "src/primitive/resample.birch"
      start = O(n - Integer(1));
    }
    auto o = O(n) - start;
    #line 143 "src/primitive/resample.birch"
    for (auto j = Integer(1); j <= o; ++j) {
      #line 144 "src/primitive/resample.birch"
      a(start + j) = n;
    }
  }
  #line 147 "src/primitive/resample.birch"
  assert(is_sorted(a));
  #line 148 "src/primitive/resample.birch"
  return a;
}

#line 154 "src/primitive/resample.birch"
#line 154 "src/primitive/resample.birch"
libbirch::DefaultArray<Integer,1> cumulative_offspring_to_offspring(const libbirch::DefaultArray<Integer,1>& O) {
  #line 155 "src/primitive/resample.birch"
  return adjacent_difference(O, [=](const Integer& x, const Integer& y) -> Integer {
    #line 156 "src/primitive/resample.birch"
    return x - y;
  });
}

#line 164 "src/primitive/resample.birch"
#line 164 "src/primitive/resample.birch"
libbirch::DefaultArray<Integer,1> permute_ancestors(const libbirch::DefaultArray<Integer,1>& a) {
  auto N = length(a);
  auto b = a;
  auto n = Integer(1);
  #line 168 "src/primitive/resample.birch"
  while (n <= N) {
    auto c = b(n);
    #line 170 "src/primitive/resample.birch"
    if (c != n && b(c) != c) {
      #line 171 "src/primitive/resample.birch"
      b(n) = b(c);
      #line 172 "src/primitive/resample.birch"
      b(c) = c;
    } else {
      #line 174 "src/primitive/resample.birch"
      n = n + Integer(1);
    }
  }
  #line 177 "src/primitive/resample.birch"
  return b;
}

#line 183 "src/primitive/resample.birch"
#line 183 "src/primitive/resample.birch"
libbirch::DefaultArray<Real,1> cumulative_weights(const libbirch::DefaultArray<Real,1>& w) {
  auto N = length(w);
  libbirch::DefaultArray<Real,1> W(libbirch::make_shape(N));
  #line 186 "src/primitive/resample.birch"
  if (N > Integer(0)) {
    auto mx = max(w);
    #line 188 "src/primitive/resample.birch"
    W(Integer(1)) = nan_exp(w(Integer(1)) - mx);
    #line 189 "src/primitive/resample.birch"
    for (auto n = Integer(2); n <= N; ++n) {
      #line 190 "src/primitive/resample.birch"
      W(n) = W(n - Integer(1)) + nan_exp(w(n) - mx);
    }
  }
  #line 193 "src/primitive/resample.birch"
  return W;
}

#line 203 "src/primitive/resample.birch"
#line 203 "src/primitive/resample.birch"
std::tuple<Real, Real> resample_reduce(const libbirch::DefaultArray<Real,1>& w) {
  #line 204 "src/primitive/resample.birch"
  if (length(w) == Integer(0)) {
    #line 205 "src/primitive/resample.birch"
    return std::make_tuple(0.0, 0.0);
  } else {
    auto N = length(w);
    auto W = 0.0;
    auto W2 = 0.0;
    auto mx = max(w);
    #line 211 "src/primitive/resample.birch"
    for (auto n = Integer(1); n <= N; ++n) {
      auto v = nan_exp(w(n) - mx);
      #line 213 "src/primitive/resample.birch"
      W = W + v;
      #line 214 "src/primitive/resample.birch"
      W2 = W2 + v * v;
    }
    #line 216 "src/primitive/resample.birch"
    return std::make_tuple(W * W / W2, log(W) + mx);
  }
}

}
