namespace birch {
#line 4 "src/test/basic/test_basic_array.birch"
int test_basic_array(int argc_, char** argv_) {
  #line 4 "src/test/basic/test_basic_array.birch"
  Eigen::initParallel();

  {
    Array<Integer> o;
    #line 7 "src/test/basic/test_basic_array.birch"
    o->pushBack(Integer(1));
    #line 8 "src/test/basic/test_basic_array.birch"
    o->pushBack(Integer(2));
    #line 9 "src/test/basic/test_basic_array.birch"
    o->pushBack(Integer(4));
    #line 10 "src/test/basic/test_basic_array.birch"
    o->pushBack(Integer(5));
    #line 11 "src/test/basic/test_basic_array.birch"
    if (!(check_container(o, libbirch::make_array_from_sequence({ Integer(1), Integer(2), Integer(4), Integer(5) })))) {
      #line 12 "src/test/basic/test_basic_array.birch"
      exit(Integer(1));
    }
    #line 15 "src/test/basic/test_basic_array.birch"
    o->insert(Integer(3), Integer(3));
    #line 16 "src/test/basic/test_basic_array.birch"
    if (!(check_container(o, libbirch::make_array_from_sequence({ Integer(1), Integer(2), Integer(3), Integer(4), Integer(5) })))) {
      #line 17 "src/test/basic/test_basic_array.birch"
      exit(Integer(1));
    }
    #line 20 "src/test/basic/test_basic_array.birch"
    o->erase(Integer(4));
    #line 21 "src/test/basic/test_basic_array.birch"
    if (!(check_container(o, libbirch::make_array_from_sequence({ Integer(1), Integer(2), Integer(3), Integer(5) })))) {
      #line 22 "src/test/basic/test_basic_array.birch"
      exit(Integer(1));
    }
    #line 25 "src/test/basic/test_basic_array.birch"
    if (o->front() != Integer(1)) {
      #line 26 "src/test/basic/test_basic_array.birch"
      exit(Integer(1));
    }
    #line 29 "src/test/basic/test_basic_array.birch"
    if (o->back() != Integer(5)) {
      #line 30 "src/test/basic/test_basic_array.birch"
      exit(Integer(1));
    }
    #line 33 "src/test/basic/test_basic_array.birch"
    o->clear();
    #line 34 "src/test/basic/test_basic_array.birch"
    if (o->size() != Integer(0) || !(o->empty())) {
      #line 35 "src/test/basic/test_basic_array.birch"
      stderr_->print(String("clear failed\n"));
      #line 36 "src/test/basic/test_basic_array.birch"
      exit(Integer(1));
    }
  }
  #line 4 "src/test/basic/test_basic_array.birch"
  libbirch::collect();
  #line 4 "src/test/basic/test_basic_array.birch"
  return 0;
}

}
namespace birch {
#line 5 "src/test/basic/test_basic_deep_clone_alias.birch"
int test_basic_deep_clone_alias(int argc_, char** argv_) {
  #line 5 "src/test/basic/test_basic_deep_clone_alias.birch"
  Eigen::initParallel();

  {
    List<Integer> x;
    #line 8 "src/test/basic/test_basic_deep_clone_alias.birch"
    x->pushBack(Integer(1));
    #line 9 "src/test/basic/test_basic_deep_clone_alias.birch"
    x->pushBack(Integer(2));
    auto z = x;
    auto y = copy(x);
    #line 18 "src/test/basic/test_basic_deep_clone_alias.birch"
    x->set(Integer(1), Integer(3));
    #line 19 "src/test/basic/test_basic_deep_clone_alias.birch"
    x->set(Integer(2), Integer(4));
    #line 22 "src/test/basic/test_basic_deep_clone_alias.birch"
    if (z->get(Integer(1)) != Integer(3) || z->get(Integer(2)) != Integer(4)) {
      #line 23 "src/test/basic/test_basic_deep_clone_alias.birch"
      exit(Integer(1));
    }
  }
  #line 5 "src/test/basic/test_basic_deep_clone_alias.birch"
  libbirch::collect();
  #line 5 "src/test/basic/test_basic_deep_clone_alias.birch"
  return 0;
}

}
namespace birch {
#line 4 "src/test/basic/test_basic_deep_clone_chain.birch"
int test_basic_deep_clone_chain(int argc_, char** argv_) {
  #line 4 "src/test/basic/test_basic_deep_clone_chain.birch"
  Eigen::initParallel();

  {
    DeepCloneNode x;
    #line 6 "src/test/basic/test_basic_deep_clone_chain.birch"
    x->a = Integer(1);
    auto y = copy(x);
    #line 10 "src/test/basic/test_basic_deep_clone_chain.birch"
    y->a = Integer(2);
    auto z = copy(y);
    #line 16 "src/test/basic/test_basic_deep_clone_chain.birch"
    x = z;
    #line 17 "src/test/basic/test_basic_deep_clone_chain.birch"
    y = z;
    #line 20 "src/test/basic/test_basic_deep_clone_chain.birch"
    if (z->a != Integer(2)) {
      #line 21 "src/test/basic/test_basic_deep_clone_chain.birch"
      exit(Integer(1));
    }
  }
  #line 4 "src/test/basic/test_basic_deep_clone_chain.birch"
  libbirch::collect();
  #line 4 "src/test/basic/test_basic_deep_clone_chain.birch"
  return 0;
}

#line 23 "src/test/basic/test_basic_deep_clone_chain.birch"
#line 23 "src/test/basic/test_basic_deep_clone_chain.birch"
DeepCloneNode_::DeepCloneNode_() :
    #line 23 "src/test/basic/test_basic_deep_clone_chain.birch"
    base_type_(),
    #line 26 "src/test/basic/test_basic_deep_clone_chain.birch"
    a() {
  //
}

#line 23 "src/test/basic/test_basic_deep_clone_chain.birch"
DeepCloneNode_* make_DeepCloneNode_() {
  #line 23 "src/test/basic/test_basic_deep_clone_chain.birch"
  return new DeepCloneNode_();
  #line 23 "src/test/basic/test_basic_deep_clone_chain.birch"
}

}
namespace birch {
#line 5 "src/test/basic/test_basic_deep_clone_modify_dst.birch"
int test_basic_deep_clone_modify_dst(int argc_, char** argv_) {
  #line 5 "src/test/basic/test_basic_deep_clone_modify_dst.birch"
  Eigen::initParallel();

  {
    List<Integer> x;
    #line 8 "src/test/basic/test_basic_deep_clone_modify_dst.birch"
    x->pushBack(Integer(1));
    #line 9 "src/test/basic/test_basic_deep_clone_modify_dst.birch"
    x->pushBack(Integer(2));
    auto y = copy(x);
    #line 15 "src/test/basic/test_basic_deep_clone_modify_dst.birch"
    y->set(Integer(1), Integer(3));
    #line 16 "src/test/basic/test_basic_deep_clone_modify_dst.birch"
    y->set(Integer(2), Integer(4));
    #line 19 "src/test/basic/test_basic_deep_clone_modify_dst.birch"
    if (x->get(Integer(1)) != Integer(1) || x->get(Integer(2)) != Integer(2)) {
      #line 20 "src/test/basic/test_basic_deep_clone_modify_dst.birch"
      exit(Integer(1));
    }
  }
  #line 5 "src/test/basic/test_basic_deep_clone_modify_dst.birch"
  libbirch::collect();
  #line 5 "src/test/basic/test_basic_deep_clone_modify_dst.birch"
  return 0;
}

}
namespace birch {
#line 5 "src/test/basic/test_basic_deep_clone_modify_src.birch"
int test_basic_deep_clone_modify_src(int argc_, char** argv_) {
  #line 5 "src/test/basic/test_basic_deep_clone_modify_src.birch"
  Eigen::initParallel();

  {
    List<Integer> x;
    #line 8 "src/test/basic/test_basic_deep_clone_modify_src.birch"
    x->pushBack(Integer(1));
    #line 9 "src/test/basic/test_basic_deep_clone_modify_src.birch"
    x->pushBack(Integer(2));
    auto y = copy(x);
    #line 15 "src/test/basic/test_basic_deep_clone_modify_src.birch"
    x->set(Integer(1), Integer(3));
    #line 16 "src/test/basic/test_basic_deep_clone_modify_src.birch"
    x->set(Integer(2), Integer(4));
    #line 19 "src/test/basic/test_basic_deep_clone_modify_src.birch"
    if (y->get(Integer(1)) != Integer(1) || y->get(Integer(2)) != Integer(2)) {
      #line 20 "src/test/basic/test_basic_deep_clone_modify_src.birch"
      exit(Integer(1));
    }
  }
  #line 5 "src/test/basic/test_basic_deep_clone_modify_src.birch"
  libbirch::collect();
  #line 5 "src/test/basic/test_basic_deep_clone_modify_src.birch"
  return 0;
}

}
namespace birch {
#line 4 "src/test/basic/test_basic_list.birch"
int test_basic_list(int argc_, char** argv_) {
  #line 4 "src/test/basic/test_basic_list.birch"
  Eigen::initParallel();

  {
    List<Integer> o;
    #line 7 "src/test/basic/test_basic_list.birch"
    o->pushBack(Integer(1));
    #line 8 "src/test/basic/test_basic_list.birch"
    o->pushBack(Integer(2));
    #line 9 "src/test/basic/test_basic_list.birch"
    o->pushBack(Integer(4));
    #line 10 "src/test/basic/test_basic_list.birch"
    o->pushBack(Integer(5));
    #line 11 "src/test/basic/test_basic_list.birch"
    if (!(check_container(o, libbirch::make_array_from_sequence({ Integer(1), Integer(2), Integer(4), Integer(5) })))) {
      #line 12 "src/test/basic/test_basic_list.birch"
      exit(Integer(1));
    }
    #line 15 "src/test/basic/test_basic_list.birch"
    o->insert(Integer(3), Integer(3));
    #line 16 "src/test/basic/test_basic_list.birch"
    if (!(check_container(o, libbirch::make_array_from_sequence({ Integer(1), Integer(2), Integer(3), Integer(4), Integer(5) })))) {
      #line 17 "src/test/basic/test_basic_list.birch"
      exit(Integer(1));
    }
    #line 20 "src/test/basic/test_basic_list.birch"
    o->erase(Integer(4));
    #line 21 "src/test/basic/test_basic_list.birch"
    if (!(check_container(o, libbirch::make_array_from_sequence({ Integer(1), Integer(2), Integer(3), Integer(5) })))) {
      #line 22 "src/test/basic/test_basic_list.birch"
      exit(Integer(1));
    }
    #line 25 "src/test/basic/test_basic_list.birch"
    o->popFront();
    #line 26 "src/test/basic/test_basic_list.birch"
    if (o->front() != Integer(2)) {
      #line 27 "src/test/basic/test_basic_list.birch"
      exit(Integer(1));
    }
    #line 30 "src/test/basic/test_basic_list.birch"
    o->popBack();
    #line 31 "src/test/basic/test_basic_list.birch"
    if (o->back() != Integer(3)) {
      #line 32 "src/test/basic/test_basic_list.birch"
      exit(Integer(1));
    }
    #line 35 "src/test/basic/test_basic_list.birch"
    o->clear();
    #line 36 "src/test/basic/test_basic_list.birch"
    if (o->size() != Integer(0) || !(o->empty())) {
      #line 37 "src/test/basic/test_basic_list.birch"
      stderr_->print(String("clear failed\n"));
      #line 38 "src/test/basic/test_basic_list.birch"
      exit(Integer(1));
    }
  }
  #line 4 "src/test/basic/test_basic_list.birch"
  libbirch::collect();
  #line 4 "src/test/basic/test_basic_list.birch"
  return 0;
}

}
namespace birch {
#line 4 "src/test/basic/test_basic_ragged_array.birch"
int test_basic_ragged_array(int argc_, char** argv_) {
  #line 4 "src/test/basic/test_basic_ragged_array.birch"
  Eigen::initParallel();

  {
    RaggedArray<Integer> o;
    #line 7 "src/test/basic/test_basic_ragged_array.birch"
    o->pushBack();
    #line 8 "src/test/basic/test_basic_ragged_array.birch"
    o->pushBack(Integer(1), Integer(1));
    #line 9 "src/test/basic/test_basic_ragged_array.birch"
    o->pushBack(Integer(1), Integer(2));
    #line 10 "src/test/basic/test_basic_ragged_array.birch"
    o->pushBack(Integer(1), Integer(3));
    #line 11 "src/test/basic/test_basic_ragged_array.birch"
    o->pushBack();
    #line 12 "src/test/basic/test_basic_ragged_array.birch"
    o->pushBack(Integer(2), Integer(4));
    #line 13 "src/test/basic/test_basic_ragged_array.birch"
    o->pushBack();
    #line 14 "src/test/basic/test_basic_ragged_array.birch"
    o->pushBack(Integer(3), Integer(5));
    #line 15 "src/test/basic/test_basic_ragged_array.birch"
    if (!(check_ragged_array(o, libbirch::make_array_from_sequence({ Integer(3), Integer(1), Integer(1) }), libbirch::make_array_from_sequence({ Integer(1), Integer(2), Integer(3), Integer(4), Integer(5) })))) {
      #line 16 "src/test/basic/test_basic_ragged_array.birch"
      exit(Integer(1));
    }
    #line 19 "src/test/basic/test_basic_ragged_array.birch"
    o->pushBack(Integer(2), Integer(6));
    #line 20 "src/test/basic/test_basic_ragged_array.birch"
    if (!(check_ragged_array(o, libbirch::make_array_from_sequence({ Integer(3), Integer(2), Integer(1) }), libbirch::make_array_from_sequence({ Integer(1), Integer(2), Integer(3), Integer(4), Integer(6), Integer(5) })))) {
      #line 21 "src/test/basic/test_basic_ragged_array.birch"
      exit(Integer(1));
    }
    #line 24 "src/test/basic/test_basic_ragged_array.birch"
    o->clear();
    #line 25 "src/test/basic/test_basic_ragged_array.birch"
    if (o->size() != Integer(0) || !(o->empty())) {
      #line 26 "src/test/basic/test_basic_ragged_array.birch"
      stderr_->print(String("clear failed\n"));
      #line 27 "src/test/basic/test_basic_ragged_array.birch"
      exit(Integer(1));
    }
  }
  #line 4 "src/test/basic/test_basic_ragged_array.birch"
  libbirch::collect();
  #line 4 "src/test/basic/test_basic_ragged_array.birch"
  return 0;
}

#line 31 "src/test/basic/test_basic_ragged_array.birch"
#line 31 "src/test/basic/test_basic_ragged_array.birch"
Boolean check_ragged_array(const RaggedArray<Integer>& o, const libbirch::DefaultArray<Integer,1>& sizes, const libbirch::DefaultArray<Integer,1>& values) {
  auto result = true;
  #line 36 "src/test/basic/test_basic_ragged_array.birch"
  if (o->size() != length(sizes)) {
    #line 37 "src/test/basic/test_basic_ragged_array.birch"
    stderr_->print(String("incorrect total size\n"));
    #line 38 "src/test/basic/test_basic_ragged_array.birch"
    result = false;
  }
  #line 42 "src/test/basic/test_basic_ragged_array.birch"
  for (auto i = Integer(1); i <= length(sizes); ++i) {
    #line 43 "src/test/basic/test_basic_ragged_array.birch"
    if (o->size(i) != sizes(i)) {
      #line 44 "src/test/basic/test_basic_ragged_array.birch"
      stderr_->print(String("incorrect row size\n"));
      #line 45 "src/test/basic/test_basic_ragged_array.birch"
      result = false;
    }
  }
  auto k = Integer(1);
  #line 51 "src/test/basic/test_basic_ragged_array.birch"
  for (auto i = Integer(1); i <= o->size(); ++i) {
    #line 52 "src/test/basic/test_basic_ragged_array.birch"
    for (auto j = Integer(1); j <= o->size(i); ++j) {
      #line 53 "src/test/basic/test_basic_ragged_array.birch"
      if (o->get(i, j) != values(k)) {
        #line 54 "src/test/basic/test_basic_ragged_array.birch"
        stderr_->print(String("incorrect value\n"));
        #line 55 "src/test/basic/test_basic_ragged_array.birch"
        result = false;
      }
      #line 57 "src/test/basic/test_basic_ragged_array.birch"
      k = k + Integer(1);
    }
  }
  #line 61 "src/test/basic/test_basic_ragged_array.birch"
  return result;
}

}
namespace birch {
#line 4 "src/test/basic/test_basic_stack.birch"
int test_basic_stack(int argc_, char** argv_) {
  #line 4 "src/test/basic/test_basic_stack.birch"
  Eigen::initParallel();

  {
    Stack<Integer> o;
    #line 7 "src/test/basic/test_basic_stack.birch"
    o->push(Integer(1));
    #line 8 "src/test/basic/test_basic_stack.birch"
    o->push(Integer(2));
    #line 9 "src/test/basic/test_basic_stack.birch"
    o->push(Integer(4));
    #line 10 "src/test/basic/test_basic_stack.birch"
    o->push(Integer(5));
    #line 11 "src/test/basic/test_basic_stack.birch"
    if (!(check_stack(o, libbirch::make_array_from_sequence({ Integer(5), Integer(4), Integer(2), Integer(1) })))) {
      #line 12 "src/test/basic/test_basic_stack.birch"
      exit(Integer(1));
    }
    #line 15 "src/test/basic/test_basic_stack.birch"
    o->push(Integer(3));
    #line 16 "src/test/basic/test_basic_stack.birch"
    if (!(check_stack(o, libbirch::make_array_from_sequence({ Integer(3), Integer(5), Integer(4), Integer(2), Integer(1) })))) {
      #line 17 "src/test/basic/test_basic_stack.birch"
      exit(Integer(1));
    }
    #line 20 "src/test/basic/test_basic_stack.birch"
    o->pop();
    #line 21 "src/test/basic/test_basic_stack.birch"
    if (!(check_stack(o, libbirch::make_array_from_sequence({ Integer(5), Integer(4), Integer(2), Integer(1) })))) {
      #line 22 "src/test/basic/test_basic_stack.birch"
      exit(Integer(1));
    }
    #line 25 "src/test/basic/test_basic_stack.birch"
    if (o->top() != Integer(5)) {
      #line 26 "src/test/basic/test_basic_stack.birch"
      exit(Integer(1));
    }
    #line 29 "src/test/basic/test_basic_stack.birch"
    o->clear();
    #line 30 "src/test/basic/test_basic_stack.birch"
    if (o->size() != Integer(0) || !(o->empty())) {
      #line 31 "src/test/basic/test_basic_stack.birch"
      stderr_->print(String("clear failed\n"));
      #line 32 "src/test/basic/test_basic_stack.birch"
      exit(Integer(1));
    }
  }
  #line 4 "src/test/basic/test_basic_stack.birch"
  libbirch::collect();
  #line 4 "src/test/basic/test_basic_stack.birch"
  return 0;
}

}
namespace birch {
#line 4 "src/test/basic/test_basic_tape.birch"
int test_basic_tape(int argc_, char** argv_) {
  #line 4 "src/test/basic/test_basic_tape.birch"
  Eigen::initParallel();

  {
    Tape<Integer> o;
    #line 7 "src/test/basic/test_basic_tape.birch"
    o->pushBack(Integer(1));
    #line 8 "src/test/basic/test_basic_tape.birch"
    o->pushBack(Integer(2));
    #line 9 "src/test/basic/test_basic_tape.birch"
    o->pushBack(Integer(4));
    #line 10 "src/test/basic/test_basic_tape.birch"
    o->pushBack(Integer(5));
    #line 11 "src/test/basic/test_basic_tape.birch"
    if (!(check_container(o, libbirch::make_array_from_sequence({ Integer(1), Integer(2), Integer(4), Integer(5) })))) {
      #line 12 "src/test/basic/test_basic_tape.birch"
      exit(Integer(1));
    }
    #line 15 "src/test/basic/test_basic_tape.birch"
    o->insert(Integer(3), Integer(3));
    #line 16 "src/test/basic/test_basic_tape.birch"
    if (!(check_container(o, libbirch::make_array_from_sequence({ Integer(1), Integer(2), Integer(3), Integer(4), Integer(5) })))) {
      #line 17 "src/test/basic/test_basic_tape.birch"
      exit(Integer(1));
    }
    #line 20 "src/test/basic/test_basic_tape.birch"
    o->erase(Integer(4));
    #line 21 "src/test/basic/test_basic_tape.birch"
    if (!(check_container(o, libbirch::make_array_from_sequence({ Integer(1), Integer(2), Integer(3), Integer(5) })))) {
      #line 22 "src/test/basic/test_basic_tape.birch"
      exit(Integer(1));
    }
    #line 25 "src/test/basic/test_basic_tape.birch"
    if (o->front() != Integer(1)) {
      #line 26 "src/test/basic/test_basic_tape.birch"
      exit(Integer(1));
    }
    #line 29 "src/test/basic/test_basic_tape.birch"
    if (o->back() != Integer(5)) {
      #line 30 "src/test/basic/test_basic_tape.birch"
      exit(Integer(1));
    }
  }
  #line 4 "src/test/basic/test_basic_tape.birch"
  libbirch::collect();
  #line 4 "src/test/basic/test_basic_tape.birch"
  return 0;
}

}
