namespace birch {
#line 1 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 1 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
TestMatrixGaussian_::TestMatrixGaussian_() :
    #line 1 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    X(),
    #line 4 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    n(Integer(5)),
    #line 5 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    p(Integer(4)),
    #line 7 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    M((libbirch::make_shape(n, p))),
    #line 8 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    U((libbirch::make_shape(n, n))),
    #line 9 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    V((libbirch::make_shape(p, p))) {
  //
}

#line 11 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 11 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 11 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
void TestMatrixGaussian_::initialize() {
  #line 12 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  M = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 12 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    return simulate_uniform(-(10.0), 10.0);
  }, n, p);
  #line 13 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  U = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 13 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, n, n);
  #line 14 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  V = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 14 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, p, p);
  #line 16 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  U = outer(U) + diagonal(1.0e-2, n);
  #line 17 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  V = outer(V) + diagonal(1.0e-2, p);
}

#line 20 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 20 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 20 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
void TestMatrixGaussian_::simulate() {
  #line 21 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    handle_assume(X, MatrixGaussian(M, U, V));
;
}

#line 24 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 24 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 24 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
libbirch::DefaultArray<Real,1> TestMatrixGaussian_::forward() {
  #line 25 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  return vec(X->eval());
}

#line 28 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 28 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 28 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
libbirch::DefaultArray<Real,1> TestMatrixGaussian_::backward() {
  #line 29 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  return vec(X->eval());
}

#line 32 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 32 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 32 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
Distribution<libbirch::DefaultArray<Real,2>> TestMatrixGaussian_::marginal() {
  #line 33 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  return X->getDistribution();
}

#line 36 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 36 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
#line 36 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
Integer TestMatrixGaussian_::size() {
  #line 37 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  return n * p;
}

#line 1 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
TestMatrixGaussian_* make_TestMatrixGaussian_() {
  #line 1 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  return new TestMatrixGaussian_();
  #line 1 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
}

#line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
int test_pdf_matrix_gaussian(int argc_, char** argv_) {
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  [[maybe_unused]] Integer B = Integer(1000);
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  [[maybe_unused]] Integer S = Integer(20);
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  int c_, option_index_;
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  option long_options_[] = {
    #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    {0, 0, 0, 0}
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  };
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  const char* short_options_ = ":";
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  ::opterr = 0;
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  while (c_ != -1) {
    #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    switch (c_) {
      #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      case NFLAG_:
        #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        if (!::optarg) {
          #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        }
        #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        break;
      #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      case BFLAG_:
        #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        if (!::optarg) {
          #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        }
        #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        break;
      #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      case SFLAG_:
        #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        if (!::optarg) {
          #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        }
        #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        break;
      #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      case lazyFLAG_:
        #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        if (!::optarg) {
          #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        }
        #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 42 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        break;
      #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      case '?':
        #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      case ':':
        #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      default:
        #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  Eigen::initParallel();

  {
    TestMatrixGaussian m;
    #line 44 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    m->initialize();
    #line 45 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    m->simulate();
    #line 46 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  libbirch::collect();
  #line 41 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  return 0;
}

#line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
int test_grad_matrix_gaussian(int argc_, char** argv_) {
  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  int c_, option_index_;
  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  option long_options_[] = {
    #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    {0, 0, 0, 0}
  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  };
  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  const char* short_options_ = ":";
  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  ::opterr = 0;
  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  while (c_ != -1) {
    #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    switch (c_) {
      #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      case NFLAG_:
        #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        if (!::optarg) {
          #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        }
        #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        break;
      #line 50 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      case backwardFLAG_:
        #line 50 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        if (!::optarg) {
          #line 50 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 50 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        }
        #line 50 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 50 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        break;
      #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      case '?':
        #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      case ':':
        #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
      default:
        #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  Eigen::initParallel();

  {
    TestMatrixGaussian m;
    #line 52 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
    test_grad(m, N, backward);
  }
  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  libbirch::collect();
  #line 49 "src/test/distribution/matrix_gaussian/TestMatrixGaussian.birch"
  return 0;
}

}
