namespace birch {
#line 1 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 1 "src/test/distribution/matrix_other/TestInverseWishart.birch"
TestInverseWishart_::TestInverseWishart_() :
    #line 1 "src/test/distribution/matrix_other/TestInverseWishart.birch"
    base_type_(),
    #line 2 "src/test/distribution/matrix_other/TestInverseWishart.birch"
    \u03a3(),
    #line 3 "src/test/distribution/matrix_other/TestInverseWishart.birch"
    p(Integer(4)),
    #line 4 "src/test/distribution/matrix_other/TestInverseWishart.birch"
    k(),
    #line 5 "src/test/distribution/matrix_other/TestInverseWishart.birch"
    \u03a8((libbirch::make_shape(p, p))) {
  //
}

#line 7 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 7 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 7 "src/test/distribution/matrix_other/TestInverseWishart.birch"
void TestInverseWishart_::initialize() {
  #line 8 "src/test/distribution/matrix_other/TestInverseWishart.birch"
  k = simulate_uniform(2.0, 10.0);
  #line 9 "src/test/distribution/matrix_other/TestInverseWishart.birch"
  \u03a8 = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 10 "src/test/distribution/matrix_other/TestInverseWishart.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, p, p);
  #line 11 "src/test/distribution/matrix_other/TestInverseWishart.birch"
  \u03a8 = outer(\u03a8) + diagonal(1.0e-2, p);
}

#line 14 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 14 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 14 "src/test/distribution/matrix_other/TestInverseWishart.birch"
void TestInverseWishart_::simulate() {
  #line 15 "src/test/distribution/matrix_other/TestInverseWishart.birch"
    handle_assume(\u03a3, InverseWishart(\u03a8, k));
;
}

#line 18 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 18 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 18 "src/test/distribution/matrix_other/TestInverseWishart.birch"
libbirch::DefaultArray<Real,1> TestInverseWishart_::forward() {
  #line 19 "src/test/distribution/matrix_other/TestInverseWishart.birch"
  \u03a3->eval();
  #line 20 "src/test/distribution/matrix_other/TestInverseWishart.birch"
  return vectorize();
}

#line 23 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 23 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 23 "src/test/distribution/matrix_other/TestInverseWishart.birch"
libbirch::DefaultArray<Real,1> TestInverseWishart_::backward() {
  #line 24 "src/test/distribution/matrix_other/TestInverseWishart.birch"
  \u03a3->eval();
  #line 25 "src/test/distribution/matrix_other/TestInverseWishart.birch"
  return vectorize();
}

#line 28 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 28 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 28 "src/test/distribution/matrix_other/TestInverseWishart.birch"
Distribution<libbirch::DefaultArray<Real,2>> TestInverseWishart_::marginal() {
  #line 29 "src/test/distribution/matrix_other/TestInverseWishart.birch"
  return \u03a3->getDistribution();
}

#line 32 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 32 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 32 "src/test/distribution/matrix_other/TestInverseWishart.birch"
libbirch::DefaultArray<Real,1> TestInverseWishart_::vectorize() {
  #line 33 "src/test/distribution/matrix_other/TestInverseWishart.birch"
  return vec(\u03a3->eval());
}

#line 36 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 36 "src/test/distribution/matrix_other/TestInverseWishart.birch"
#line 36 "src/test/distribution/matrix_other/TestInverseWishart.birch"
Integer TestInverseWishart_::size() {
  #line 37 "src/test/distribution/matrix_other/TestInverseWishart.birch"
  return p * p;
}

#line 1 "src/test/distribution/matrix_other/TestInverseWishart.birch"
TestInverseWishart_* make_TestInverseWishart_() {
  #line 1 "src/test/distribution/matrix_other/TestInverseWishart.birch"
  return new TestInverseWishart_();
  #line 1 "src/test/distribution/matrix_other/TestInverseWishart.birch"
}

}
namespace birch {
#line 1 "src/test/distribution/matrix_other/TestWishart.birch"
#line 1 "src/test/distribution/matrix_other/TestWishart.birch"
TestWishart_::TestWishart_() :
    #line 1 "src/test/distribution/matrix_other/TestWishart.birch"
    base_type_(),
    #line 2 "src/test/distribution/matrix_other/TestWishart.birch"
    \u03a3(),
    #line 3 "src/test/distribution/matrix_other/TestWishart.birch"
    p(Integer(4)),
    #line 4 "src/test/distribution/matrix_other/TestWishart.birch"
    k(),
    #line 5 "src/test/distribution/matrix_other/TestWishart.birch"
    \u03a8((libbirch::make_shape(p, p))) {
  //
}

#line 7 "src/test/distribution/matrix_other/TestWishart.birch"
#line 7 "src/test/distribution/matrix_other/TestWishart.birch"
#line 7 "src/test/distribution/matrix_other/TestWishart.birch"
void TestWishart_::initialize() {
  #line 8 "src/test/distribution/matrix_other/TestWishart.birch"
  k = simulate_uniform(2.0, 10.0);
  #line 9 "src/test/distribution/matrix_other/TestWishart.birch"
  \u03a8 = matrix_lambda([=](const Integer& i, const Integer& j) {
    #line 10 "src/test/distribution/matrix_other/TestWishart.birch"
    return simulate_uniform(-(2.0), 2.0);
  }, p, p);
  #line 11 "src/test/distribution/matrix_other/TestWishart.birch"
  \u03a8 = outer(\u03a8) + diagonal(1.0e-2, p);
}

#line 14 "src/test/distribution/matrix_other/TestWishart.birch"
#line 14 "src/test/distribution/matrix_other/TestWishart.birch"
#line 14 "src/test/distribution/matrix_other/TestWishart.birch"
void TestWishart_::simulate() {
  #line 15 "src/test/distribution/matrix_other/TestWishart.birch"
    handle_assume(\u03a3, Wishart(\u03a8, k));
;
}

#line 18 "src/test/distribution/matrix_other/TestWishart.birch"
#line 18 "src/test/distribution/matrix_other/TestWishart.birch"
#line 18 "src/test/distribution/matrix_other/TestWishart.birch"
libbirch::DefaultArray<Real,1> TestWishart_::forward() {
  #line 19 "src/test/distribution/matrix_other/TestWishart.birch"
  \u03a3->eval();
  #line 20 "src/test/distribution/matrix_other/TestWishart.birch"
  return vectorize();
}

#line 23 "src/test/distribution/matrix_other/TestWishart.birch"
#line 23 "src/test/distribution/matrix_other/TestWishart.birch"
#line 23 "src/test/distribution/matrix_other/TestWishart.birch"
libbirch::DefaultArray<Real,1> TestWishart_::backward() {
  #line 24 "src/test/distribution/matrix_other/TestWishart.birch"
  \u03a3->eval();
  #line 25 "src/test/distribution/matrix_other/TestWishart.birch"
  return vectorize();
}

#line 28 "src/test/distribution/matrix_other/TestWishart.birch"
#line 28 "src/test/distribution/matrix_other/TestWishart.birch"
#line 28 "src/test/distribution/matrix_other/TestWishart.birch"
Distribution<libbirch::DefaultArray<Real,2>> TestWishart_::marginal() {
  #line 29 "src/test/distribution/matrix_other/TestWishart.birch"
  return \u03a3->getDistribution();
}

#line 32 "src/test/distribution/matrix_other/TestWishart.birch"
#line 32 "src/test/distribution/matrix_other/TestWishart.birch"
#line 32 "src/test/distribution/matrix_other/TestWishart.birch"
libbirch::DefaultArray<Real,1> TestWishart_::vectorize() {
  #line 33 "src/test/distribution/matrix_other/TestWishart.birch"
  return vec(\u03a3->eval());
}

#line 36 "src/test/distribution/matrix_other/TestWishart.birch"
#line 36 "src/test/distribution/matrix_other/TestWishart.birch"
#line 36 "src/test/distribution/matrix_other/TestWishart.birch"
Integer TestWishart_::size() {
  #line 37 "src/test/distribution/matrix_other/TestWishart.birch"
  return p * p;
}

#line 1 "src/test/distribution/matrix_other/TestWishart.birch"
TestWishart_* make_TestWishart_() {
  #line 1 "src/test/distribution/matrix_other/TestWishart.birch"
  return new TestWishart_();
  #line 1 "src/test/distribution/matrix_other/TestWishart.birch"
}

}
