namespace birch {
#line 1 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
#line 1 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
TestDirichletMultinomial_::TestDirichletMultinomial_() :
    #line 1 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    base_type_(),
    #line 2 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    n(),
    #line 3 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    \u03b1((libbirch::make_shape(Integer(5)))),
    #line 4 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    \u03c1(),
    #line 5 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    x() {
  //
}

#line 7 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
#line 7 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
#line 7 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
void TestDirichletMultinomial_::initialize() {
  #line 8 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  n = simulate_uniform_int(Integer(100), Integer(500));
  #line 9 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  for (auto i = Integer(1); i <= Integer(5); ++i) {
    #line 10 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    \u03b1(i) = simulate_uniform(1.0, 10.0);
  }
}

#line 14 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
#line 14 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
#line 14 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
void TestDirichletMultinomial_::simulate() {
  #line 15 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    handle_assume(\u03c1, Dirichlet(\u03b1));
;
  #line 16 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    handle_assume(x, Multinomial(n, \u03c1));
;
}

#line 19 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
#line 19 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
#line 19 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
libbirch::DefaultArray<Real,1> TestDirichletMultinomial_::forward() {
  Integer D = length(\u03b1);
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2) * D));
  #line 22 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  y(libbirch::make_range(Integer(1), D)) = \u03c1->eval();
  #line 23 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  y(libbirch::make_range(D + Integer(1), Integer(2) * D)) = x->eval();
  #line 24 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  return y;
}

#line 27 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
#line 27 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
#line 27 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
libbirch::DefaultArray<Real,1> TestDirichletMultinomial_::backward() {
  Integer D = length(\u03b1);
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2) * D));
  #line 30 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  assert(!(x->hasValue()));
  #line 31 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  y(libbirch::make_range(D + Integer(1), Integer(2) * D)) = x->eval();
  #line 32 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  assert(!(\u03c1->hasValue()));
  #line 33 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  y(libbirch::make_range(Integer(1), D)) = \u03c1->eval();
  #line 34 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  return y;
}

#line 37 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
#line 37 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
#line 37 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
Integer TestDirichletMultinomial_::size() {
  #line 38 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  return Integer(2) * length(\u03b1);
}

#line 1 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
TestDirichletMultinomial_* make_TestDirichletMultinomial_() {
  #line 1 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  return new TestDirichletMultinomial_();
  #line 1 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
}

#line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
int test_conjugacy_dirichlet_multinomial(int argc_, char** argv_) {
  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  int c_, option_index_;
  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  option long_options_[] = {
    #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    {0, 0, 0, 0}
  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  };
  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  const char* short_options_ = ":";
  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  ::opterr = 0;
  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  while (c_ != -1) {
    #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    switch (c_) {
      #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
      case NFLAG_:
        #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
        if (!::optarg) {
          #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
        }
        #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
        N = from_string<Integer>(String(::optarg));
        #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
        break;
      #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
      case lazyFLAG_:
        #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
        if (!::optarg) {
          #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
        }
        #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
        break;
      #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
      case '?':
        #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
      case ':':
        #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
      default:
        #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  Eigen::initParallel();

  {
    TestDirichletMultinomial m;
    #line 44 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  libbirch::collect();
  #line 42 "src/test/distribution/multivariate_discrete/TestDirichletMultinomial.birch"
  return 0;
}

}
