namespace birch {
#line 1 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 1 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
TestChainMultivariateGaussian_::TestChainMultivariateGaussian_() :
    #line 1 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    x((libbirch::make_shape(Integer(5)))),
    #line 3 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    \u03bc((libbirch::make_shape(Integer(3)))),
    #line 4 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    \u03a3((libbirch::make_shape(Integer(3), Integer(3)))) {
  //
}

#line 6 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 6 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 6 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
void TestChainMultivariateGaussian_::initialize() {
  #line 7 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  for (auto i = Integer(1); i <= Integer(3); ++i) {
    #line 8 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    \u03bc(i) = simulate_uniform(-(10.0), 10.0);
    #line 9 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    for (auto j = Integer(1); j <= Integer(3); ++j) {
      #line 10 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      \u03a3(i, j) = simulate_uniform(-(2.0), 2.0);
    }
  }
  #line 13 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  \u03a3 = outer(\u03a3) + diagonal(1.0e-2, Integer(3));
}

#line 16 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 16 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 16 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
void TestChainMultivariateGaussian_::simulate() {
  #line 17 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    handle_assume(x(Integer(1)), MultivariateGaussian(\u03bc, \u03a3));
;
  #line 18 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    handle_assume(x(Integer(2)), MultivariateGaussian(x(Integer(1)), \u03a3));
;
  #line 19 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    handle_assume(x(Integer(3)), MultivariateGaussian(x(Integer(2)), \u03a3));
;
  #line 20 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    handle_assume(x(Integer(4)), MultivariateGaussian(x(Integer(3)), \u03a3));
;
  #line 21 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    handle_assume(x(Integer(5)), MultivariateGaussian(x(Integer(4)), \u03a3));
;
}

#line 24 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 24 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 24 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
libbirch::DefaultArray<Real,1> TestChainMultivariateGaussian_::forward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(15)));
  #line 26 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  for (auto i = Integer(1); i <= Integer(5); ++i) {
    #line 27 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    y(libbirch::make_range((i - Integer(1)) * Integer(3) + Integer(1), i * Integer(3))) = x(i)->eval();
  }
  #line 29 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  return y;
}

#line 32 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 32 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 32 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
libbirch::DefaultArray<Real,1> TestChainMultivariateGaussian_::backward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(15)));
  #line 34 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  for (auto i = Integer(0); i <= Integer(4); ++i) {
    #line 35 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    assert(!(x(Integer(5) - i)->hasValue()));
    #line 36 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    y(libbirch::make_range((Integer(4) - i) * Integer(3) + Integer(1), (Integer(5) - i) * Integer(3))) = x(Integer(5) - i)->eval();
  }
  #line 38 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  return y;
}

#line 41 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 41 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 41 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
Distribution<libbirch::DefaultArray<Real,1>> TestChainMultivariateGaussian_::marginal() {
  #line 42 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  return x(Integer(5))->getDistribution();
}

#line 45 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 45 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
#line 45 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
Integer TestChainMultivariateGaussian_::size() {
  #line 46 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  return Integer(15);
}

#line 1 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
TestChainMultivariateGaussian_* make_TestChainMultivariateGaussian_() {
  #line 1 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  return new TestChainMultivariateGaussian_();
  #line 1 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
}

#line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
int test_conjugacy_chain_multivariate_gaussian(int argc_, char** argv_) {
  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  int c_, option_index_;
  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  option long_options_[] = {
    #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  };
  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  ::opterr = 0;
  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    switch (c_) {
      #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case NFLAG_:
        #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        if (!::optarg) {
          #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        }
        #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        break;
      #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case lazyFLAG_:
        #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        if (!::optarg) {
          #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        }
        #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        break;
      #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case '?':
        #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case ':':
        #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      default:
        #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestChainMultivariateGaussian m;
    #line 52 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  libbirch::collect();
  #line 50 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  return 0;
}

#line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
int test_pdf_chain_multivariate_gaussian(int argc_, char** argv_) {
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  [[maybe_unused]] Integer B = Integer(1000);
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  [[maybe_unused]] Integer S = Integer(20);
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  int c_, option_index_;
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  option long_options_[] = {
    #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  };
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  ::opterr = 0;
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    switch (c_) {
      #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case NFLAG_:
        #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        if (!::optarg) {
          #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        }
        #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        break;
      #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case BFLAG_:
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        if (!::optarg) {
          #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        }
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        break;
      #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case SFLAG_:
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        if (!::optarg) {
          #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        }
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        break;
      #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case lazyFLAG_:
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        if (!::optarg) {
          #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        }
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 56 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        break;
      #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case '?':
        #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case ':':
        #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      default:
        #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestChainMultivariateGaussian m;
    #line 58 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    m->initialize();
    #line 59 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    m->simulate();
    #line 60 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  libbirch::collect();
  #line 55 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  return 0;
}

#line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
int test_grad_chain_multivariate_gaussian(int argc_, char** argv_) {
  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  int c_, option_index_;
  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  option long_options_[] = {
    #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  };
  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  ::opterr = 0;
  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    switch (c_) {
      #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case NFLAG_:
        #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        if (!::optarg) {
          #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        }
        #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        break;
      #line 64 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case backwardFLAG_:
        #line 64 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        if (!::optarg) {
          #line 64 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 64 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        }
        #line 64 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 64 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        break;
      #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case '?':
        #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      case ':':
        #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
      default:
        #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestChainMultivariateGaussian m;
    #line 66 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
    test_grad(m, N, backward);
  }
  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  libbirch::collect();
  #line 63 "src/test/distribution/multivariate_gaussian/TestChainMultivariateGaussian.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 1 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
TestLinearMultivariateGaussianMultivariateGaussian_::TestLinearMultivariateGaussianMultivariateGaussian_() :
    #line 1 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    \u03bc(),
    #line 3 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    x(),
    #line 5 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    n(Integer(4)),
    #line 7 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    A((libbirch::make_shape(n, n))),
    #line 8 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    \u03bc_0((libbirch::make_shape(n))),
    #line 9 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    \u03a3_0((libbirch::make_shape(n, n))),
    #line 10 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    c((libbirch::make_shape(n))),
    #line 11 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    \u03a3_1((libbirch::make_shape(n, n))) {
  //
}

#line 13 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 13 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 13 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
void TestLinearMultivariateGaussianMultivariateGaussian_::initialize() {
  #line 14 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  for (auto i = Integer(1); i <= n; ++i) {
    #line 15 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    \u03bc_0(i) = simulate_uniform(-(10.0), 10.0);
    #line 16 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    c(i) = simulate_uniform(-(10.0), 10.0);
    #line 17 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    for (auto j = Integer(1); j <= n; ++j) {
      #line 18 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      \u03a3_0(i, j) = simulate_uniform(-(2.0), 2.0);
      #line 19 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      \u03a3_1(i, j) = simulate_uniform(-(2.0), 2.0);
      #line 20 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      A(i, j) = simulate_uniform(-(2.0), 2.0);
    }
  }
  #line 23 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  \u03a3_0 = outer(\u03a3_0) + diagonal(1.0e-2, n);
  #line 24 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  \u03a3_1 = outer(\u03a3_1) + diagonal(1.0e-2, n);
}

#line 27 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 27 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 27 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
void TestLinearMultivariateGaussianMultivariateGaussian_::simulate() {
  #line 28 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    handle_assume(\u03bc, MultivariateGaussian(\u03bc_0, \u03a3_0));
;
  #line 29 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    handle_assume(x, MultivariateGaussian(A * \u03bc + c, \u03a3_1));
;
}

#line 32 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 32 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 32 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearMultivariateGaussianMultivariateGaussian_::forward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2) * n));
  #line 34 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  y(libbirch::make_range(Integer(1), n)) = \u03bc->eval();
  #line 35 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  y(libbirch::make_range((n + Integer(1)), Integer(2) * n)) = x->eval();
  #line 36 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  return y;
}

#line 39 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 39 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 39 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
libbirch::DefaultArray<Real,1> TestLinearMultivariateGaussianMultivariateGaussian_::backward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2) * n));
  #line 41 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  assert(!(x->hasValue()));
  #line 42 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  y(libbirch::make_range((n + Integer(1)), Integer(2) * n)) = x->eval();
  #line 43 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  assert(!(\u03bc->hasValue()));
  #line 44 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  y(libbirch::make_range(Integer(1), n)) = \u03bc->eval();
  #line 45 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  return y;
}

#line 48 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 48 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 48 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
Distribution<libbirch::DefaultArray<Real,1>> TestLinearMultivariateGaussianMultivariateGaussian_::marginal() {
  #line 49 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  return x->getDistribution();
}

#line 52 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 52 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
#line 52 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
Integer TestLinearMultivariateGaussianMultivariateGaussian_::size() {
  #line 53 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  return Integer(2) * n;
}

#line 1 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
TestLinearMultivariateGaussianMultivariateGaussian_* make_TestLinearMultivariateGaussianMultivariateGaussian_() {
  #line 1 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  return new TestLinearMultivariateGaussianMultivariateGaussian_();
  #line 1 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
}

#line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
int test_conjugacy_linear_multivariate_gaussian_multivariate_gaussian(int argc_, char** argv_) {
  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  int c_, option_index_;
  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  option long_options_[] = {
    #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  };
  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  ::opterr = 0;
  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    switch (c_) {
      #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case NFLAG_:
        #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case lazyFLAG_:
        #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 58 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case '?':
        #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case ':':
        #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      default:
        #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMultivariateGaussianMultivariateGaussian m;
    #line 60 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  libbirch::collect();
  #line 57 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  return 0;
}

#line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
int test_pdf_linear_multivariate_gaussian_multivariate_gaussian(int argc_, char** argv_) {
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Integer B = Integer(1000);
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Integer S = Integer(20);
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  int c_, option_index_;
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  option long_options_[] = {
    #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  };
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  ::opterr = 0;
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    switch (c_) {
      #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case NFLAG_:
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case BFLAG_:
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case SFLAG_:
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 64 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 65 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case lazyFLAG_:
        #line 65 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 65 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 65 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 65 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 65 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case '?':
        #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case ':':
        #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      default:
        #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMultivariateGaussianMultivariateGaussian m;
    #line 67 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    m->initialize();
    #line 68 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    m->simulate();
    #line 69 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  libbirch::collect();
  #line 63 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  return 0;
}

#line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
int test_grad_linear_multivariate_gaussian_multivariate_gaussian(int argc_, char** argv_) {
  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  int c_, option_index_;
  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  option long_options_[] = {
    #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  };
  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  ::opterr = 0;
  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    switch (c_) {
      #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case NFLAG_:
        #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case backwardFLAG_:
        #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 73 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case '?':
        #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      case ':':
        #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
      default:
        #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestLinearMultivariateGaussianMultivariateGaussian m;
    #line 75 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
    test_grad(m, N, backward);
  }
  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  libbirch::collect();
  #line 72 "src/test/distribution/multivariate_gaussian/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
TestMultivariateGaussian_::TestMultivariateGaussian_() :
    #line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    x(),
    #line 3 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    \u03bc((libbirch::make_shape(Integer(5)))),
    #line 4 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    \u03a3((libbirch::make_shape(Integer(5), Integer(5)))) {
  //
}

#line 6 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 6 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 6 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
void TestMultivariateGaussian_::initialize() {
  #line 7 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  for (auto i = Integer(1); i <= Integer(5); ++i) {
    #line 8 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    \u03bc(i) = simulate_uniform(-(10.0), 10.0);
    #line 9 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    for (auto j = Integer(1); j <= Integer(5); ++j) {
      #line 10 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      \u03a3(i, j) = simulate_uniform(-(2.0), 2.0);
    }
  }
  #line 13 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  \u03a3 = outer(\u03a3) + diagonal(1.0e-2, Integer(5));
}

#line 16 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 16 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 16 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
void TestMultivariateGaussian_::simulate() {
  #line 17 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    handle_assume(x, MultivariateGaussian(\u03bc, \u03a3));
;
}

#line 20 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 20 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 20 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
libbirch::DefaultArray<Real,1> TestMultivariateGaussian_::forward() {
  #line 21 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  return x->eval();
}

#line 24 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 24 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 24 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
libbirch::DefaultArray<Real,1> TestMultivariateGaussian_::backward() {
  #line 25 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  return x->eval();
}

#line 28 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 28 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 28 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
Distribution<libbirch::DefaultArray<Real,1>> TestMultivariateGaussian_::marginal() {
  #line 29 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  return x->getDistribution();
}

#line 32 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 32 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
#line 32 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
Integer TestMultivariateGaussian_::size() {
  #line 33 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  return Integer(5);
}

#line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
TestMultivariateGaussian_* make_TestMultivariateGaussian_() {
  #line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  return new TestMultivariateGaussian_();
  #line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
}

#line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
int test_conjugacy_multivariate_gaussian(int argc_, char** argv_) {
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  int c_, option_index_;
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  option long_options_[] = {
    #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  };
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  ::opterr = 0;
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    switch (c_) {
      #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case NFLAG_:
        #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        if (!::optarg) {
          #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        }
        #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        break;
      #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case lazyFLAG_:
        #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        if (!::optarg) {
          #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        }
        #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        break;
      #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case '?':
        #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case ':':
        #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      default:
        #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestMultivariateGaussian m;
    #line 39 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  libbirch::collect();
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  return 0;
}

#line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
int test_pdf_multivariate_gaussian(int argc_, char** argv_) {
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  [[maybe_unused]] Integer B = Integer(1000);
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  [[maybe_unused]] Integer S = Integer(20);
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  int c_, option_index_;
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  option long_options_[] = {
    #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  };
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  ::opterr = 0;
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    switch (c_) {
      #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case NFLAG_:
        #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        if (!::optarg) {
          #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        }
        #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        break;
      #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case BFLAG_:
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        if (!::optarg) {
          #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        }
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        break;
      #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case SFLAG_:
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        if (!::optarg) {
          #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        }
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        break;
      #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case lazyFLAG_:
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        if (!::optarg) {
          #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        }
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 43 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        break;
      #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case '?':
        #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case ':':
        #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      default:
        #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestMultivariateGaussian m;
    #line 45 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    m->initialize();
    #line 46 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    m->simulate();
    #line 47 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  libbirch::collect();
  #line 42 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  return 0;
}

#line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
int test_grad_multivariate_gaussian(int argc_, char** argv_) {
  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  int c_, option_index_;
  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  option long_options_[] = {
    #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  };
  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  ::opterr = 0;
  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    switch (c_) {
      #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case NFLAG_:
        #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        if (!::optarg) {
          #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        }
        #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        break;
      #line 51 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case backwardFLAG_:
        #line 51 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        if (!::optarg) {
          #line 51 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 51 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        }
        #line 51 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 51 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        break;
      #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case '?':
        #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      case ':':
        #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
      default:
        #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestMultivariateGaussian m;
    #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
    test_grad(m, N, backward);
  }
  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  libbirch::collect();
  #line 50 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussian.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
TestMultivariateGaussianMultivariateGaussian_::TestMultivariateGaussianMultivariateGaussian_() :
    #line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    base_type_(),
    #line 2 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    \u03bc_1(),
    #line 3 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    x(),
    #line 5 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    n(Integer(4)),
    #line 7 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    \u03bc_0((libbirch::make_shape(n))),
    #line 8 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    \u03a3_0((libbirch::make_shape(n, n))),
    #line 9 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    \u03a3_1((libbirch::make_shape(n, n))) {
  //
}

#line 11 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 11 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 11 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
void TestMultivariateGaussianMultivariateGaussian_::initialize() {
  #line 12 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  for (auto i = Integer(1); i <= n; ++i) {
    #line 13 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    \u03bc_0(i) = simulate_uniform(-(10.0), 10.0);
    #line 14 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    for (auto j = Integer(1); j <= n; ++j) {
      #line 15 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      \u03a3_0(i, j) = simulate_uniform(-(2.0), 2.0);
      #line 16 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      \u03a3_1(i, j) = simulate_uniform(-(2.0), 2.0);
    }
  }
  #line 19 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  \u03a3_0 = outer(\u03a3_0) + diagonal(1.0e-2, n);
  #line 20 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  \u03a3_1 = outer(\u03a3_1) + diagonal(1.0e-2, n);
}

#line 23 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 23 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 23 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
void TestMultivariateGaussianMultivariateGaussian_::simulate() {
  #line 24 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    handle_assume(\u03bc_1, MultivariateGaussian(\u03bc_0, \u03a3_0));
;
  #line 25 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    handle_assume(x, MultivariateGaussian(\u03bc_1, \u03a3_1));
;
}

#line 28 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 28 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 28 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
libbirch::DefaultArray<Real,1> TestMultivariateGaussianMultivariateGaussian_::forward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2) * n));
  #line 30 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  y(libbirch::make_range(Integer(1), n)) = \u03bc_1->eval();
  #line 31 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  y(libbirch::make_range((n + Integer(1)), Integer(2) * n)) = x->eval();
  #line 32 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  return y;
}

#line 35 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 35 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 35 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
libbirch::DefaultArray<Real,1> TestMultivariateGaussianMultivariateGaussian_::backward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(Integer(2) * n));
  #line 37 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  assert(!(x->hasValue()));
  #line 38 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  y(libbirch::make_range((n + Integer(1)), Integer(2) * n)) = x->eval();
  #line 39 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  assert(!(\u03bc_1->hasValue()));
  #line 40 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  y(libbirch::make_range(Integer(1), n)) = \u03bc_1->eval();
  #line 41 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  return y;
}

#line 44 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 44 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 44 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
Distribution<libbirch::DefaultArray<Real,1>> TestMultivariateGaussianMultivariateGaussian_::marginal() {
  #line 45 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  return x->getDistribution();
}

#line 48 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 48 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
#line 48 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
Integer TestMultivariateGaussianMultivariateGaussian_::size() {
  #line 49 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  return Integer(2) * n;
}

#line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
TestMultivariateGaussianMultivariateGaussian_* make_TestMultivariateGaussianMultivariateGaussian_() {
  #line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  return new TestMultivariateGaussianMultivariateGaussian_();
  #line 1 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
}

#line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
int test_conjugacy_multivariate_gaussian_multivariate_gaussian(int argc_, char** argv_) {
  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  int c_, option_index_;
  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  option long_options_[] = {
    #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  };
  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  ::opterr = 0;
  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    switch (c_) {
      #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case NFLAG_:
        #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case lazyFLAG_:
        #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case '?':
        #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case ':':
        #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      default:
        #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestMultivariateGaussianMultivariateGaussian m;
    #line 55 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  libbirch::collect();
  #line 53 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  return 0;
}

#line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
int test_pdf_multivariate_gaussian_multivariate_gaussian(int argc_, char** argv_) {
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Integer B = Integer(1000);
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Integer S = Integer(20);
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  int c_, option_index_;
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  option long_options_[] = {
    #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  };
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  ::opterr = 0;
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    switch (c_) {
      #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case NFLAG_:
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case BFLAG_:
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        B = from_string<Integer>(String(::optarg));
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case SFLAG_:
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        S = from_string<Integer>(String(::optarg));
        #line 59 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 60 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case lazyFLAG_:
        #line 60 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 60 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 60 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 60 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 60 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case '?':
        #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case ':':
        #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      default:
        #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestMultivariateGaussianMultivariateGaussian m;
    #line 62 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    m->initialize();
    #line 63 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    m->simulate();
    #line 64 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    test_pdf(m->marginal(), N, B, S, lazy);
  }
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  libbirch::collect();
  #line 58 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  return 0;
}

#line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
int test_grad_multivariate_gaussian_multivariate_gaussian(int argc_, char** argv_) {
  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Integer N = Integer(1000);
  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  [[maybe_unused]] Boolean backward = false;
  
  enum {
    NFLAG_,
    backwardFLAG_,
  };
  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  int c_, option_index_;
  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  option long_options_[] = {
    #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    {"backward", required_argument, 0, backwardFLAG_ },
    #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    {0, 0, 0, 0}
  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  };
  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  const char* short_options_ = ":";
  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  ::opterr = 0;
  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  while (c_ != -1) {
    #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    switch (c_) {
      #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case NFLAG_:
        #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        N = from_string<Integer>(String(::optarg));
        #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case backwardFLAG_:
        #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        if (!::optarg) {
          #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        }
        #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        backward = from_string<Boolean>(String(::optarg));
        #line 68 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        break;
      #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case '?':
        #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      case ':':
        #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
      default:
        #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  Eigen::initParallel();

  {
    TestMultivariateGaussianMultivariateGaussian m;
    #line 70 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
    test_grad(m, N, backward);
  }
  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  libbirch::collect();
  #line 67 "src/test/distribution/multivariate_gaussian/TestMultivariateGaussianMultivariateGaussian.birch"
  return 0;
}

}
