namespace birch {
#line 1 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 1 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
TestAddDiscreteDelta_::TestAddDiscreteDelta_() :
    #line 1 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    base_type_(),
    #line 2 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    x1(),
    #line 3 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    x2(),
    #line 4 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    s() {
  //
}

#line 6 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 6 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 6 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
void TestAddDiscreteDelta_::initialize() {
}

#line 10 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 10 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 10 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
void TestAddDiscreteDelta_::simulate() {
  #line 11 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    handle_assume(x1, UniformInteger(Integer(1), Integer(100)));
;
  #line 12 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    handle_assume(x2, Binomial(Integer(100), 0.25));
;
  #line 13 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    handle_assume(s, Delta(x1 + x2));
;
}

#line 16 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 16 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 16 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
libbirch::DefaultArray<Real,1> TestAddDiscreteDelta_::forward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(size()));
  #line 18 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  y(Integer(1)) = x1->eval();
  #line 19 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  y(Integer(2)) = x2->eval();
  #line 20 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  y(Integer(3)) = s->eval();
  #line 21 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  return y;
}

#line 24 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 24 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 24 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
libbirch::DefaultArray<Real,1> TestAddDiscreteDelta_::backward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(size()));
  #line 26 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  y(Integer(3)) = s->eval();
  #line 27 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  assert(!(x1->hasValue()));
  #line 28 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  assert(!(x2->hasValue()));
  #line 29 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  y(Integer(2)) = x2->eval();
  #line 30 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  y(Integer(1)) = x1->eval();
  #line 31 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  return y;
}

#line 34 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 34 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 34 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
Distribution<Integer> TestAddDiscreteDelta_::marginal() {
  #line 35 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  return s->getDistribution();
}

#line 38 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 38 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
#line 38 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
Integer TestAddDiscreteDelta_::size() {
  #line 39 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  return Integer(3);
}

#line 1 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
TestAddDiscreteDelta_* make_TestAddDiscreteDelta_() {
  #line 1 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  return new TestAddDiscreteDelta_();
  #line 1 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
}

#line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
int test_conjugacy_add_discrete_delta(int argc_, char** argv_) {
  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  int c_, option_index_;
  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  option long_options_[] = {
    #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    {0, 0, 0, 0}
  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  };
  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  const char* short_options_ = ":";
  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  ::opterr = 0;
  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  while (c_ != -1) {
    #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    switch (c_) {
      #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      case NFLAG_:
        #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        if (!::optarg) {
          #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        }
        #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        N = from_string<Integer>(String(::optarg));
        #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        break;
      #line 44 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      case lazyFLAG_:
        #line 44 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        if (!::optarg) {
          #line 44 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 44 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        }
        #line 44 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 44 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        break;
      #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      case '?':
        #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      case ':':
        #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      default:
        #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  Eigen::initParallel();

  {
    TestAddDiscreteDelta m;
    #line 46 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  libbirch::collect();
  #line 43 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  return 0;
}

#line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
int test_pdf_add_discrete_delta(int argc_, char** argv_) {
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  [[maybe_unused]] Integer B = Integer(0);
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  [[maybe_unused]] Integer S = Integer(0);
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  int c_, option_index_;
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  option long_options_[] = {
    #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    {0, 0, 0, 0}
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  };
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  const char* short_options_ = ":";
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  ::opterr = 0;
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  while (c_ != -1) {
    #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    switch (c_) {
      #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      case NFLAG_:
        #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        if (!::optarg) {
          #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        }
        #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        N = from_string<Integer>(String(::optarg));
        #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        break;
      #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      case BFLAG_:
        #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        if (!::optarg) {
          #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        }
        #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        B = from_string<Integer>(String(::optarg));
        #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        break;
      #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      case SFLAG_:
        #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        if (!::optarg) {
          #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        }
        #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        S = from_string<Integer>(String(::optarg));
        #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        break;
      #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      case lazyFLAG_:
        #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        if (!::optarg) {
          #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        }
        #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 50 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        break;
      #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      case '?':
        #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      case ':':
        #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
      default:
        #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  Eigen::initParallel();

  {
    TestAddDiscreteDelta m;
    #line 52 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    m->initialize();
    #line 53 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    m->simulate();
    #line 54 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
    test_pdf(m->marginal(), N, lazy);
  }
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  libbirch::collect();
  #line 49 "src/test/distribution/scalar_enumerate/TestAddDiscreteDelta.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 1 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
TestLongDiscreteDelta_::TestLongDiscreteDelta_() :
    #line 1 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    base_type_(),
    #line 2 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    x((libbirch::make_shape(Integer(5)))),
    #line 3 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    s() {
  //
}

#line 5 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 5 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 5 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
void TestLongDiscreteDelta_::initialize() {
}

#line 9 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 9 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 9 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
void TestLongDiscreteDelta_::simulate() {
  #line 10 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    handle_assume(x(Integer(1)), Binomial(Integer(10), 0.5));
;
  #line 11 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    handle_assume(x(Integer(2)), Binomial(Integer(10), 0.5));
;
  #line 12 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    handle_assume(x(Integer(3)), Binomial(Integer(10), 0.5));
;
  #line 13 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    handle_assume(x(Integer(4)), Binomial(Integer(10), 0.5));
;
  #line 14 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    handle_assume(x(Integer(5)), Binomial(Integer(10), 0.5));
;
  #line 15 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    handle_assume(s, Delta(-(x(Integer(1))) - (x(Integer(2)) + x(Integer(3))) - (x(Integer(4)) - x(Integer(5)))));
;
}

#line 18 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 18 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 18 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
libbirch::DefaultArray<Real,1> TestLongDiscreteDelta_::forward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(size()));
  #line 20 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(1)) = x(Integer(1))->eval();
  #line 21 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(2)) = x(Integer(2))->eval();
  #line 22 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(3)) = x(Integer(3))->eval();
  #line 23 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(4)) = x(Integer(4))->eval();
  #line 24 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(5)) = x(Integer(5))->eval();
  #line 25 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(6)) = s->eval();
  #line 26 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  return y;
}

#line 29 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 29 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 29 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
libbirch::DefaultArray<Real,1> TestLongDiscreteDelta_::backward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(size()));
  #line 31 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(6)) = s->eval();
  #line 32 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  assert(!(x(Integer(1))->hasValue()));
  #line 33 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  assert(!(x(Integer(2))->hasValue()));
  #line 34 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  assert(!(x(Integer(3))->hasValue()));
  #line 35 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  assert(!(x(Integer(4))->hasValue()));
  #line 36 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  assert(!(x(Integer(5))->hasValue()));
  #line 37 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(5)) = x(Integer(5))->eval();
  #line 38 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(4)) = x(Integer(4))->eval();
  #line 39 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(3)) = x(Integer(3))->eval();
  #line 40 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(2)) = x(Integer(2))->eval();
  #line 41 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  y(Integer(1)) = x(Integer(1))->eval();
  #line 42 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  return y;
}

#line 45 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 45 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 45 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
Distribution<Integer> TestLongDiscreteDelta_::marginal() {
  #line 46 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  return s->getDistribution();
}

#line 49 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 49 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
#line 49 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
Integer TestLongDiscreteDelta_::size() {
  #line 50 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  return Integer(6);
}

#line 1 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
TestLongDiscreteDelta_* make_TestLongDiscreteDelta_() {
  #line 1 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  return new TestLongDiscreteDelta_();
  #line 1 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
}

#line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
int test_conjugacy_long_discrete_delta(int argc_, char** argv_) {
  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  int c_, option_index_;
  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  option long_options_[] = {
    #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    {0, 0, 0, 0}
  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  };
  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  const char* short_options_ = ":";
  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  ::opterr = 0;
  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  while (c_ != -1) {
    #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    switch (c_) {
      #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      case NFLAG_:
        #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        if (!::optarg) {
          #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        }
        #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        N = from_string<Integer>(String(::optarg));
        #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        break;
      #line 55 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      case lazyFLAG_:
        #line 55 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        if (!::optarg) {
          #line 55 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 55 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        }
        #line 55 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 55 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        break;
      #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      case '?':
        #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      case ':':
        #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      default:
        #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  Eigen::initParallel();

  {
    TestLongDiscreteDelta m;
    #line 57 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  libbirch::collect();
  #line 54 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  return 0;
}

#line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
int test_pdf_long_discrete_delta(int argc_, char** argv_) {
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  [[maybe_unused]] Integer B = Integer(0);
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  [[maybe_unused]] Integer S = Integer(0);
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  int c_, option_index_;
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  option long_options_[] = {
    #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    {0, 0, 0, 0}
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  };
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  const char* short_options_ = ":";
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  ::opterr = 0;
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  while (c_ != -1) {
    #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    switch (c_) {
      #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      case NFLAG_:
        #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        if (!::optarg) {
          #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        }
        #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        N = from_string<Integer>(String(::optarg));
        #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        break;
      #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      case BFLAG_:
        #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        if (!::optarg) {
          #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        }
        #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        B = from_string<Integer>(String(::optarg));
        #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        break;
      #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      case SFLAG_:
        #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        if (!::optarg) {
          #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        }
        #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        S = from_string<Integer>(String(::optarg));
        #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        break;
      #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      case lazyFLAG_:
        #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        if (!::optarg) {
          #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        }
        #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 61 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        break;
      #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      case '?':
        #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      case ':':
        #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
      default:
        #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  Eigen::initParallel();

  {
    TestLongDiscreteDelta m;
    #line 63 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    m->initialize();
    #line 64 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    m->simulate();
    #line 65 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
    test_pdf(m->marginal(), N, lazy);
  }
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  libbirch::collect();
  #line 60 "src/test/distribution/scalar_enumerate/TestLongDiscreteDelta.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 1 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
TestNegateDiscreteDelta_::TestNegateDiscreteDelta_() :
    #line 1 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    base_type_(),
    #line 2 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    \u03c1(),
    #line 3 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    x(),
    #line 4 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    y(),
    #line 6 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    \u03b1(),
    #line 7 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    \u03b2(),
    #line 8 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    n() {
  //
}

#line 10 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 10 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 10 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
void TestNegateDiscreteDelta_::initialize() {
  #line 11 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  \u03b1 = simulate_uniform(0.0, 10.0);
  #line 12 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  \u03b2 = simulate_uniform(0.0, 10.0);
  #line 13 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  n = simulate_uniform_int(Integer(1), Integer(100));
}

#line 16 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 16 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 16 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
void TestNegateDiscreteDelta_::simulate() {
  #line 17 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    handle_assume(\u03c1, Beta(\u03b1, \u03b2));
;
  #line 18 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    handle_assume(x, Binomial(n, \u03c1));
;
  #line 19 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    handle_assume(y, Delta(-(x)));
;
}

#line 22 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 22 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 22 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
libbirch::DefaultArray<Real,1> TestNegateDiscreteDelta_::forward() {
  libbirch::DefaultArray<Real,1> z(libbirch::make_shape(size()));
  #line 24 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  z(Integer(1)) = \u03c1->eval();
  #line 25 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  z(Integer(2)) = x->eval();
  #line 26 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  z(Integer(3)) = y->eval();
  #line 27 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  return z;
}

#line 30 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 30 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 30 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
libbirch::DefaultArray<Real,1> TestNegateDiscreteDelta_::backward() {
  libbirch::DefaultArray<Real,1> z(libbirch::make_shape(size()));
  #line 32 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  assert(!(y->hasValue()));
  #line 33 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  z(Integer(3)) = y->eval();
  #line 34 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  assert(!(x->hasValue()));
  #line 35 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  z(Integer(2)) = x->eval();
  #line 36 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  assert(!(\u03c1->hasValue()));
  #line 37 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  z(Integer(1)) = \u03c1->eval();
  #line 38 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  return z;
}

#line 41 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 41 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 41 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
Distribution<Integer> TestNegateDiscreteDelta_::marginal() {
  #line 42 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  return y->getDistribution();
}

#line 45 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 45 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
#line 45 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
Integer TestNegateDiscreteDelta_::size() {
  #line 46 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  return Integer(3);
}

#line 1 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
TestNegateDiscreteDelta_* make_TestNegateDiscreteDelta_() {
  #line 1 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  return new TestNegateDiscreteDelta_();
  #line 1 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
}

#line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
int test_conjugacy_negate_discrete_delta(int argc_, char** argv_) {
  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  int c_, option_index_;
  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  option long_options_[] = {
    #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    {0, 0, 0, 0}
  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  };
  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  const char* short_options_ = ":";
  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  ::opterr = 0;
  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  while (c_ != -1) {
    #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    switch (c_) {
      #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      case NFLAG_:
        #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        if (!::optarg) {
          #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        }
        #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        N = from_string<Integer>(String(::optarg));
        #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        break;
      #line 51 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      case lazyFLAG_:
        #line 51 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        if (!::optarg) {
          #line 51 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 51 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        }
        #line 51 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 51 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        break;
      #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      case '?':
        #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      case ':':
        #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      default:
        #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  Eigen::initParallel();

  {
    TestNegateDiscreteDelta m;
    #line 53 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  libbirch::collect();
  #line 50 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  return 0;
}

#line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
int test_pdf_negate_discrete_delta(int argc_, char** argv_) {
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  [[maybe_unused]] Integer B = Integer(0);
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  [[maybe_unused]] Integer S = Integer(0);
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  int c_, option_index_;
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  option long_options_[] = {
    #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    {0, 0, 0, 0}
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  };
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  const char* short_options_ = ":";
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  ::opterr = 0;
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  while (c_ != -1) {
    #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    switch (c_) {
      #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      case NFLAG_:
        #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        if (!::optarg) {
          #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        }
        #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        N = from_string<Integer>(String(::optarg));
        #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        break;
      #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      case BFLAG_:
        #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        if (!::optarg) {
          #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        }
        #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        B = from_string<Integer>(String(::optarg));
        #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        break;
      #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      case SFLAG_:
        #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        if (!::optarg) {
          #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        }
        #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        S = from_string<Integer>(String(::optarg));
        #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        break;
      #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      case lazyFLAG_:
        #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        if (!::optarg) {
          #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        }
        #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 57 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        break;
      #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      case '?':
        #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      case ':':
        #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
      default:
        #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  Eigen::initParallel();

  {
    TestNegateDiscreteDelta m;
    #line 59 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    m->initialize();
    #line 60 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    m->simulate();
    #line 61 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
    test_pdf(m->marginal(), N, lazy);
  }
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  libbirch::collect();
  #line 56 "src/test/distribution/scalar_enumerate/TestNegateDiscreteDelta.birch"
  return 0;
}

}
namespace birch {
#line 1 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 1 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
TestSubtractDiscreteDelta_::TestSubtractDiscreteDelta_() :
    #line 1 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    base_type_(),
    #line 2 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    x1(),
    #line 3 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    x2(),
    #line 4 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    s() {
  //
}

#line 6 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 6 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 6 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
void TestSubtractDiscreteDelta_::initialize() {
}

#line 10 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 10 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 10 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
void TestSubtractDiscreteDelta_::simulate() {
  #line 11 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    handle_assume(x1, UniformInteger(Integer(1), Integer(100)));
;
  #line 12 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    handle_assume(x2, Binomial(Integer(100), 0.25));
;
  #line 13 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    handle_assume(s, Delta(x1 - x2));
;
}

#line 16 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 16 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 16 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
libbirch::DefaultArray<Real,1> TestSubtractDiscreteDelta_::forward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(size()));
  #line 18 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  y(Integer(1)) = x1->eval();
  #line 19 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  y(Integer(2)) = x2->eval();
  #line 20 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  y(Integer(3)) = s->eval();
  #line 21 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  return y;
}

#line 24 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 24 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 24 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
libbirch::DefaultArray<Real,1> TestSubtractDiscreteDelta_::backward() {
  libbirch::DefaultArray<Real,1> y(libbirch::make_shape(size()));
  #line 26 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  y(Integer(3)) = s->eval();
  #line 27 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  assert(!(x1->hasValue()));
  #line 28 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  assert(!(x2->hasValue()));
  #line 29 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  y(Integer(2)) = x2->eval();
  #line 30 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  y(Integer(1)) = x1->eval();
  #line 31 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  return y;
}

#line 34 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 34 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 34 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
Distribution<Integer> TestSubtractDiscreteDelta_::marginal() {
  #line 35 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  return s->getDistribution();
}

#line 38 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 38 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
#line 38 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
Integer TestSubtractDiscreteDelta_::size() {
  #line 39 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  return Integer(3);
}

#line 1 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
TestSubtractDiscreteDelta_* make_TestSubtractDiscreteDelta_() {
  #line 1 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  return new TestSubtractDiscreteDelta_();
  #line 1 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
}

#line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
int test_conjugacy_subtract_discrete_delta(int argc_, char** argv_) {
  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    lazyFLAG_,
  };
  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  int c_, option_index_;
  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  option long_options_[] = {
    #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    {0, 0, 0, 0}
  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  };
  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  const char* short_options_ = ":";
  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  ::opterr = 0;
  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  while (c_ != -1) {
    #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    switch (c_) {
      #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      case NFLAG_:
        #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        if (!::optarg) {
          #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        }
        #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        N = from_string<Integer>(String(::optarg));
        #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        break;
      #line 44 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      case lazyFLAG_:
        #line 44 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        if (!::optarg) {
          #line 44 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 44 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        }
        #line 44 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 44 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        break;
      #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      case '?':
        #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      case ':':
        #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      default:
        #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  Eigen::initParallel();

  {
    TestSubtractDiscreteDelta m;
    #line 46 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    test_conjugacy(m, N, lazy);
  }
  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  libbirch::collect();
  #line 43 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  return 0;
}

#line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
int test_pdf_subtract_discrete_delta(int argc_, char** argv_) {
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  [[maybe_unused]] Integer N = Integer(10000);
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  [[maybe_unused]] Integer B = Integer(0);
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  [[maybe_unused]] Integer S = Integer(0);
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  [[maybe_unused]] Boolean lazy = false;
  
  enum {
    NFLAG_,
    BFLAG_,
    SFLAG_,
    lazyFLAG_,
  };
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  int c_, option_index_;
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  option long_options_[] = {
    #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    {"B", required_argument, 0, BFLAG_ },
    #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    {"S", required_argument, 0, SFLAG_ },
    #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    {"lazy", required_argument, 0, lazyFLAG_ },
    #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    {0, 0, 0, 0}
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  };
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  const char* short_options_ = ":";
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  ::opterr = 0;
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  while (c_ != -1) {
    #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    switch (c_) {
      #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      case NFLAG_:
        #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        if (!::optarg) {
          #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        }
        #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        N = from_string<Integer>(String(::optarg));
        #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        break;
      #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      case BFLAG_:
        #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        if (!::optarg) {
          #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        }
        #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        B = from_string<Integer>(String(::optarg));
        #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        break;
      #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      case SFLAG_:
        #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        if (!::optarg) {
          #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        }
        #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        S = from_string<Integer>(String(::optarg));
        #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        break;
      #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      case lazyFLAG_:
        #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        if (!::optarg) {
          #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
          error(String("value required for option --") + String(long_options_[::optopt].name));
        #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        }
        #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        lazy = from_string<Boolean>(String(::optarg));
        #line 50 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        break;
      #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      case '?':
        #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        error(String("unrecognized option --") + String(argv_[::optind - 1]));
      #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      case ':':
        #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        error(String("value required for option --") + String(long_options_[::optopt].name));
      #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
      default:
        #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
        error(String("unknown error parsing command-line options."));
    }
    #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  Eigen::initParallel();

  {
    TestSubtractDiscreteDelta m;
    #line 52 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    m->initialize();
    #line 53 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    m->simulate();
    #line 54 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
    test_pdf(m->marginal(), N, lazy);
  }
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  libbirch::collect();
  #line 49 "src/test/distribution/scalar_enumerate/TestSubtractDiscreteDelta.birch"
  return 0;
}

}
