namespace birch {
#line 1 "src/utility/ProgressBar.birch"
#line 1 "src/utility/ProgressBar.birch"
ProgressBar_::ProgressBar_() :
    #line 1 "src/utility/ProgressBar.birch"
    base_type_(),
    #line 8 "src/utility/ProgressBar.birch"
    out(stderr_),
    #line 13 "src/utility/ProgressBar.birch"
    current(-(Integer(1))),
    #line 18 "src/utility/ProgressBar.birch"
    maximum(Integer(80)) {
  //
}

#line 30 "src/utility/ProgressBar.birch"
#line 30 "src/utility/ProgressBar.birch"
#line 30 "src/utility/ProgressBar.birch"
void ProgressBar_::update(const Real& progress) {
  #line 31 "src/utility/ProgressBar.birch"
  assert(0.0 <= progress && progress <= 1.0);
  auto old = current;
  #line 33 "src/utility/ProgressBar.birch"
  current = scalar<Integer>(progress * maximum);
  #line 34 "src/utility/ProgressBar.birch"
  if (current != old) {
    #line 36 "src/utility/ProgressBar.birch"
    out->flush();
    #line 37 "src/utility/ProgressBar.birch"
    if (old >= Integer(0)) {
      #line 39 "src/utility/ProgressBar.birch"
      out->print(String("\033[1A\r"));
    }
    #line 41 "src/utility/ProgressBar.birch"
    for (auto i = Integer(1); i <= current; ++i) {
      #line 42 "src/utility/ProgressBar.birch"
      out->print(String("\u25a0"));
    }
    #line 44 "src/utility/ProgressBar.birch"
    for (auto i = (current + Integer(1)); i <= maximum; ++i) {
      #line 45 "src/utility/ProgressBar.birch"
      out->print(String("\u25a1"));
    }
    #line 47 "src/utility/ProgressBar.birch"
    out->print(String("\n"));
    #line 48 "src/utility/ProgressBar.birch"
    out->flush();
  }
}

#line 1 "src/utility/ProgressBar.birch"
ProgressBar_* make_ProgressBar_() {
  #line 1 "src/utility/ProgressBar.birch"
  return new ProgressBar_();
  #line 1 "src/utility/ProgressBar.birch"
}

}
#line 1 "src/utility/chrono.birch"

#include <chrono>

thread_local static std::chrono::time_point<std::chrono::steady_clock>
    savedTimePoint = std::chrono::steady_clock::now();
namespace birch {
#line 11 "src/utility/chrono.birch"
#line 11 "src/utility/chrono.birch"
void tic() {
  #line 12 "src/utility/chrono.birch"

  savedTimePoint = std::chrono::steady_clock::now();
  }

#line 20 "src/utility/chrono.birch"
#line 20 "src/utility/chrono.birch"
Real toc() {
  Real elapsed;
  #line 22 "src/utility/chrono.birch"

  std::chrono::duration<double> e = std::chrono::steady_clock::now() - savedTimePoint;
  elapsed = e.count();
    #line 26 "src/utility/chrono.birch"
  return elapsed;
}

}
namespace birch {
#line 4 "src/utility/collect.birch"
#line 4 "src/utility/collect.birch"
void collect() {
  #line 5 "src/utility/collect.birch"

  libbirch::collect();
  }

}
namespace birch {
}
namespace birch {
}
namespace birch {
#line 6 "src/utility/error.birch"
#line 6 "src/utility/error.birch"
void error(const String& msg) {
  #line 7 "src/utility/error.birch"
  stderr_->print(String("error: ") + msg + String("\n"));
  #line 8 "src/utility/error.birch"

  std::exit(EXIT_FAILURE);
  }

#line 16 "src/utility/error.birch"
#line 16 "src/utility/error.birch"
void warn(const String& msg) {
  #line 17 "src/utility/error.birch"
  stderr_->print(String("warning: ") + msg + String("\n"));
}

}
namespace birch {
#line 56 "src/utility/make.birch"
#line 56 "src/utility/make.birch"
std::optional<Object> make(const Buffer& buffer) {
  std::optional<Object> result;
  auto className = buffer->get<String>(String("class"));
  #line 59 "src/utility/make.birch"
  if (className.has_value()) {
    #line 60 "src/utility/make.birch"
    result = make<Object>(className.value());
  }
  #line 62 "src/utility/make.birch"
  if (result.has_value()) {
    #line 63 "src/utility/make.birch"
    result.value()->read(buffer);
  }
  #line 65 "src/utility/make.birch"
  return result;
}

}
